var os = require("os"),
fs = require("fs"),
path = require("path"),
http = require("http"),
https = require("https"),
zlib = require("zlib"),
cookie = "",
//cookie = cookie_format("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"),
//user_agent = "okhttp",
user_agent = "com.zhiliaoapp.musically/2022400030 (Linux; U; Android 7.1.2; en_US; SM-G973N; Build/PPR1.190810.011;tt-ok/3.10.0.2)",
//user_agents_random = false,
user_agents_random = true,
help = "node " + path.basename(__filename) + " t=following|follower i=0 [m=\"metadata_file.json\"] [lives=\"metadata_file.json\"] [save_empty] [skip_empty] [v] [r] [max_depth=0] [l=-1] [o=0] [w=200] [c=1] [x] [y] [a] [n=100] [error_delay=1000] [aweme_host=\"*.tiktokv.com\"] [debug] \\"
+ os.EOL + "[cookie=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX] = [j=\"sid_tt=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX; sessionid=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\"] \\"
+ os.EOL + "[min_followed=0] [min_follower=0] \\"
+ os.EOL + "[max_followed=0] [max_follower=0] \\"
+ os.EOL + "[skip_live] [skip_banned] [skip_private] [skip_followed] [skip_follower] \\"
+ os.EOL + "[only_live] [only_banned] [only_private] [only_followed] [only_follower]"
+ os.EOL + "t - following (users user is following)"
+ os.EOL + "    follower (users following user)"
+ os.EOL + "i - id of a user"
+ os.EOL + "m - save metadata to file - if not passed an output file then uses a default construction"
+ os.EOL + "v - unfiltered metadata"
+ os.EOL + "r - reverse order (list sorted oldest>newest)"
+ os.EOL + "l - max number of items to retrieve (integer)"
+ os.EOL + "o - cursor (integer) - unix time in milliseconds"
+ os.EOL + "w - cursor batch size"
+ os.EOL + "c - concurrent requests"
+ os.EOL + "x - log current cursor - if passed a value then also shows time elapsed between cursors"
+ os.EOL + "y - override the limit set by the \"l\" flag to finish the final cursor's batch"
+ os.EOL + "a - abort if trying to fetch followers for an account with >5k (api limit)"
+ os.EOL + "p - if aborted from flag \"a\", save output as [0]"
+ os.EOL + "n - re-attempt requests on server error - takes a max amount of errors before a success to ignore (0 = no limit)"
+ os.EOL + "j - private cookie from \".tiktok.com\""
+ os.EOL
+ os.EOL + "min_followed - filter out users with fewer followed users"
+ os.EOL + "min_follower - filter out users with fewer followers"
+ os.EOL
+ os.EOL + "max_followed - filter out users with more followed users"
+ os.EOL + "max_follower - filter out users with more followers"
+ os.EOL
+ os.EOL + "skip_live - filter out live users"
+ os.EOL + "skip_banned - filter out banned users"
+ os.EOL + "skip_private - filter out private users"
+ os.EOL + "skip_followed - filter out followed users"
+ os.EOL + "skip_follower - filter out follower users"
+ os.EOL
+ os.EOL + "only_live - filter out non live users"
+ os.EOL + "only_banned - filter out non banned users"
+ os.EOL + "only_private - filter out non private users"
+ os.EOL + "only_followed - filter out non followed users"
+ os.EOL + "only_follower - filter out non follower users"
+ os.EOL
+ os.EOL + "lives - save live users' room info to a separate file"
+ os.EOL + "lives_include - add users' room info to the default metadata filter"
+ os.EOL
+ os.EOL + "debug - shows http requests"
+ os.EOL + "cookie - content of the sid_tt/sessionid cookie"
+ os.EOL + "max_depth - max amount of cursors to scrape through"
+ os.EOL + "aweme_host - host to attempt first for api calls"
+ os.EOL + "save_empty - save output files to disk if the contents are empty [default]"
+ os.EOL + "skip_empty - skip saving files to disk if the contents are empty"
+ os.EOL + "error_delay - interval between re-attempts with flag \"n\" (ms)",
example_metadata = {
//	"time_range": "",
	"uid": "",
	"sec_uid": "",
	"unique_id": "",
	"nickname": "",
	"signature": "",
	"region": "",
	"language": "",
	"ins_id": false,
	"twitter_name": false,
	"youtube_channel_id": false,
//	"follow_status": 0,
//	"follower_status": 0,
	"aweme_count": 0,
	"favoriting_count": 0,
	"follower_count": 0,
	"following_count": 0,
	"secret": 0,
	"status": 0,
	"create_time": 0
},
max_depth = 0,
limit = -1,
break_limit = false,
default_cursor = 0,
active_cursor = default_cursor,
active_cursor_count = 0,
active_cursor_requests = [],
cursor_print = false,
cursor_times = false,
count = 200,
max_threads = 1,
ignore_errors = false,
//ignore_errors_delay = 1000,
ignore_errors_delay = 0,
ignore_errors_limit = 100,
ignore_errors_count = 0,
debug = false,
save_empty = true,
abort_on_cap = false,
abort_on_cap_log = false,
skip_min_followed = false,
skip_min_follower = false,
skip_max_followed = false,
skip_max_follower = false,
skip_live = false,
skip_banned = false,
skip_private = false,
skip_followed = false,
skip_follower = false,
only_live = false,
only_banned = false,
only_private = false,
only_followed = false,
only_follower = false,
output_tags = "tiloy",
output_time = Date.now(),
metadata = [],
metadata_file,
metadata_save = true,
metadata_reverse = false,
metadata_verbose = false,
metadata_save_obj = false,
metadata_update_obj = false,
metadata_obj,
metadata_obj_file,
metadata_obj_initial,
hash_string,
lives = [],
lives_file,
lives_save = false,
lives_include = false,
scrape_type = "following",
running = true,
timeout = null,
idRegex = /^[1-9][0-9]{0,19}$/,
request_aweme_iid = false,
request_aweme_sign = false,
request_aweme_sign_func,

aweme_hosts = [
	"api22-normal-c-alisg.tiktokv.com",
	"api22-normal-c-useast2a.tiktokv.com",
	"api22-normal-n-alisg.tiktokv.com",
	"api22-normal-v4.tiktokv.com",
	"api22-quic.tiktokv.com",
	"api77-normal-c-alisg.tiktokv.com"
],

aweme_app = {
	region: "US",

	version_name: "27.3.3",
	version_code: "270303",
	manifest_version_code: "2022703030",

//	os_api: "19",
	os_version: "10",
//	os_api: "33",
//	os_version: "13",

//	aid: 1180,
	aid: 1233,

	iid: "",
	device_id: "6006859028954454735",

	device_version: generateBase62(8)
};
function generateBase62(length) {
	var i = 0, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	while (i < length) {
		r += base62.charAt(Math.floor(Math.random() * 62));
		i++;
	}
	return r;
}
function generateDeviceId() {
	var i = 1, a = new Array(19);//Math.floor(Math.random() * 9) + 11
	a[0] = 54;//Math.floor(Math.random() * 9) + 49
	while (i < a.length) {
		a[i++] = Math.floor(Math.random() * 10) + 48;
	}
	return String.fromCharCode.apply(null, a);
}
function generateVerify() {
	var i = 0, d = new Date(), t = d.getTime() - d.getTimezoneOffset() * 60000, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	do {
		switch (i) {
			case 8:
			case 13:
			case 18:
			case 23:
				r += "_";
				break;
			case 14:
				r += "4";
				break;
			default:
				r += base62.charAt(Math.floor(Math.random() * 62));
				break;
		}
		i++;
	} while (i < 36);
	return "verify_" + t.toString(36) + "_" + r;
}
function generateCookie() {
	return [
		cookie || cookie_format(""),
		"tt_webid=" + aweme_app.device_id,
		"tt_webid_v2=" + aweme_app.device_id,
		"tt_csrf_token=" + generateBase62(24),
		"s_v_web_id=" + generateVerify()
	].join("; ");
}
function parseArgv(arguments) {
	var i = 2, e, r = {};
	while (i < arguments.length) {
		e = arguments[i].indexOf("=");
		if (e === -1) {
			r[arguments[i]] = "";
		} else {
			r[arguments[i].substring(0, e)] = arguments[i].substring(e + 1);
		}
		i++;
	}
	return r;
}
function random_user_agent() {
	return "com.zhiliaoapp.musically/" + Math.random().toString().substr(2,10) + " (Linux; U; Android 7.1.2; en_US; SM-G973N; Build/PPR1.190810.011;tt-ok/3.10.0.2)";
}
function requestGet(uri, headers, callback) {
	try {
		var u = typeof uri === "string" ? new URL(uri) : uri, h, r;
		if (u.protocol === "http:") {
			h = http;
		} else if (u.protocol === "https:") {
			h = https;
		} else {
			process.nextTick(callback, new Error("Only http and https is supported."));
			return;
		}
		if (debug) console.log("http/get: " + String(uri));
		r = h.request({
			method: "GET",
			host: u.host,
			port: +u.port || 0,
			path: u.pathname + u.search,//+ u.hash
			timeout: 10000,
			headers: {
				"Cookie": generateCookie(),
				"User-Agent": user_agents_random ? random_user_agent() : user_agent,
				...headers
			}
		}, function(response) {
			if (callback === null) {
				return;
			}
			if (debug) console.log("http/"
				+ response.statusCode
				+ (response.headers["content-encoding"] !== undefined ? "=" + response.headers["content-encoding"] : "")
				+ (+response.headers["content-length"] ? " (" + response.headers["content-length"] + " bytes)" : "")
				+ ": " + String(uri)
				+ (response.headers["location"] !== undefined ? " => " + response.headers["location"] : ""));
			if (response.statusCode >= 300 && response.statusCode < 400) {
				var l = response.headers["location"];
				if (l === undefined) {
					callback(new Error("Redirection without location."));
					callback = null;
				} else {
					try {
						requestGet(new URL(l, String(uri)), headers, callback);
					} catch (e) {
						callback(e);
						callback = null;
					}
				}
				return;
			}
			if (response.statusCode !== 200) {
				callback(new Error(response.statusMessage));
				callback = null;
				return;
			}
			callback(null, response, r, String(uri));
			callback = null;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("timeout", function() {
			r.destroy();
			if (debug) console.log("timed_out: " + String(uri));
		}).end();
		active_cursor_requests.push(r);
	} catch (e) {
		process.nextTick(callback, e);
		return;
	}
}
function content_decoder(encoding) {
	switch(encoding) {
		case "gzip":
			return zlib.createGunzip();
		case "deflate":
			return zlib.createInflate();
		case "br":
			return zlib.BrotliDecompress();
		default:
			return null;
	}
}
function requestGetJson(uri, headers, callback) {
	requestGet(uri, {
		...headers,
		"Accept-Encoding": "gzip, deflate, br"
	}, function(error, response, request) {
		if (error !== null) {
			callback(error);
			return;
		}
		var data_stream, d = "";
		if ((data_stream = content_decoder(response.headers["content-encoding"]))) {
			response.pipe(data_stream);
		} else {
			data_stream = response;
		}
		data_stream.setEncoding("utf8");
		data_stream.on("data", function(data) {
			d += data;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("end", function() {
			if (callback === null) {
				return;
			}
			if (d.length === 0) {
				callback(new Error("Empty response."));
				return;
			}
			try {
				var d2 = d.replace(/([\[:])?(?<![\d.]|\\".)(\d{15,})([,\}\]])/g, "$1\"$2\"$3"); // rancid
				callback(null, JSON.parse(d2));
			} catch (e) {
				try {
					callback(null, JSON.parse(d));
//					console.error(new Error("RegEx for preserving big numbers failed"));
//					fs.writeFileSync("/" + path.basename(__filename) + "_" + output_time + "_pass.json", d);
//					fs.writeFileSync("/" + path.basename(__filename) + "_" + output_time + "_fail.json", d2);
				} catch (e) {
					callback(e);
				}
			}
			callback = null;
		});
	});
}
function requestAweme(uri, thread_cursor, callback) {
	var f = function(error, repeat) {
		if (thread_cursor !== active_cursor || repeat > (aweme_hosts.length*5) || !running) {
			callback(error !== null ? error : new Error("Exited unexpectedly."), thread_cursor);
			return;
		}

		var h = aweme_hosts[repeat % aweme_hosts.length],
		d = new Date(),
		t = d.getTime() - d.getTimezoneOffset() * 60000,
		ts = Math.floor(t / 1000),
		uri_full = "https://" + h + uri
		+ "&address_book_access=1"

		+ "&ac=wifi"
		+ "&ac2=wifi"
		+ "&app_language=en"
		+ "&app_name=musical_ly"
		+ "&app_type=normal"
		+ "&channel=googleplay"
		+ "&cpu_support64=false"
		+ "&device_brand=google"
		+ "&device_platform=android"
		+ "&dpi=441"
		+ "&language=en"
		+ "&locale=en"
		+ "&pass-region=1"
		+ "&pass-route=1"
		+ "&resolution=1080*1920"
		+ "&ssmix=a"
		+ "&timezone_name=Etc%2FGMT"
		+ "&timezone_offset=0"
		+ "&uoo=0"

//		+ "&carrier_region_v2="
//		+ "&cdid="
//		+ "&host_abi="
//		+ "&mcc_mnc="
//		+ "&openudid="

		+ "&carrier_region=" + aweme_app.region
		+ "&current_region=" + aweme_app.region
		+ "&op_region=" + aweme_app.region
		+ "&region=" + aweme_app.region
		+ "&sys_region=" + aweme_app.region

		+ "&manifest_version_code=" + aweme_app.manifest_version_code
		+ "&update_version_code=" + aweme_app.manifest_version_code
		+ "&version_code=" + aweme_app.version_code

		+ "&ab_version=" + aweme_app.version_name
		+ "&build_number=" + aweme_app.version_name
		+ "&version_name=" + aweme_app.version_name

//		+ "&os_api=" + aweme_app.os_api
		+ "&os_version=" + aweme_app.os_version

		+ "&aid=" + aweme_app.aid
//		+ "&iid=" + aweme_app.iid
		+ (request_aweme_iid ? "&iid=" + (aweme_app.iid || generateDeviceId()) : "")
		+ "&device_id=" + aweme_app.device_id
		+ "&device_type=Pixel%20" + aweme_app.device_version

		+ "&_rticket=" + t
		+ "&ts=" + ts;

		requestGetJson(uri_full, request_aweme_sign ? request_aweme_sign_func(path.basename(uri_full).substring(1), ts, generateCookie()) : {}, function(error, data) {
			if (error === null) {
				if (typeof data !== "object" || data === null || typeof data.status_code !== "number") {
					error = new Error("Unexpected response.");
				} else if (![
					0, // success
					9, // account suspended
					204, // account suspended
					2096, // private list
					3170, // invalid user
					3002060 // hiding list
				].includes(data.status_code)) {
					error = awemeError(data);
				}
			}
			if (error !== null) {
				aweme_app.device_version = generateBase62(8);
				f(error, repeat + 1);
			} else {
				if (aweme_hosts.indexOf(h) > 0) {
					aweme_hosts.splice(aweme_hosts.indexOf(h), 1);
					aweme_hosts.unshift(h);
				}
				callback(null, thread_cursor, data);
			}
		});
	};
	f(null, 0);
}
function awemeError(data) {
	var status_message = [data.status_msg, data.data?.message].find(v => typeof v === "string" && v.length > 0);
	return new Error(data.status_code + (status_message ? " (" + status_message + ")" : ""));
}
function scrape_follows(uid) {
	var y = 0, m = true, n, total_count, cursor_printed, cursor_start, cursor_end, delay = 0, depth = 0, f0 = function() {
		if (running) {
			if (m) {
				m = false;
				print_cursor();
				for (var i = 0; active_cursor_count < max_threads; i++) {
					active_cursor_count++;
					setTimeout(requestAweme, delay+i*25, "/aweme/v1/user/" + scrape_type + "/list/"
					+ "?user_id=" + uid
					+ "&max_time=" + active_cursor
					+ "&count=" + count
					+ "&offset=0"
					+ "&source_type=1", active_cursor, f1);
				}
			} else {
				print_cursor();
				active_cursor = null;
				f2();
				if (metadata_save) metadata_save_to_file();
				if (metadata_save_obj) metadata_save_obj_to_file();
				if (lives_save) lives_save_to_file();
			}
		}
	}, print_cursor = function() {
		if (cursor_print && cursor_printed !== String([active_cursor,y])) {
			cursor_printed = String([active_cursor,y]);
			console.log("cursor: " + active_cursor + (active_cursor !== default_cursor
			? " (" + (new Date(+active_cursor*1000)).toISOString() + ")"
			+ " [" + (count*depth) + "=" + count + "*" + depth + (max_depth ? "/" + max_depth : "") + "]"
			+ (total_count !== undefined ? " / " + total_count : "")
			: ""));
			console.log("item count: " + y + (limit > 0 ? "/" + limit + (break_limit ? "+" : "") : ""));
			if (cursor_times) {
				cursor_end = Date.now();
				if (active_cursor !== default_cursor) console.log("duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f1 = function(error, thread_cursor, data) {
		if (thread_cursor !== active_cursor) {
//			console.log("ignoring: " + thread_cursor);
			return;
		} else if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				delay = ignore_errors_delay;
				m = true;
				if (ignore_errors_count % max_threads === 0) console.error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			} else {
				console.error(error);
			}
		} else if (data.status_code !== 0) { // success
			console.error(awemeError(data));
		} else if (typeof data !== "object" || data === null
		|| typeof data.min_time !== "number"
		|| typeof data.has_more !== "boolean") {
			console.error(new Error("Unexpected response."));
			console.error(data);
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				delay = ignore_errors_delay;
				m = true;
				console.error("ignoring: " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			}
		} else {
			if (active_cursor === default_cursor) {
				total_count = data.total;
				if (abort_on_cap && total_count > 5000) {
					m = false;
					if (abort_on_cap_log) metadata = [0];
					f0();
					return;
				}
			}
//			var time_range = (new Date(+data.min_time*1000)).toISOString() + " > " + (new Date(+active_cursor*1000)).toISOString();
			delay = 0;
			n = data.has_more;
			active_cursor = data.min_time;
			ignore_errors_count = 0;
			if (++depth === max_depth) {
				n = false;
			}
			var detail = data[scrape_type + "s"];
			if (typeof detail === "object" && detail !== null) {
				for (var j = 0; j < detail.length; j++) {
					if (typeof detail[j] === "object" && detail[j] !== null) {

						var v = detail[j],
						is_x = k => v[k] !== undefined && v[k] !== 0,
						is_live = is_x("room_id"),
						is_banned = !is_x("status"),
						is_private = is_x("secret"),
						is_followed = is_x("follow_status"),
						is_follower = is_x("follower_status");

						if (skip_min_followed && skip_min_followed > v.following_count) continue;
						if (skip_min_follower && skip_min_follower > v.follower_count) continue;

						if (skip_max_followed && skip_max_followed < v.following_count) continue;
						if (skip_max_follower && skip_max_follower < v.follower_count) continue;

						if (skip_live && is_live) continue;
						if (skip_banned && is_banned) continue;
						if (skip_private && is_private) continue;
						if (skip_followed && is_followed) continue;
						if (skip_follower && is_follower) continue;

						if (only_live && !is_live) continue;
						if (only_banned && !is_banned) continue;
						if (only_private && !is_private) continue;
						if (only_followed && !is_followed) continue;
						if (only_follower && !is_follower) continue;

//						v.time_range = time_range;

						if (metadata_save || metadata_save_obj) {
							var user_metadata = metadata_verbose ? v : obj_filter(v, example_metadata);
							if (metadata_save) metadata.push(user_metadata);
							if (metadata_save_obj && (metadata_update_obj || !metadata_obj.hasOwnProperty(v.uid))) metadata_obj[v.uid] = user_metadata;
						}
						if (lives_save && is_live) lives.push(v.room_data);

						if (++y === limit) {
							n = false;
							if (!break_limit) break;
						}
					}
				}
			}
			f2();
			m = n;
		}
		active_cursor_count--;
		f0();
	}, f2 = function() {
		for (var j = 0; j < active_cursor_requests.length; j++) {
			active_cursor_requests[j].destroy();
		}
		active_cursor_count = 1;
		active_cursor_requests = [];
	};
	f0();
}
function obj_filter(obj_in, obj_match) {
	var obj_out = {};
	for (var [key, value] of Object.entries(obj_in)) {
		if (obj_match.hasOwnProperty(key)) {
			if (typeof value === "object") {
				obj_out[key] = obj_filter(value, obj_match[key]);
			} else if (obj_match[key] !== false || value.length > 0) {
				obj_out[key] = value;
			}
		}
	}
	return obj_out;
}
function sanitizeFilename(value) {
	return value.replace(/[\x00-\x1f"*/:<>?\\|]/g, "");
}
function createTimeToFilename(value) {
	var t = (new Date(value * 1000)).toISOString();
	return t.substring(0, t.length === 24 ? 19 : 22).replace(/[-:]/g, "") + "Z";
}
function output_file_name(a, tag="", params=true) {
	var obj_out = [];
//	obj_out.push(path.basename(__filename, path.extname(__filename)));
	obj_out.push(path.basename(__filename));
	obj_out.push(createTimeToFilename(output_time/1000));
	if (params) {
		output_tags.split("").forEach(function(value) {
			if (a[value] !== undefined) {
				if (a[value] === "") {
					obj_out.push(value);
				} else {
					obj_out.push([value,sanitizeFilename(a[value])].join("="));
				}
			}
		});
	}
	if (tag.length > 0) obj_out.push(tag);
	return obj_out.join("_") + ".json";
}
function writeFile(file, str, callback) {
	fs.writeFile(file, str, function(error) {
		if (error !== null) {
			console.error(error);
		} else {
			callback();
		}
	});
}
function metadata_save_to_file() {
	if (save_empty || metadata.length > 0) {
		writeFile(metadata_file, JSON.stringify(metadata_reverse ? metadata.reverse() : metadata), function() {
			console.log("output file: " + metadata_file);
			console.log("item count: " + metadata.length);
		});
	}
}
function metadata_save_obj_to_file() {
	var len = Object.keys(metadata_obj).length;
	if (save_empty || len > 0) {
		var v = JSON.stringify(metadata_obj);
		if (metadata_obj_initial === hash_string(v)) return;
		writeFile(metadata_obj_file, v, function() {
			console.log("output file: " + metadata_obj_file);
			console.log("item count: " + len);
		});
	}
}
function lives_save_to_file() {
	if (save_empty || lives.length > 0) {
		writeFile(lives_file, "[" + (metadata_reverse ? lives.reverse() : lives).join(", ") + "]", function() {
			console.log("output file: " + lives_file);
			console.log("item count: " + lives.length);
		});
	}
}
process.on("SIGINT", function() {
	running = false;
	if (timeout !== null) {
		clearTimeout(timeout);
		timeout = null;
	}
});
(function() {
	var i, a = parseArgv(process.argv);

	if (a.t !== undefined) scrape_type = a.t.toLowerCase();
	if (!["following","follower"].includes(scrape_type) || !a.i || !idRegex.test(a.i)) {
		console.log(help);
		return;
	}

	if (!isNaN(i = BoundInt(a.o))) default_cursor = i;
	if (default_cursor === 0) default_cursor = Math.floor(Date.now() / 1000);
	active_cursor = default_cursor;

	if (a.cookie !== undefined) cookie = cookie_format(a.cookie);
	if (a.j !== undefined) cookie = a.j;

	if (a.u !== undefined) user_agent = a.u;
	if (a.ur !== undefined) user_agents_random = true;

	if (!isNaN(i = BoundInt(a.l))) limit = i;
	if (!isNaN(i = BoundInt(a.w, 1, 200))) count = i;
	if (!isNaN(i = BoundInt(a.n))) ignore_errors_limit = i;
	if (!isNaN(i = BoundInt(a.error_delay))) ignore_errors_delay = i;
	if (!isNaN(i = BoundInt(a.max_depth))) max_depth = i;
	if (!isNaN(i = BoundInt(a.c, 1, 100))) max_threads = i;
	if (!isNaN(i = BoundInt(a.min_followed))) skip_min_followed = i;
	if (!isNaN(i = BoundInt(a.min_follower))) skip_min_follower = i;
	if (!isNaN(i = BoundInt(a.max_followed))) skip_max_followed = i;
	if (!isNaN(i = BoundInt(a.max_follower))) skip_max_follower = i;

	if (a.x !== undefined) cursor_print = true;
	if (a.x !== undefined && a.x.length > 0) cursor_times = true;
	if (a.y !== undefined) break_limit = true;
	if (a.n !== undefined) ignore_errors = true;
	if (a.a !== undefined && scrape_type === "follower") abort_on_cap = true;
	if (a.p !== undefined) abort_on_cap_log = true;
	if (a.debug !== undefined) debug = true;

	if (a.skip_live !== undefined) skip_live = true;
	if (a.skip_banned !== undefined) skip_banned = true;
	if (a.skip_private !== undefined) skip_private = true;
	if (a.skip_followed !== undefined) skip_followed = true;
	if (a.skip_follower !== undefined) skip_follower = true;

	if (a.only_live !== undefined) only_live = true;
	if (a.only_banned !== undefined) only_banned = true;
	if (a.only_private !== undefined) only_private = true;
	if (a.only_followed !== undefined) only_followed = true;
	if (a.only_follower !== undefined) only_follower = true;

	if (a.save_empty !== undefined) save_empty = true;
	if (a.skip_empty !== undefined) save_empty = false;

	if (a.lives !== undefined) metadata_save = false;
	if (a.mo !== undefined) metadata_save = false;
	if (a.m !== undefined) metadata_save = true;
	if (a.r !== undefined) metadata_reverse = true;
	if (a.v !== undefined) metadata_verbose = true;
	if (metadata_save) metadata_file = a.m !== undefined && a.m.length > 0 ? a.m : output_file_name(a);

	if (a.lives !== undefined) lives_save = true;
	if (lives_save) lives_file = a.lives !== undefined && a.lives.length > 0 ? a.lives : output_file_name(a, "lives");

	if (a.lives_include !== undefined) lives_include = true;
	if (lives_include) {
		example_metadata.room_id = 0;
		example_metadata.room_data = false;
	}

	if (a.mo !== undefined) metadata_save_obj = true;
	if (a.mu !== undefined) metadata_update_obj = true;

	if (metadata_save_obj) {
		if (a.mo !== undefined && a.mo.length > 0) {
			metadata_obj_file = a.mo;
		} else {
			metadata_obj_file = "@" + a.i + "_" + scrape_type + ".json";
		}
		try {
			var crypto = require("crypto");
			hash_string = v => crypto.createHash("md5").update(v).digest("hex");
		} catch (e) {
			metadata_save_obj = false;
		}
		if (metadata_save_obj) {
			try {
				var metadata_str = fs.readFileSync(metadata_obj_file, "utf8");
				metadata_obj = JSON.parse(metadata_str);
				metadata_obj_initial = hash_string(metadata_str);
			} catch (e) {
				metadata_obj = {};
			}
		}
	}

	if (a.aweme_host !== undefined && a.aweme_host.length > 0) {
		var api_pos = aweme_hosts.indexOf(a.aweme_host);
		if (api_pos > 0) aweme_hosts.splice(api_pos, 1);
		if (api_pos !== 0) aweme_hosts.unshift(a.aweme_host);
	}

	if (a.iid !== undefined || a.request_aweme_iid !== undefined) request_aweme_iid = true;
	if (a.sign !== undefined || a.request_aweme_sign !== undefined) request_aweme_sign = true;

	if (scrape_type === "follower") request_aweme_iid = true;
	if (scrape_type === "following") request_aweme_sign = true;

	Object.keys(aweme_app)
	.filter(v => a[v] !== undefined && a[v].length > 0)
	.forEach(v => aweme_app[v] = a[v]);

	if (request_aweme_sign) {
		request_aweme_sign_func = (require("./aweme")).gorgonSign;

//		aweme_host = "api16-normal-useast5.us.tiktokv.com";

//		aweme_app.version_name = "19.3.3";
//		aweme_app.version_code = "190303";
//		aweme_app.manifest_version_code = "2021903030";

	}

	scrape_follows(a.i);
})();
function BoundInt(n, min=0, max=undefined) {
	var i = parseInt(n, 10);
	if (!isNaN(i) && typeof min === "number" && i < min) return min;
	if (!isNaN(i) && typeof max === "number" && i > max) return max;
	return i;
}
function cookie_format(cookie) {
	return ["sid_tt", "sessionid", "sessionid_ss"].map(v => v + "=" + cookie).join("; ");
}