//"https://www.tiktok.com/@*",
//"https://www.tiktok.com/music/*",
//"https://www.tiktok.com/tag/*",
//"https://www.tiktok.com/@*/video/*",
//"https://www.tiktok.com/*",
//"https://www.tiktok.com/foryou*",
//"https://www.tiktok.com/trending*",
//"https://www.tiktok.com/discover*"
var state = {
	active: false,
	type: "",
	key: "",
	//data: null,
	id: null,
	current: 0,
	last: 0,
	muted: false,
	volume: 1,
	rate: 1,
	flip: false,
	rotate: 1,
	transform: false,
	quality: false,
	style: null,
	target: null,
	browser: null,
	share: null,
	info: null,
	video: null,
	items: null,
	reloader: null,
	viewer: null,
	observer: null,
	sharer: null,
	request: null,
	did: "",
	iid: "",
	dver: "",
	generateDeviceId: function() {
		var i = 1, a = new Array(19);//Math.floor(Math.random() * 9) + 11
		a[0] = 54;//Math.floor(Math.random() * 9) + 49
		while (i < a.length) {
			a[i++] = Math.floor(Math.random() * 10) + 48;
		}
		return String.fromCharCode.apply(null, a);
	},
	generateBase62: function(length) {
		var i = 0, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
		while (i < length) {
			r += base62.charAt(Math.floor(Math.random() * 62));
			i++;
		}
		return r;
	},
	randomizeDevice: function() {
		state.did = state.generateDeviceId();
		state.iid = state.generateDeviceId();
		state.dver = state.generateBase62(8);
	},
	requestAweme: function(path, callback) {
		var d = new Date(), t = d.getTime() - d.getTimezoneOffset() * 60000, r = new XMLHttpRequest();
		r.onreadystatechange = function() {
			if (this.readyState < 4) {
				return;
			} else if (this.status !== 200) {
				state.randomizeDevice();
				callback.call(this, new Error(this.statusText));
				return;
			}
			try {
				callback.call(this, null, JSON.parse(this.responseText));
			} catch (e) {
				state.randomizeDevice();
				callback.call(this, e);
			}
		};
		r.open("GET", "https://api-t2.tiktokv.com" + path
		+ "&region=US"
		//+ "&version_name=10.0.0"
		+ "&ts=" + Math.floor(t / 1000)
		+ "&timezone_name=Etc%2FGMT"
		+ "&device_type=Pixel%20" + state.dver
		+ "&iid=" + state.iid
		+ "&locale=en"
		+ "&app_type=normal"
		//+ "&build_number=10.0.0"
		+ "&resolution=1080*1920"
		+ "&aid=1180"
		+ "&app_name=musical_ly"
		+ "&_rticket=" + t
		+ "&device_platform=android"
		+ "&version_code=100000"
		+ "&dpi=441"
		+ "&cpu_support64=false"
		+ "&sys_region=US"
		+ "&timezone_offset=0"
		+ "&device_id=" + state.did
		+ "&pass-route=1"
		+ "&device_brand=google"
		+ "&os_version=8.0.0"
		//+ "&ab_version=10.0.0"
		+ "&op_region=US"
		+ "&app_language=en"
		+ "&pass-region=1"
		+ "&language=en"
		+ "&channel=googleplay");
		r.send();
		return r;
	},
	requestVideoDetail: function(id, callback) {
		return state.requestAweme("/aweme/v1/aweme/detail/?aweme_id=" + id, callback);
	},
	requestVideosDetail: function(ids, callback) {
		return state.requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + (typeof ids === "string" ? ids : ids.join()) + "]", callback);
	},
	generateSign: function(url) {
		return window.byted_acrawler ? window.byted_acrawler.sign({url: encodeURI(url)}) : "";
	},
	signUrl: function(url) {
		return url + "&_signature=" + state.generateSign(url);
	},
	requestTiktok: function(path, sign, callback) {
		var r = new XMLHttpRequest();
		r.onreadystatechange = function() {
			if (this.readyState < 4) {
				return;
			} else if (this.status !== 200) {
				callback.call(this, new Error(this.statusText));
				return;
			}
			try {
				callback.call(this, null, JSON.parse(this.responseText));
			} catch (e) {
				callback.call(this, e);
			}
		};
		r.open("GET", sign ? state.signUrl("https://m.tiktok.com" + path + "&aid=1988&appId=1233&appType=m&app_name=tiktok_web&device_platform=web&language=en") : "https://www.tiktok.com" + path);
		r.send();
		return r;
	},
	requestRaw: function(url, callback) {
		var r = new XMLHttpRequest();
		r.onreadystatechange = function() {
			if (this.readyState < 4) {
				return;
			} else if (this.status !== 200 && (this.status < 300 || this.status >= 400)) {
				callback.call(this, new Error(this.statusText));
				return;
			}
			callback.call(this, null);
		};
		r.open("GET", url);
		r.send();
		return r;
	},
	requestUserNode: function(username, callback) {
		return state.requestTiktok("/node/share/user/@" + encodeURI(username) + "?user_agent=", false, callback);
	},
	requestMusicNode: function(id, callback) {
		return state.requestTiktok("/node/share/music/_-" + id + "?user_agent=", false, callback);
	},
	requestChallengeNode: function(tag, callback) {
		return state.requestTiktok("/node/share/tag/" + encodeURI(tag) + "?user_agent=", false, callback);
	},
	requestVideoNode: function(id, callback) {
		return state.requestTiktok("/node/share/video/@_/" + id + "?user_agent=", false, callback);
	},
	requestDiscoverNode: function(callback) {
		return state.requestTiktok("/node/share/discover?user_agent=", false, callback);
	},
	requestUserVideosNode: function(id, cursor, callback) {
		return state.requestTiktok("/node/video/feed"
		+ "?secUid="
		+ "&id=" + id
		+ "&type=1"
		+ "&count=30"
		+ "&minCursor=0"
		+ "&maxCursor=" + cursor
		+ "&shareUid="
		+ "&lang=en", false, callback);
	},
	requestMusicVideosNode: function(id, cursor, callback) {
		return state.requestTiktok("/node/video/feed"
		+ "?secUid="
		+ "&id=" + id
		+ "&type=4"
		+ "&count=30"
		+ "&minCursor=0"
		+ "&maxCursor=" + cursor
		+ "&shareUid="
		+ "&lang=en", false, callback);
	},
	requestChallengeVideosNode: function(id, cursor, callback) {
		return state.requestTiktok("/node/video/feed"
		+ "?secUid="
		+ "&id=" + id
		+ "&type=3"
		+ "&count=30"
		+ "&minCursor=0"
		+ "&maxCursor=" + cursor
		+ "&shareUid="
		+ "&lang=en", false, callback);
	},
	requestSearch: function(keyword, callback) {
		return state.requestTiktok("/discover/render/" + encodeURI(keyword), false, callback);
	},
	requestUserSearch: function(keyword, cursor, callback) {
		return state.requestTiktok("/api/discover/user/?discoverType=1&needItemList=false&useRecommend=false&keyWord=" + encodeURIComponent(keyword) + "&offset=" + cursor + "&count=20", true, callback);
	},
	requestMusicSearch: function(keyword, cursor, callback) {
		return state.requestTiktok("/api/discover/music/?discoverType=1&needItemList=false&useRecommend=false&keyWord=" + encodeURIComponent(keyword) + "&offset=" + cursor + "&count=20", true, callback);
	},
	requestChallengeSearch: function(keyword, cursor, callback) {
		return state.requestTiktok("/api/discover/challenge/?discoverType=1&needItemList=false&useRecommend=false&keyWord=" + encodeURIComponent(keyword) + "&offset=" + cursor + "&count=20", true, callback);
	},
	requestUserInfo: function(id, callback) {
		return state.requestTiktok("/api/user/detail/?userId=" + id, true, callback);
	},
	requestUserInfoByUsername: function(username, callback) {
		return state.requestTiktok("/api/user/detail/?uniqueId=" + encodeURIComponent(username), true, callback);
	},
	requestMusicInfo: function(id, callback) {
		return state.requestTiktok("/api/music/detail/?musicId=" + id, true, callback);
	},
	requestChallengeInfo: function(id, callback) {
		return state.requestTiktok("/api/challenge/detail/?challengeId=" + id, true, callback);
	},
	requestChallengeInfoByTag: function(tag, callback) {
		return state.requestTiktok("/api/challenge/detail/?challengeName=" + encodeURIComponent(tag), true, callback);
	},
	requestVideoInfo: function(id, callback) {
		return state.requestTiktok("/api/item/detail/?itemId=" + id, true, callback);
	},
	requestUserVideos: function(id, cursor, callback) {
		return state.requestTiktok("/api/item_list/"
		+ "?secUid="
		+ "&id=" + id
		+ "&type=1"
		+ "&sourceType=8"
		+ "&count=30"
		+ "&minCursor=0"
		+ "&maxCursor=" + cursor, true, callback);
	},
	requestUserFavorites: function(id, cursor, callback) {
		return state.requestTiktok("/api/item_list/"
		+ "?secUid="
		+ "&id=" + id
		+ "&type=2"
		+ "&sourceType=9"
		+ "&count=30"
		+ "&minCursor=0"
		+ "&maxCursor=" + cursor, true, callback);
	},
	requestMusicVideos: function(id, cursor, callback) {
		return state.requestTiktok("/api/music/item_list/"
		+ "?musicID=" + id
		+ "&count=30"
		+ "&cursor=" + cursor, true, callback);
	},
	requestChallengeVideos: function(id, cursor, callback) {
		return state.requestTiktok("/api/challenge/item_list/"
		+ "?challengeID=" + id
		+ "&count=30"
		+ "&cursor=" + cursor, true, callback);
	}
};
(function() {
	var keys = {
		Backspace: 8,
		Pause: 19,
		Escape: 27,
		Space: 32,
		PageUp: 33,
		PageDown: 34,
		ArrowLeft: 37,
		ArrowRight: 39,
		Insert: 45,
		Delete: 46,
		KeyA: 65,
		KeyD: 68,
		KeyE: 69,
		KeyI: 73,
		KeyJ: 74,
		KeyK: 75,
		KeyL: 76,
		KeyO: 79,
		KeyP: 80,
		KeyQ: 81,
		KeyR: 82,
		KeyS: 83,
		KeyU: 85,
		KeyW: 87,
		KeyX: 88,
		KeyZ: 90,
		Comma: 188,
		Period: 190
	}, rotate = ["-90", "0", "90", "180"];
	function getQualityUri(value) {
		var i = value.indexOf("?video_id="), e;
		if (i > -1 && (e = value.indexOf("&", i + 10)) > -1) {
			return "https://api-h2.tiktokv.com/aweme/v1/play/" + value.substring(i, e) + "&improve_bitrate=1&ratio=default";
		}
		return value;
	}
	function createTimeToString(value) {
		var t = (new Date(value * 1000)).toISOString();
		return t.length === 24 ? t.substring(0, 10) + " " + t.substring(11, 19) : t.substring(0, 13) + " " + t.substring(14, 22);
	}
	function emptyElement(element) {
		while (element.lastChild !== null) {
			element.removeChild(element.lastChild);
		}
	}
	function preventDefault(event) {
		event.preventDefault();
	}
	function stopPropagation(event) {
		event.stopPropagation();
	}
	function keydownHandler(event) {
		var k = event.which || event.keyCode || keys[event.code] || 0;
		switch (k) {
			case 32:
			case 37:
			case 39:
				event.stopPropagation();
				break;
		}
	}
	function volumeHandler(event) {
		state.muted = event.currentTarget.muted;
		localStorage.setItem("awemer-volume", String(state.volume = event.currentTarget.volume));
	}
	function updateTransform() {
		var t = state.flip ? "scaleX(-1)" : "";
		switch (state.rotate) {
			case 0:
				t += "rotate(-90deg)";
				state.video.style.maxWidth = state.video.parentNode.clientHeight > state.video.videoWidth ? "none" : state.video.parentNode.clientHeight + "px";
				state.video.style.maxHeight = state.video.parentNode.clientWidth > state.video.videoHeight ? "none" : state.video.parentNode.clientWidth + "px";
				break;
			case 3:
				t += "rotate(180deg)";
			case 1:
				state.video.style.maxWidth = "";
				state.video.style.maxHeight = "";
				break;
			case 2:
				t += "rotate(90deg)";
				state.video.style.maxWidth = state.video.parentNode.clientHeight > state.video.videoWidth ? "none" : state.video.parentNode.clientHeight + "px";
				state.video.style.maxHeight = state.video.parentNode.clientWidth > state.video.videoHeight ? "none" : state.video.parentNode.clientWidth + "px";
				break;
		}
		state.video.style.transform = t;
	}
	function updateStats() {
		if (state.video.readyState > 0) {
			state.info.lastChild.lastChild.textContent = state.rate.toFixed(2) + " " + rotate[state.rotate] + " " + (state.flip ? "-1" : "0");
		}
	}
	function metadataHandler() {
		if (state.transform) {
			updateTransform();
			state.transform = false;
		}
		emptyElement(state.info.lastChild);
		state.info.lastChild.appendChild(document.createTextNode(state.video.videoWidth + " " + state.video.videoHeight + " " + state.video.duration.toFixed(3) + " "));
		state.info.lastChild.appendChild(document.createTextNode(""));
		updateStats();
	}
	function dragHandler(event) {
		event.dataTransfer.setData("text/plain", event.currentTarget.href);
	}
	function dropHandler(event) {
		var i = event.currentTarget.currentTime;
		event.currentTarget.src = event.dataTransfer.getData("text/plain");
		event.currentTarget.load();
		event.currentTarget.currentTime = i;
		event.currentTarget.play();
		event.preventDefault();
	}
	function originHandler(event) {
		if (state.request !== null || state.video === null) {
			return;
		}
		var id = event.currentTarget.getAttribute("data-id"), s = state.video.src;
		event.currentTarget.style.cursor = "progress";
		/*state.request = state.requestRaw(state.video.src, function(error) {
			state.request = null;
			var i, e, t, a = document.getElementById("awemer-origin");
			if (a === null || a.getAttribute("data-id") !== id) {
				return;
			}
			a.style.cursor = "";
			if (error !== null) {
				console.log(error);
				return;
			}
			a.onclick = null;
			a.textContent = "origin";
			if ((i = (t = this.responseText).indexOf("vid:")) > -1 && (e = t.indexOf("\0", i + 4)) > -1) {
				a.setAttribute("data-normal", "https://api-h2.tiktokv.com/aweme/v1/play/?video_id=" + t.substring(i + 4, e));
				a.setAttribute("data-fine", a.getAttribute("data-normal") + "&improve_bitrate=1&ratio=default");
			} else {
				a.setAttribute("data-normal", s);
				a.setAttribute("data-fine", s);
			}
			a.href = a.getAttribute(state.quality ? "data-fine" : "data-normal");
		});*/
		state.request = state.requestVideoDetail(id, function(error, data) {
			state.request = null;
			var a = document.getElementById("awemer-origin");
			if (a === null || a.getAttribute("data-id") !== id) {
				return;
			}
			a.style.cursor = "";
			if (error !== null) {
				console.log(error);
				return;
			} else if (typeof data !== "object" || data === null || data.status_code !== 0
			|| typeof data.aweme_detail !== "object" || data.aweme_detail === null || data.aweme_detail.aweme_id !== id
			|| typeof data.aweme_detail.video !== "object" || data.aweme_detail.video === null
			|| typeof data.aweme_detail.video.play_addr !== "object" || data.aweme_detail.video.play_addr === null
			|| typeof data.aweme_detail.video.play_addr.url_list !== "object" || data.aweme_detail.video.play_addr.url_list === null) {
				console.log(data);
				return;
			}
			a.onclick = null;
			a.textContent = "origin";
			a.setAttribute("data-normal", data.aweme_detail.video.play_addr.url_list[0]);
			a.setAttribute("data-fine", getQualityUri(data.aweme_detail.video.play_addr.url_list[data.aweme_detail.video.play_addr.url_list.length - 1]));
			a.href = a.getAttribute(state.quality ? "data-fine" : "data-normal");
			a.ondragstart = dragHandler;
			a.draggable = true;
			state.video.ondrop = dropHandler;
			state.video.ondragover = preventDefault;
		});
		event.preventDefault();
		event.stopPropagation();
	}
	function qualityHandler() {
		var a = event.currentTarget.previousSibling.previousSibling;
		if (state.quality) {
			state.quality = false;
			event.currentTarget.textContent = "normal";
			localStorage.setItem("awemer-quality", "0");
			if (a.onclick === null) {
				a.href = a.getAttribute("data-normal");
			}
		} else {
			state.quality = true;
			event.currentTarget.textContent = "fine";
			localStorage.setItem("awemer-quality", "1");
			if (a.onclick === null) {
				a.href = a.getAttribute("data-fine");
			}
		}
		event.preventDefault();
		event.stopPropagation();
	}
	function addOrigin(element, id) {
		var a = document.createElement("a");
		a.className = "awemer-link";
		a.id = "awemer-origin";
		a.target = "_blank";
		a.href = "#";
		a.onclick = originHandler;
		a.setAttribute("data-id", id);
		a.textContent = "request origin";
		element.appendChild(a);
		element.appendChild(document.createTextNode(" ("));
		a = document.createElement("a");
		a.className = "awemer-link";
		a.target = "_blank";
		a.href = "#";
		a.onclick = qualityHandler;
		a.textContent = state.quality ? "fine" : "normal";
		element.appendChild(a);
		element.appendChild(document.createTextNode(")"));
	}
	function getCurrentId() {
		var i, e, t;
		return (state.current < state.items.length && (t = state.items[state.current].querySelector("a")) !== null && (i = (t = t.href).indexOf("video/")) > -1)
		|| (i = (t = location.href).indexOf("video/")) > -1 ? t.substring(i + 6, (e = t.indexOf("?", i + 6)) > -1 ? e : t.length) : "";
	}
	function fixVideo() {
		var i = getCurrentId();
		emptyElement(state.info.firstChild);
		if (i.length > 0) {
			addOrigin(state.info.firstChild, i);
			state.info.firstChild.appendChild(document.createTextNode("\n" + i));
			if (typeof __NEXT_DATA__ === "object" && __NEXT_DATA__ !== null
			&& typeof __NEXT_DATA__.props === "object" && __NEXT_DATA__.props !== null
			&& typeof __NEXT_DATA__.props.pageProps === "object" && __NEXT_DATA__.props.pageProps !== null
			&& typeof __NEXT_DATA__.props.pageProps.itemInfo === "object" && __NEXT_DATA__.props.pageProps.itemInfo !== null
			&& typeof __NEXT_DATA__.props.pageProps.itemInfo.itemStruct === "object" && __NEXT_DATA__.props.pageProps.itemInfo.itemStruct !== null
			&& typeof __NEXT_DATA__.props.pageProps.itemInfo.itemStruct.createTime === "number" && __NEXT_DATA__.props.pageProps.itemInfo.itemStruct.createTime !== 0
			&& __NEXT_DATA__.props.pageProps.itemInfo.itemStruct.id === i) {
				state.info.firstChild.appendChild(document.createTextNode("\n" + createTimeToString(__NEXT_DATA__.props.pageProps.itemInfo.itemStruct.createTime)));
			}
		}
		state.transform = true;
		state.video.controls = true;
		state.video.muted = state.muted;
		state.video.volume = state.volume;
		state.video.playbackRate = state.rate;
		state.video.onkeydown = keydownHandler;
		state.video.onclick = stopPropagation;
		state.video.onvolumechange = volumeHandler;
		state.video.onloadedmetadata = metadataHandler;
		state.video.className = "";
		if (state.video.readyState > 0) {
			metadataHandler();
		}
		state.video.focus();
	}
	function previousNextPostHandler() {
		state.id = null;
		if (state.browser !== null) {
			state.video = state.browser.querySelector("video");
			fixVideo();
		}
	}
	function closePostHandler() {
		state.id = null;
		document.body.style.overflow = "";
		if (state.current < state.items.length) {
			scrollBy(0, state.items[state.current].getBoundingClientRect().top - (state.type.charCodeAt(0) === 116 || state.type.charCodeAt(0) === 118 ? 70 : 72));
		}
	}
	function browserHandler(event) {
		if (event.currentTarget === event.target || (event.target.tagName === "DIV" && event.target.className.indexOf("video-card-browse") > -1)) {
			state.video.focus();
		} else if (event.target.tagName === "IMG") {
			if (event.target.className.indexOf("arrow-left") > -1) {
				state.current--;
				if (state.id !== null) {
					clearTimeout(state.id);
				}
				state.id = setTimeout(previousNextPostHandler, 0);
			} else if (event.target.className.indexOf("arrow-right") > -1) {
				state.current++;
				if (state.id !== null) {
					clearTimeout(state.id);
				}
				state.id = setTimeout(previousNextPostHandler, 0);
			} else if (event.target.className.indexOf("close") > -1) {
				document.body.style.overflow = "";
				state.rate = state.video.playbackRate;
				state.video.onkeydown = state.video.onclick = state.video.onvolumechange = state.video.onloadedmetadata = null;
				state.transform = false;
				state.browser = null;
				state.video = null;
				if (state.info.parentNode !== null) {
					state.info.parentNode.removeChild(state.info);
				}
				if (state.id !== null) {
					clearTimeout(state.id);
				}
				state.id = setTimeout(closePostHandler, 0);
			}
		}
	}
	function determineType() {
		var m;
		if (state.type.length === 0) {
			if (location.pathname.indexOf("/@") === 0) {
				if ((m = location.pathname.match(/\/video\/([1-9][0-9]*)/)) !== null) {
					state.type = "video";
					state.key = m[1];
				} else if ((m = location.pathname.match(/@([^?/]+)/)) !== null) {
					state.type = "user";
					state.key = decodeURI(m[1]);
				} else {
					return false;
				}
			} else if (location.pathname.indexOf("/music/") === 0) {
				if ((m = location.pathname.match(/-([1-9][0-9]*)(?:[?/]|$)/)) === null) {
					return false;
				}
				state.type = "music";
				state.key = m[1];
			} else if (location.pathname.indexOf("/tag/") === 0) {
				if ((m = location.pathname.match(/tag\/([^?/]+)/)) === null) {
					return false;
				}
				state.type = "challenge";
				state.key = decodeURI(m[1]);
			} else if (location.pathname === "/" || location.pathname.indexOf("/foryou") === 0 || location.pathname.indexOf("/trending") === 0) {
				state.type = "trending";
			} else if (location.pathname.indexOf("/discover") === 0) {
				state.type = "discover";
			} else {
				return false;
			}
		}
		return true;
	}
	function loadSettings() {
		var i = localStorage.getItem("awemer-timestamp"), e, k;
		if (i === null || i !== "1557506774530") {
			for (e = 0; e < localStorage.length; e++) {
				if ((k = localStorage.key(e)).indexOf("awemer") === 0) {
					localStorage.removeItem(k);
				}
			}
			localStorage.setItem("awemer-timestamp", "1557506774530");
		} else {
			if ((i = localStorage.getItem("awemer-volume")) !== null) {
				state.volume = +i;
			}
			state.quality = (i = localStorage.getItem("awemer-quality")) !== null && i !== "0";
		}
	}
	function addStyle() {
		state.style = document.createElement("style");
		state.style.appendChild(document.createTextNode(".count-infos, .share-desc, .share-links, .share-sub-title-thin {display: none!important;}"
		+ ".share-links {margin-top: 0px!important;}"
		+ ".share-layout-header {margin-bottom: 0px!important;}"
		+ ".video-detail {width: 100%!important; padding: 0px!important;}"//*remove
		+ ".video-detail-container {height: calc(100vh - 70px)!important; min-height: 0px!important;}"//*remove
		+ ".copy-link-container {width: 100%!important;}"//*remove
		+ ".video-card-big {flex: 1; height: 100%!important; max-height: none!important; min-height: 0px!important; margin: 0px!important; border-radius: 0px!important;}"
		+ ".video-card-big > .video-card-container {flex: 1; background-color: black!important;}"
		+ ".video-card-big > .content-container {flex-basis: 25%!important; width: 25%!important; padding: 12px!important; border-width: 0px 1px 0px 1px!important; border-radius: 0px!important; background-color: white!important;}"
		+ ".video-card-big video {position: absolute; top: 0px; right: 0px; bottom: 0px; left: 0px; width: auto; height: auto; max-width: 100%; min-width: 0px; max-height: 100%; min-height: 0px; margin: auto; outline: none;}"
		+ ".video-card-big .video-card-mask, .video-card-big .play-button, .video-card-big .event-delegate-mask, .video-card-big .mute-icon, .video-card-big .logo, .video-card-big .video-card-container-warn, .warn-info-pc {display: none!important;}"
		+ ".has-warn > div:first-child {position: relative!important;}"
		+ ".video-card-one-column video {background-color: transparent!important;}"
		+ ".image-card, ._music_card_, ._card_header_cover, ._user_carousel_avatar, .avatar-wrapper, .tiktok-avatar, .item-video-card-wrapper {border-radius: 0px!important;}"
		+ ".user-info-container, .video-infos-container {padding: 0px!important;}"
		+ ".user-info {padding: 6px 0px 6px 0px!important;}"
		+ ".video-card-browse {background-image: none!important;}"
		+ ".more-contents, .comment-content, .comment-text, .comment-time {user-select: auto!important; -webkit-user-select: auto!important; -moz-user-select: auto!important; -ms-user-select: auto!important;}"
		+ ".comment-content:active {background-color: transparent!important;}"
		+ ".main-body {width: 100%!important;}"//*remove
		+ ".video-infos-container {overflow: auto!important;}"//*remove
		+ ".awemer-link {font-weight: bold!important;}"
		+ ".awemer-link:hover {text-decoration: underline!important;}"
		+ "#awemer-share, #awemer-info {font-size: 15px; font-family: proxima-regular, sans-serif; white-space: pre-wrap;}"
		+ "#awemer-share {margin: 10px 0px 10px 0px;}"));
		document.head.appendChild(state.style);
	}
	function asThousands(value) {
		if (value.length <= 3) {
			return value;
		}
		var e = value.length % 3, r = e > 0 ? value.substring(0, e) + "," : "", i = e;
		e = value.length - 3;
		while (i < e) {
			r += value.substring(i, i += 3) + ",";
		}
		return r + value.substring(i);
	}
	function unescapeHtml(value) {
		if (value.length === 0) {
			return "";
		}
		return (new DOMParser()).parseFromString(value, "text/html").documentElement.textContent;
	}
	function getUriScheme(value) {
		var i = value.indexOf(":");
		return i === -1 || i > value.indexOf("/") ? "" : value.substring(0, i);
	}
	function fixShareHandler(error, data) {
		state.request = null;
		if (error !== null) {
			console.log(error);
			return;
		} else if (typeof data !== "object" || data === null || (data.statusCode !== 0 && (state.type.charCodeAt(0) !== 117 || data.statusCode !== 10222))) {
			console.log(data);
			return;
		}
		var t = document.querySelector(".share-layout-header");
		if (t === null) {
			return;
		}
		switch (state.type.charCodeAt(0)) {
			case 117:
				emptyElement(state.share);
				t.parentNode.insertBefore(state.share, t.nextSibling);
				state.share.appendChild(document.createTextNode(data.userInfo.user.id
				+ (typeof data.userInfo.user.createTime === "number" && data.userInfo.user.createTime !== 0 ? "\n" + createTimeToString(data.userInfo.user.createTime) + "\n" : "\n")
				+ asThousands(String(data.userInfo.stats.videoCount)) + (data.userInfo.stats.videoCount === 1 ? " video • " : " videos • ")
				+ asThousands(String(data.userInfo.stats.diggCount)) + (data.userInfo.stats.diggCount === 1 ? " favorite • " : " favorites • ")
				+ asThousands(String(data.userInfo.stats.heartCount)) + " favorited • "
				+ asThousands(String(data.userInfo.stats.followingCount)) + (data.userInfo.stats.followingCount === 1 ? " following • " : " followings • ")
				+ asThousands(String(data.userInfo.stats.followerCount)) + (data.userInfo.stats.followerCount === 1 ? " follower" : " followers")));
				if (data.userInfo.user.signature.length > 0) {
					state.share.appendChild(document.createTextNode("\n" + unescapeHtml(data.userInfo.user.signature)));
				}
				if (typeof data.userInfo.user.bioLink === "object" && data.userInfo.user.bioLink !== null && typeof data.userInfo.user.bioLink.link === "string") {
					state.share.appendChild(document.createTextNode("\n"));
					state.share.appendChild(document.createElement("a"));
					state.share.lastChild.className = "awemer-link";
					state.share.lastChild.target = "_blank";
					state.share.lastChild.href = getUriScheme(data.userInfo.user.bioLink.link).length === 0 ? "//" + data.userInfo.user.bioLink.link : data.userInfo.user.bioLink.link;
					state.share.lastChild.text = data.userInfo.user.bioLink.link;
				}
				break;
			case 109:
				emptyElement(state.share);
				t.parentNode.insertBefore(state.share, t.nextSibling);
				state.share.appendChild(document.createTextNode(data.musicInfo.music.id
				+ (typeof data.musicInfo.author === "object" && data.musicInfo.author !== null ? " " + data.musicInfo.author.id + "\n" : "\n")
				+ asThousands(String(data.musicInfo.stats.videoCount)) + (data.musicInfo.stats.videoCount === 1 ? " video\n" : " videos\n")));
				state.share.appendChild(document.createElement("a"));
				state.share.lastChild.className = "awemer-link";
				state.share.lastChild.target = "_blank";
				state.share.lastChild.href = data.musicInfo.music.playUrl;
				state.share.lastChild.text = "origin";
				break;
			case 99:
				emptyElement(state.share);
				t.parentNode.insertBefore(state.share, t.nextSibling);
				state.share.appendChild(document.createTextNode(data.challengeInfo.challenge.id + "\n"
				+ asThousands(String(data.challengeInfo.stats.videoCount)) + (data.challengeInfo.stats.videoCount === 1 ? " video • " : " videos • ")
				+ asThousands(String(data.challengeInfo.stats.viewCount)) + (data.challengeInfo.stats.viewCount === 1 ? " view" : " views")));
				if (data.challengeInfo.challenge.desc.length > 0) {
					state.share.appendChild(document.createTextNode("\n" + unescapeHtml(data.challengeInfo.challenge.desc)));
				}
				break;
		}
	}
	function fixShare() {
		if (state.request !== null) {
			state.request.abort();
			state.request = null;
		}
		switch (state.type.charCodeAt(0)) {
			case 117:
				state.request = state.requestUserNode(state.key, fixShareHandler);
				break;
			case 109:
				state.request = state.requestMusicNode(state.key, fixShareHandler);
				break;
			case 99:
				state.request = state.requestChallengeNode(state.key, fixShareHandler);
				break;
		};
	}
	function observeShareFix(mutations) {
		var i, p, t;
		for (p in mutations) {
			if (mutations[p].removedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].removedNodes[i].nodeType === 1 && mutations[p].removedNodes[i].id === "awemer-share") {
						try {
							state.sharer.disconnect();
						} catch (e) {}
						state.sharer = null;
						if ((t = document.querySelector(".share-layout-header")) !== null) {
							t.parentNode.insertBefore(state.share, t.nextSibling);
						}
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function observeShare(mutations) {
		var i, p;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "HEADER" && mutations[p].addedNodes[i].className.indexOf("share-layout-header") > -1) {
						try {
							state.sharer.disconnect();
						} catch (e) {}
						state.sharer = new MutationObserver(observeShareFix);
						state.sharer.observe(document.querySelector(".share-layout-content"), {childList: true});
						fixShare();
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function observeVideo(mutations) {
		var i, p, t;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "DIV" && mutations[p].addedNodes[i].className.indexOf("detail-mode") > -1) {
						if ((t = mutations[p].addedNodes[i].querySelector(".video-meta-title")) !== null) {
							if (state.info.parentNode === null) {
								t.parentNode.insertBefore(state.info, t);
							}
							if ((t = document.querySelector(".video-card-browse")) !== null) {
								state.items = [];
								state.browser = t.parentNode;
								state.browser.onclick = browserHandler;
								state.video = state.browser.querySelector("video");
								fixVideo();
							}
						}
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function observeDiscover(mutations) {
		var i, p;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "DIV" && mutations[p].addedNodes[i].className.indexOf("_base_layout_main") > -1) {
						try {
							state.observer.disconnect();
						} catch (e) {}
						state.observer = null;
						state.viewer.observe(mutations[p].addedNodes[i], {childList: true});
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function observeLikes(mutations) {
		var i, p;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "DIV" && mutations[p].addedNodes[i].className.indexOf("tt-feed") > -1) {
						try {
							state.viewer.disconnect();
						} catch (e) {}
						state.viewer.observe(mutations[p].addedNodes[i], {childList: true});
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function observeFeed(mutations) {
		var i, p;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "DIV" && mutations[p].addedNodes[i].className.indexOf("tt-feed") > -1) {
						try {
							state.observer.disconnect();
						} catch (e) {}
						state.observer = null;
						if (state.type.charCodeAt(0) === 117) {
							state.observer = new MutationObserver(observeLikes);
							state.observer.observe(document.querySelector(".share-layout-main"), {childList: true});
						}
						state.viewer.observe(mutations[p].addedNodes[i], {childList: true});
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	}
	function load() {
		if (state.active || !determineType()) {
			return;
		}
		state.active = true;
		var t;
		addStyle();
		if (state.type.charCodeAt(0) === 118) {
			if ((t = document.querySelector(".video-meta-title")) !== null) {
				if (state.info.parentNode === null) {
					t.parentNode.insertBefore(state.info, t);
				}
				if ((t = document.querySelector(".video-card-browse")) !== null) {
					state.items = [];
					state.browser = t.parentNode;
					state.browser.onclick = browserHandler;
					state.video = state.browser.querySelector("video");
					fixVideo();
				}
				return;
			} else if ((t = document.querySelector(".video-detail-container")) !== null) {
				state.observer = new MutationObserver(observeVideo);
				state.observer.observe(t, {childList: true});
				return;
			}
		}
		switch (state.type.charCodeAt(0)) {
			case 100:
				if ((t = document.querySelector("._base_layout_main")) !== null) {
					state.viewer.observe(t, {childList: true});
				} else if ((t = document.querySelector("._base_layout_content")) !== null) {
					state.observer = new MutationObserver(observeDiscover);
					state.observer.observe(t, {childList: true});
				} else {
					state.type = "trending";
				}
				break;
			case 117:
			case 109:
			case 99:
				if (document.querySelector(".share-layout-header") !== null) {
					state.sharer = new MutationObserver(observeShareFix);
					state.sharer.observe(document.querySelector(".share-layout-content"), {childList: true});
					fixShare();
				} else if ((t = document.querySelector(".share-layout-content")) !== null) {
					state.sharer = new MutationObserver(observeShare);
					state.sharer.observe(t, {childList: true});
				}
				break;
		}
		if ((t = document.querySelector(".tt-feed")) !== null) {
			if (state.type.charCodeAt(0) === 117) {
				state.observer = new MutationObserver(observeLikes);
				state.observer.observe(document.querySelector(".share-layout-main"), {childList: true});
			}
			state.viewer.observe(t, {childList: true});
		} else if ((t = document.querySelector(".share-layout-main")) !== null) {//*remove
			state.observer = new MutationObserver(observeFeed);
			state.observer.observe(t, {childList: true});
		}
	}
	function unload() {
		if (!state.active || state.type.length === 0) {
			return;
		}
		state.active = false;
		if (state.observer !== null) {
			try {
				state.observer.disconnect();
			} catch (e) {}
			state.observer = null;
		}
		if (state.sharer !== null) {
			try {
				state.sharer.disconnect();
			} catch (e) {}
			state.sharer = null;
		}
		try {
			state.viewer.disconnect();
		} catch (e) {}
		state.type = state.key = "";
		if (state.id !== null) {
			clearTimeout(state.id);
			state.id = null;
		}
		state.current = 0;
		state.last = 0;
		if (state.style !== null) {
			state.style.parentNode.removeChild(state.style);
			state.style = null;
		}
		state.target = null;
		if (state.video !== null) {
			document.body.style.overflow = "";
			state.rate = state.video.playbackRate;
			state.video.pause();
			state.video.onkeydown = state.video.onclick = state.video.onvolumechange = state.video.onloadedmetadata = null;
			state.transform = false;
			state.video = null;
		}
		state.browser = state.items = null;
		if (state.share.parentNode !== null) {
			state.share.parentNode.removeChild(state.share);
		}
		if (state.info.parentNode !== null) {
			state.info.parentNode.removeChild(state.info);
		}
		if (state.request !== null) {
			state.request.abort();
			state.request = null;
		}
	}
	state.share = document.createElement("div");
	state.share.id = "awemer-share";
	state.info = document.createElement("div");
	state.info.id = "awemer-info";
	state.info.appendChild(document.createElement("div"));
	state.info.appendChild(document.createElement("div"));
	state.reloader = new MutationObserver(function(mutations) {
		var i, p;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].id === "nprogress") {
						unload();
						break;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
			if (mutations[p].removedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].removedNodes[i].nodeType === 1 && mutations[p].removedNodes[i].id === "nprogress") {
						load();
						break;
					}
					i++;
				} while (i < mutations[p].removedNodes.length);
			}
		}
	});
	state.viewer = new MutationObserver(function(mutations) {
		var i, p, t, c;
		for (p in mutations) {
			if (mutations[p].addedNodes.length > 0) {
				i = 0;
				do {
					if (mutations[p].addedNodes[i].nodeType === 1 && mutations[p].addedNodes[i].tagName === "DIV" && mutations[p].addedNodes[i].className.indexOf("browse-mode") > -1) {
						if ((p = mutations[p].addedNodes[i].querySelector(".video-card-browse")) !== null) {
							i = 12;
							t = state.target;
							c = state.type.charCodeAt(0) === 100 ? "_explore_feed_card_item" : "video-feed-item";
							while (i > 0 && t !== null && (t.tagName !== "DIV" || t.className.indexOf(c) === -1)) {
								t = t.parentNode;
								i--;
							}
							if (i === 0 || t === null) {
								return;
							}
							state.items = document.getElementsByClassName(c);
							for (i = 0; i < state.items.length; i++) {
								if (state.items[i] === t) {
									state.current = i;
									break;
								}
							}
							if (i === state.items.length) {
								state.items = null;
								return;
							} else if (state.id !== null) {
								clearTimeout(state.id);
								state.id = null;
							}
							document.body.style.overflow = "hidden";
							state.browser = p.parentNode;
							state.browser.onclick = browserHandler;
							if (state.info.parentNode === null) {
								t = state.browser.parentNode.querySelector(".video-meta-title");
								t.parentNode.insertBefore(state.info, t);
							}
							state.video = state.browser.querySelector("video");
							fixVideo();
						}
						return;
					}
					i++;
				} while (i < mutations[p].addedNodes.length);
			}
		}
	});
	window.addEventListener("resize", function() {
		if (state.video !== null && state.video.readyState > 0 && (state.rotate & 1) === 0) {
			state.video.style.maxWidth = state.video.parentNode.clientHeight > state.video.videoWidth ? "none" : state.video.parentNode.clientHeight + "px";
			state.video.style.maxHeight = state.video.parentNode.clientWidth > state.video.videoHeight ? "none" : state.video.parentNode.clientWidth + "px";
		}
	});
	document.addEventListener("wheel", function(event) {
		if (state.video === null || event.ctrlKey || event.altKey || (event.target !== state.video && event.target !== state.video.parentNode)) {
			return;
		}
		var t;
		if (event.deltaY < 0) {
			if (state.browser !== null && state.current > 0 && (t = state.browser.querySelector("img.arrow-left")) !== null) {
				t.click();
			}
		} else if (event.deltaY > 0) {
			if (state.browser !== null && state.current < state.items.length - 1 && (t = state.browser.querySelector("img.arrow-right")) !== null) {
				t.click();
			}
		}
	});
	document.addEventListener("mousedown", function(event) {
		if (state.video === null || event.ctrlKey || event.altKey || (event.which !== 2 && event.button !== 1) || (event.target !== state.video && event.target !== state.video.parentNode)) {
			return;
		}
		if (event.clientX < state.video.parentNode.clientWidth / 2) {
			if (state.rotate === 0) {
				state.rotate = 3;
			} else {
				state.rotate--;
			}
		} else if (state.rotate === 3) {
			state.rotate = 0;
		} else {
			state.rotate++;
		}
		updateStats();
		if (state.video.readyState > 0) {
			updateTransform();
		} else {
			state.transform = true;
		}
		event.preventDefault();
		event.stopPropagation();
	});
	document.addEventListener("keydown", function(event) {
		if (state.video === null || event.ctrlKey || event.altKey || document.activeElement !== state.video) {
			return;
		}
		var t;
		switch (event.which || event.keyCode || keys[event.code] || 0) {
			case 8:
			case 27:
				if (state.browser !== null && (t = state.browser.querySelector("img.close")) !== null) {
					t.click();
				}
				break;
			case 19:
			case 80:
			case 82:
				if (state.video.paused) {
					state.video.play();
				} else {
					state.video.pause();
				}
				break;
			case 33:
			case 73:
			case 87:
				if (state.browser !== null && state.current > 0 && (t = state.browser.querySelector("img.arrow-left")) !== null) {
					t.click();
				}
				break;
			case 34:
			case 75:
			case 83:
				if (state.browser !== null && state.current < state.items.length - 1 && (t = state.browser.querySelector("img.arrow-right")) !== null) {
					t.click();
				}
				break;
			case 65:
			case 74:
				if (state.rate > 0) {
					state.rate = state.video.playbackRate = state.video.playbackRate > 0.25 ? state.video.playbackRate - 0.25 : 0;
				}
				updateStats();
				break;
			case 68:
			case 76:
				if (state.rate < 5) {
					state.rate = state.video.playbackRate = state.video.playbackRate < 4.75 ? state.video.playbackRate + 0.25 : 5;
				}
				updateStats();
				break;
			case 90:
			case 188:
				state.flip = false;
				updateStats();
				if (state.video.readyState > 0) {
					updateTransform();
				} else {
					state.transform = true;
				}
				break;
			case 88:
			case 190:
				state.flip = true;
				updateStats();
				if (state.video.readyState > 0) {
					updateTransform();
				} else {
					state.transform = true;
				}
				break;
			case 45:
			case 81:
			case 85:
				if (state.rotate === 0) {
					state.rotate = 3;
				} else {
					state.rotate--;
				}
				updateStats();
				if (state.video.readyState > 0) {
					updateTransform();
				} else {
					state.transform = true;
				}
				break;
			case 46:
			case 69:
			case 79:
				if (state.rotate === 3) {
					state.rotate = 0;
				} else {
					state.rotate++;
				}
				updateStats();
				if (state.video.readyState > 0) {
					updateTransform();
				} else {
					state.transform = true;
				}
				break;
			default:
				return;
		}
		event.preventDefault();
	});
	determineType();
	document.addEventListener("click", function(event) {
		state.target = state.type.length === 0 || state.video !== null ? null : event.target.parentNode;
	});
	window.addEventListener("DOMContentLoaded", function() {
		state.randomizeDevice();
		state.reloader.observe(document.body, {childList: true});
		loadSettings();
		load();
	});
})();