var os = require("os"),
fs = require("fs"),
path = require("path"),
http = require("http"),
https = require("https"),
crypto = require("crypto"),
zlib = require("zlib"),
//tls = require("tls"),
//ciphers_default = tls.DEFAULT_CIPHERS.split(":"),
//ciphers_shuffled = [ // https://httptoolkit.tech/blog/tls-fingerprinting-node-js/
//ciphers_default[2],
//ciphers_default[1],
//ciphers_default[0],
//...ciphers_default.slice(3)
//].join(":"),
child_process = require("child_process"),

cookie = "",
//cookie = cookie_format("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"),

reject_sd = true,
reject_sd_error = new Error("SD"),
uri_blocks = new Set(),

user_agent = "com.zhiliaoapp.musically/2022400030 (Linux; U; Android 7.1.2; en_US; SM-G973N; Build/PPR1.190810.011;tt-ok/3.10.0.2)",
user_agents_random = true,
cycle_hosts = true,

download_videos_tikwm = false,
download_videos_single = false,

magic_bytes = "66747970",
magic_bytes_start = 4,
magic_bytes_end = 7,
test_magic_bytes = true,

windows_max_path = 255,
windows_paths = false,
//windows_paths = process.platform === "win32",

debug = false,
//debug = true,

debug_data = false,
//debug_data = true,

help = "node " + path.basename(__filename) + " t=ui|mi|hi|vi|uv|mv|hv|v|us|s|c|cm|cv|vc|vcr|ul|fyp|followed|uvwp|uvw|mvw|hvw|bv|pv|up|li|lives_inbox|lives_following|n|nd|un si=sec_uid|i=0|@name|#tag|clipboard|\"file.txt\" \\"
+ os.EOL + "[l=-1|" + (new Date(0)).toISOString().substring(0, 10) + "|last_scrape] [last_scrape] [y] \\"
+ os.EOL + "[o=0] [c] [d=-1] [q] [h] [f] [p] [a] [b] [mp3] [z] [ui] [un] \\"
+ os.EOL + "[g=\"log.txt\"] [log_errors] [log_verbose] [log_data] [debug] [debug_data] \\"
+ os.EOL + "[w=30] [x] [n=100] [error_delay=1000] \\"
+ os.EOL + "[cookie=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX] = [j=\"sid_tt=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX; sessionid=XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\"] \\"
+ os.EOL + "[u=\"" + user_agent + "\"] [ur] \\"
+ os.EOL + "[m=\"metadata_file.json\"] [mo=\"metadata_file.json\"] [mu] [v] [s] [k] [metadata_each] [metadata_dirs] \\"
+ os.EOL + "[fetch_only] [fetched_ids=\"file.json\"] [scraped_ids=\"file.json\"] [unscraped_ids=\"file.json\"] [ignore_ids=\"file.json\"] [save_empty] [skip_empty] \\"
+ os.EOL + "[max_depth=0] [max_resumes=10] [max_retries=3] [max_converts=1] [max_downloads=10] [max_zips=3] \\"
+ os.EOL + "[min_views=0] [max_views=0] \\"
+ os.EOL + "[skip_live] [skip_photos] [skip_stories] [skip_followed] [skip_uids=\"skip_uids.txt\"] \\"
+ os.EOL + "[only_live] [only_photos] [only_stories] [only_followed] [only_uids=\"only_uids.txt\"] \\"
+ os.EOL + "[zip_photos] [story_dirs] [tag_mutual] [tag_stories] \\"
+ os.EOL + "[aweme_details_single] [aweme_host=\"*.tiktokv.com\"] [cycle_hosts] \\"
+ os.EOL + "[verify_files] [rename_hevc] [convert_hevc] \\"
+ os.EOL + "[alert_proc] [alert_args={}] [progress_bars] [windows_paths=" + windows_paths + "] [tikwm] [aid=1233]"
+ os.EOL
+ os.EOL + "t - ui (user info), mi (music info), hi (hashtag info), vi (video info),"
+ os.EOL + "    uv (user videos), mv (music videos), hv (hashtag videos), v (videos),"
+ os.EOL + "    us (user stories), s ([tiktok's selection of followed accounts]' stories),"
+ os.EOL + "    c (personal collections' videos), cm (personal collections' metadata), cv (collection's videos),"
+ os.EOL + "    vc (video comments), vcr (video comment's replies), ul (user likes),"
+ os.EOL + "    fyp (trending videos), followed (followed accounts' videos),"
+ os.EOL + "    uvwp (user videos [web page]), uvw (user videos [web api]), mvw (music videos [web api]), hvw (hashtag videos [web api]),"
+ os.EOL + "    bv (bookmarked videos), pv (playlist videos), up (user's playlists),"
+ os.EOL + "    li (livestream information), lives_inbox / lives_following (lives of followed users),"
+ os.EOL + "    n (mutuals' \"now\" posts), nd (\"now\" discover page), un (user's \"now\" posts)"
+ os.EOL + "i - id or @name of a user, id of a music, id or #tag of a hashtag,"
+ os.EOL + "    id of a video, or empty value for stdin, or file or clipboard with ids or urls of videos (separated by whitespace)"
+ os.EOL + "l - date until which to check videos (YYYY-MM-DD),"
+ os.EOL + "    last_scrape to continue until encountering a video created <= the previous use,"
+ os.EOL + "    or max number of videos to check (integer)"
+ os.EOL + "o - cursor (integer) - unix time in milliseconds (user videos) or video offset (music and hashtag videos)"
+ os.EOL + "c - add date"
+ os.EOL + "d - add description - pass a number to limit to that file name size by trimming descriptions"
+ os.EOL + "q - download videos in hd"
+ os.EOL + " =0 - download videos in sd, tagged"
+ os.EOL + " =1 - download videos in sd, tagged, and hd"
+ os.EOL + " =2 - download videos in sd, tagged, if downloading in hd fails"
+ os.EOL + " =3 - download videos in sd (with watermark), tagged"
+ os.EOL + " =4 - download videos in sd, tagged, sd (with watermark), tagged, and hd"
+ os.EOL + " =-1 - download videos in sd (with watermark)"
+ os.EOL + "h - prefer HEVC/H.265"
+ os.EOL + "g - log output to file"
+ os.EOL + "f - directory"
+ os.EOL + "p - don't download videos/photos"
+ os.EOL + "a - download thumbnails"
+ os.EOL + "b - download animated thumbnails"
+ os.EOL + "z - group files in sub-directories by creator uid"
+ os.EOL + "k - log metadata"
+ os.EOL + "m - save metadata to file as array"
+ os.EOL + "mo - save metadata to file as object"
+ os.EOL + "mu - update metadata in file given to \"mo\""
+ os.EOL + "s - split metadata results by newline"
+ os.EOL + "v - unfiltered metadata"
+ os.EOL + "w - cursor batch size"
+ os.EOL + "x - log current cursor - if passed a value then also shows time elapsed between cursors"
+ os.EOL + "y - override the limit set by the \"l\" flag to finish the final cursor's batch"
+ os.EOL + "n - re-attempt requests on server error - takes a max amount of errors before a success to ignore (0 = no limit)"
+ os.EOL + "j - private cookie from \".tiktok.com\""
+ os.EOL + "u - user agent"
+ os.EOL + "ur - randomized user agents"
+ os.EOL + "ui - add user id"
+ os.EOL + "un - add user name"
+ os.EOL
+ os.EOL + "verify_files  ^ download videos as (%file_name%~verify.mp4),"
+ os.EOL + "                pass through ffprobe after downloading to check their integrity,"
+ os.EOL + "                if failure then rename (%file_name%~error.mp4)"
+ os.EOL + "                else rename according to other flags set"
+ os.EOL + "rename_hevc   ^ if downloaded video is HEVC then rename (%file_name%~hevc.mp4)"
+ os.EOL + "convert_hevc  & if downloaded video is HEVC then convert a H264 version (%file_name%~h264.mp4)"
+ os.EOL + "              ^ (requires ffprobe)"
+ os.EOL + "              & (requires ffprobe+ffmpeg)"
+ os.EOL
+ os.EOL + "metadata_each - save separate metadata files for each video,"
+ os.EOL + "                if passed a value then also updates previously saved metadata"
+ os.EOL + "metadata_dirs - save separate metadata files in a sub-directory,"
+ os.EOL + "                defaults to /metadata but also accepts another value to use"
+ os.EOL
+ os.EOL + "max_depth     - max amount of cursors to scrape through"
+ os.EOL + "max_resumes   - max amount of times to attempt resuming a timed-out download"
+ os.EOL + "max_retries   - max amount of times to attempt re-downloading a video after it fails ffprobe"
+ os.EOL + "max_converts  - max amount of simultaneous file converts"
+ os.EOL + "max_downloads - max amount of simultaneous downloads"
+ os.EOL + "max_zips      - max amount of simultaneous photo zip operations"
+ os.EOL
+ os.EOL + "fetch_only    - only fetch ids, skip downloading files/metadata"
+ os.EOL + "fetched_ids   - save fetched ids to file"
+ os.EOL + "scraped_ids   - save fetched and scraped ids to file"
+ os.EOL + "unscraped_ids - save fetched but unscraped ids to file"
+ os.EOL + "ignore_ids    - ignore ids already present in supplied file,"
+ os.EOL + "                add successfully downloaded ids to same file"
+ os.EOL + "              - if not passed output files then uses default constructions"
+ os.EOL + "save_empty    - save output files to disk if the contents are empty [default]"
+ os.EOL + "skip_empty    - skip saving files to disk if the contents are empty"
+ os.EOL
+ os.EOL + "alert_proc    - process to run newly downloaded files through"
+ os.EOL + "alert_args    - arguments to pass to the process"
+ os.EOL + "                \"{}\" is replaced with the downloaded file's path"
+ os.EOL
+ os.EOL + "debug         - print http requests and file operations"
+ os.EOL + "debug_data    - print http response data"
+ os.EOL + "log_data      - write http response data to the log file"
+ os.EOL + "log_errors    - write errors to the log file"
+ os.EOL + "log_verbose   - write all non error output to the log file"
+ os.EOL
+ os.EOL + "aid           - app id"
+ os.EOL + "mp3           - download audios"
+ os.EOL + "tikwm         - download videos directly from tikwm without using the details api"
+ os.EOL + "cookie        - content of the sid_tt/sessionid cookie"
+ os.EOL + "zip_photos    % zip photo posts after download"
+ os.EOL + "story_dirs    - directory to save story posts to"
+ os.EOL + "tag_mutual    - tag mutual only posts"
+ os.EOL + "tag_stories   - tag story posts"
+ os.EOL + "error_delay   - interval between re-attempts with flag \"n\" (ms)"
+ os.EOL + "last_scrape   - save the creation timestamp of the most recent post, for use with \"l=last_scrape\""
+ os.EOL + "strip_spaces  - consolidate/trim whitespace in filename descriptions"
+ os.EOL + "windows_paths - remove descriptions if resulting file path would be >= " + windows_max_path + " characters (windows max safe file path)"
+ os.EOL + "progress_bars $ visual indicator for files' download progress"
+ os.EOL + "                if passed a value then also shows line count"
+ os.EOL + "              % (requires archiver)"
+ os.EOL + "              $ (requires multi-progress and cli-cursor)"
+ os.EOL
+ os.EOL + "min_views     - filter out posts with fewer views"
+ os.EOL + "max_views     - filter out posts with more views"
+ os.EOL
+ os.EOL + "skip_live     - filter out live users"
+ os.EOL + "skip_photos   - filter out photo posts"
+ os.EOL + "skip_stories  - filter out story posts"
+ os.EOL + "skip_followed - filter out posts created by followed users"
+ os.EOL + "skip_uids     - filter out posts created by given users"
+ os.EOL
+ os.EOL + "only_live     - filter out non live users"
+ os.EOL + "only_photos   - filter out non photo posts"
+ os.EOL + "only_stories  - filter out non story posts"
+ os.EOL + "only_followed - filter out posts not created by followed users"
+ os.EOL + "only_uids     - filter out posts not created by given users"
+ os.EOL
+ os.EOL + "aweme_host    - host to attempt first for api calls"
+ os.EOL + "cycle_hosts   - rotate through hosts on error"
+ os.EOL
+ os.EOL + "item_buckets     - split all items into sub-directories based on the item's id"
+ os.EOL + "metadata_buckets - split metadata items into sub-directories based on the item's id"
+ os.EOL
+ os.EOL + "aweme_details_single - use alternate details endpoint"
+ os.EOL
+ os.EOL + "node " + path.basename(__filename) + " e=file.txt|[cmd f] [r=-1] [p=1] [o] [s] [i=clipboard|uid|uids.txt|metadata_file.json]"
+ os.EOL + "e - file (empty value for stdin) with commands (separated by newline,"
+ os.EOL + "    separate arguments with space,"
+ os.EOL + "    escape arguments with quotation marks or apostrophes"
+ os.EOL + "    and quotation marks and apostrophes by doubling)"
+ os.EOL + "    comment out lines with #"
+ os.EOL + "f - treat flag \"e\" as a single command instead of as a file to read"
+ os.EOL + "d - write given commands to file, after any expansion"
+ os.EOL + "r - repeat interval in seconds"
+ os.EOL + "p - max concurrent processes"
+ os.EOL + "o - redirect output to stdout and stderr"
+ os.EOL + "s - run commands through the shell"
+ os.EOL + "u - rebuild commands from given file(s) on restarting its loop"
+ os.EOL + "i - uid, or file or clipboard with list of uids to insert into the commands in place of the string \"{}\"",
limit = -1,
cursor = 0,
//count = 30,
count = 100,
date_limit = false,
date = false,
description = false,
description_limit = -1,
//description_limit = 200,
//description_limit = 255,
quality = false,
hevc = false,
previous_scrape = 0,
last_scrape = 0,
last_scrape_save = false,
last_scrape_file,
last_scrapes_dir = "last_scrapes",
backup_cookie = "",
//backup_cookie = cookie_format("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"),
private_cookie = false,
private_cookie_used = false,
previous_account_status = 0,
account_status = 0,
account_status_save = false,
account_status_file,
account_status_dir = "account_status",
log_save = false,
log_data = false,
log_errors = false,
log_verbose = false,
log_file = "log.txt",
logger,
cursor_print = false,
cursor_times = false,
break_limit = false,
ignore_errors = false,
//ignore_errors_delay = 1000,
ignore_errors_delay = 0,
ignore_errors_limit = 100,
ignore_errors_count = 0,
uid_directories = false,
directories_created = new Set(),
fetch_only = false,
download_videos = true,
download_audios = false,
download_thumbs = false,
download_thumbs_anim = false,
zip_photos = false,
flat_photos = false,
archiver,
download_exts = [],
download_files = true,
request_aweme_iid = false,
request_aweme_sign = false,
request_aweme_sign_func,
request_aweme_cache = true,
request_aweme_cache_dir = "request_aweme_cache",
request_aweme_cache_cursors = false,
request_aweme_cache_cursors_dir = "request_aweme_cache_cursors",
request_aweme_static = false,
request_aweme_static_dir = "static_uris",
lives = {},
lives_file,
lives_save = false,
lives_include = false,
metadata = [],
metadata_obj = {},
metadata_each = {},
item_buckets = false,
metadata_buckets = false,
metadata_verbose = false,
metadata_split = false,
metadata_print = false,
metadata_save = false,
metadata_save_obj = false,
metadata_update_obj = false,
metadata_save_each = false,
metadata_update_each = false,
metadata_dirs = false,
metadata_dir_name = "metadata",
metadata_file,
metadata_obj_file,
metadata_obj_initial,
metadata_files = false,
story_dirs = false,
story_dir_name = "stories",
max_depth = 0,
max_resumes = 10,
max_retries = 3,
max_converts = 1,
max_downloads = 10,
max_zips = 3,
queued_zips = [],
active_zips = 0,
fetched_ids = [],
fetched_ids_save = false,
fetched_ids_file,
scraped_ids = [],
scraped_ids_save = false,
scraped_ids_file,
unscraped_ids = [],
unscraped_ids_save = false,
unscraped_ids_file,
ignore_ids = new Set(),
ignore_exts = new Set(),
ignore_ids_save = false,
ignore_ids_file = "ignore_ids.json",
ignore_ids_dir = "ignore_ids",
ignore_ids_initial,
ignore_ids_save_queue = 0,
ignore_ids_save_queued = false,
save_empty = true,
skip_min_views = false,
skip_max_views = false,
skip_live = false,
only_live = false,
skip_photos = false,
only_photos = false,
skip_stories = false,
only_stories = false,
skip_followed = false,
only_followed = false,
skip_uids = false,
skip_uids_file = "skip_uids.txt",
only_uids = false,
only_uids_file = "only_uids.txt",
file_tag_delimiter = "~",
file_tag_default = "",
file_tag_wm = "wm",
file_tag_sd = "sd",
file_tag_verify = "verify",
//it's important that this tag has >= the characters of the other tags,
//there could be a valid file name with a short tag that would be overlong with a longer one
file_tag_hevc = "hevc",
file_tag_h264 = "h264",
file_tag_error = "error",
file_tag_mutual = "mutual",
file_tag_stories = "story",
strip_spaces = false,
tag_uid = false,
tag_unique_id = false,
tag_mutual = false,
tag_stories = false,
tag_wm = true,
tag_sd = false,
download_wm = false,
download_sd = true,
download_hd = false,
fallback_sd = false,
verify_files = false,
rename_hevc = false,
convert_hevc = false,
queued_converts = [],
active_converts = 0,
require_ffprobe = false,
cached_content_lengths = {},
ffmpeg,
ffprobe,
ffmpeg_path,
ffprobe_path,
//ffmpeg_path = "ffmpeg",
//ffprobe_path = "ffprobe",
ffprobe_exts = new Set(["mp4","mp4_sd","mp4_wm"]),
alert_on_download = false,
alert_proc,
alert_args = "{}",
progress_bars = false,
//progress_bars_stream = process.stderr,
progress_bars_stream = process.stdout,
progress_bars_debug = false,
multi_progress,
output_tags = "tiloy",
output_time = Date.now(),
//root_directory = process.cwd(),
root_directory = __dirname,
directory = root_directory + path.sep + "download",
running = true,
timeout = null,
commands_file,
commands_file_cmds,
commands_file_uids,
commands_file_func,
idRegex = /^[1-9][0-9]{0,19}$/,
uidRegex = /^@?[1-9][0-9]{0,19}$/,

aweme_host,
aweme_host_core = "api16-core-c-useast1a.tiktokv.com",
aweme_host_normal = "api16-normal-c-useast1a.tiktokv.com",
aweme_host_stream = "webcast16-normal-c-useast1a.tiktokv.com",

aweme_hosts = [
	"api16-normal-c-useast1a.tiktokv.com",
	"api19-normal-c-useast1a.tiktokv.com",
	"api22-normal-c-useast1a.tiktokv.com"
],

aweme_post_endpoints = new Set([
	"/tiktok/v1/now/feed"
]),

aweme_app = {
	region: "US",

	version_name: "27.3.3",
	version_code: "270303",
	manifest_version_code: "2022703030",

//	os_api: "19",
	os_version: "10",
//	os_api: "33",
//	os_version: "13",

//	aid: 1180,
	aid: 1233,

	iid: "",
	device_id: "6006859028954454735",

	device_version: generateBase62(8)
};
function generateBase62(length) {
	var i = 0, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	while (i < length) {
		r += base62.charAt(Math.floor(Math.random() * 62));
		i++;
	}
	return r;
}
function generateDeviceId() {
	var i = 1, a = new Array(19);//Math.floor(Math.random() * 9) + 11
	a[0] = 54;//Math.floor(Math.random() * 9) + 49
	while (i < a.length) {
		a[i++] = Math.floor(Math.random() * 10) + 48;
	}
	return String.fromCharCode.apply(null, a);
}
function generateVerify() {
	var i = 0, d = new Date(), t = d.getTime() - d.getTimezoneOffset() * 60000, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	do {
		switch (i) {
			case 8:
			case 13:
			case 18:
			case 23:
				r += "_";
				break;
			case 14:
				r += "4";
				break;
			default:
				r += base62.charAt(Math.floor(Math.random() * 62));
				break;
		}
		i++;
	} while (i < 36);
	return "verify_" + t.toString(36) + "_" + r;
}
function generateCookie() {
	return [
		cookie || cookie_format(""),
		"tt_webid=" + aweme_app.device_id,
		"tt_webid_v2=" + aweme_app.device_id,
		"tt_csrf_token=" + generateBase62(24),
		"s_v_web_id=" + generateVerify()
	].join("; ");
}
function getQualityUris(i, host) {
	return [host,...aweme_hosts].map(h => "https://" + h + "/aweme/v1/play/?video_id=" + i + "&line=1&improve_bitrate=1&ratio=default");
//	return aweme_hosts.map(h => "https://" + h + "/aweme/v1/play/?video_id=" + i + "&line=1&improve_bitrate=1&ratio=default");
}
function getWatermarkedUriApi(aweme_id) {
	return "https://tikwm.com/video/media/wmplay/" + aweme_id + ".mp4";
}
function getUriApi(aweme_id) {
	return "https://tikwm.com/video/media/play/" + aweme_id + ".mp4";
}
function getQualityUriApi(aweme_id) {
//	return Array.from(Array(max_retries)).map(() => "https://tikwm.com/video/media/hdplay/" + aweme_id + ".mp4");
	return ["https://tikwm.com/video/media/hdplay/" + aweme_id + ".mp4"];
}
//function getQualityUri(value) {
//	var u = new URL(value), i = u.searchParams.get("video_id");
//	if (i !== null) {
//		return getQualityUris(i, u["host"]);
//	}
//	return [value];
//}
function getUri(i, host) {
	return "https://" + host + "/aweme/v1/play/?video_id=" + i;
}
function createTimeToFilename(value) {
	var t = (new Date(value * 1000)).toISOString();
	return t.substring(0, t.length === 24 ? 19 : 22).replace(/[-:]/g, "") + "Z";
}
function sanitizeFilename(value) {
	var v = value.replace(/[\x00-\x1f"*\/:<>?\\|]/g, "");
	return strip_spaces ? v.replace(/\s+/g, " ").trim() : v;
}
function sanitizeLog(value) {
	return value.replace(/[\r\n]/g, "");
}
function ensureFileDirectorySync(file, callback, log_debug=true) {
	if (debug && log_debug) console_log("check_file_directory: " + file);
	if (!directories_created.has(directory) && !path.isAbsolute(file)) {
		try {
			if (debug && log_debug) console_log("create_directory: " + directory);
			ensureDirectorySync(directory);
			if (debug && log_debug) console_log("change_directory: " + directory);
			process.chdir(directory);
			directories_created.add(directory);
		} catch (e) {
			if (callback !== undefined) {
				callback(e, file);
			} else {
				console_error(e);
			}
			return;
		}
	}
	var file_directory = path.dirname(file);
	if (!directories_created.has(file_directory)) {
		try {
			if (debug && log_debug) console_log("create_directory: " + file_directory);
			ensureDirectorySync(file_directory);
			directories_created.add(file_directory);
		} catch (e) {
			if (callback !== undefined) {
				callback(e);
			} else {
				console_error(e);
			}
			return;
		}
	}
	return null;
}
function ensureDirectorySync(directory) {
	if ((directory = path.normalize(directory)).lastIndexOf(path.sep) + path.sep.length >= directory.length) {
		directory = directory.substring(0, directory.length - path.sep.length);
	}
	try {
		var dir_stats = fs.lstatSync(directory);
		var dirs_stat = new Set();
		while (dir_stats.isSymbolicLink() && !dirs_stat.has(directory)) {
			dirs_stat.add(directory);
			directory = fs.readlinkSync(directory);
			dir_stats = fs.lstatSync(directory);
		}
		if (!dir_stats.isDirectory()) {
			throw new Error("Path is not a directory.");
		}
	} catch (e) {
		if (e.code !== "ENOENT") {
			throw e;
		}
		for (var i = directory.length + path.sep.length, e, t; (i -= path.sep.length) > -1
		&& (i = directory.lastIndexOf(path.sep, i)) > -1
		&& !fs.existsSync(t = directory.substring(0, i));) {}
		if (i > -1) {
			i += path.sep.length;
			e = t.length;
		} else if (directory.substring(0, path.sep.length) === path.sep) {
			t = "";
			i = path.sep.length;
			e = 0;
		} else {//root
			t = "." + path.sep;
			i = 0;
			e = 0;
		}
		for (; (i = directory.indexOf(path.sep, i)) > -1; e = i, i += path.sep.length) {
			fs.mkdirSync(t += directory.substring(e, i));
		}
		fs.mkdirSync(t + directory.substring(e));
	}
}
function emptyFunction() {}
function parseArgv(arguments) {
	var i = 2, e, r = {};
	while (i < arguments.length) {
		e = arguments[i].indexOf("=");
		if (e === -1) {
			r[arguments[i]] = "";
		} else {
			r[arguments[i].substring(0, e)] = arguments[i].substring(e + 1);
		}
		i++;
	}
	return r;
}
function readStdIn(callback) {
	var d = "", s = process.stdin.isTTY ? fs.createReadStream(null, {fd: process.stdin.fd}) : process.stdin;
	s.setEncoding("utf8");
	s.on("data", function(data) {
		d += data;
	}).on("error", function(error) {
		if (callback !== null) {
			callback(error);
			callback = null;
		}
	}).on("end", function() {
		if (callback !== null) {
			callback(null, d);
			callback = null;
		}
	});
	s.resume();
}
function getCmds(value) {
	var i = 0, lr = /(?:\r\n|[\r\n])+/g, m, r = [];
	while ((m = lr.exec(value)) !== null) {
		if (i < lr.lastIndex - m[0].length) {
			r.push(value.substring(i, lr.lastIndex - m[0].length));
		}
		i = lr.lastIndex;
	}
	if (i < value.length) {
		r.push(value.substring(i));
	}
	var cmds = r.filter(v => !v.match(/^\s*#/));
	if (commands_file_uids !== undefined && commands_file_uids.length > 0) {
		var uids = [];
		if (uidRegex.test(commands_file_uids)) {
			uids = [commands_file_uids.replace(/^@/, "")];
		} else {
			try {
				if (commands_file_uids === "clipboard") {
					uids = (require("clipboardy")).readSync();
				} else if (path.extname(commands_file_uids) === ".json") {
					uids = JSON.parse(fs.readFileSync(file_path_absolute(commands_file_uids, root_directory), "utf8"));
				} else {
					uids = fs.readFileSync(file_path_absolute(commands_file_uids, root_directory), "utf8");
				}
				uids = [...new Set(commands_file_func(uids))];
			} catch (e) {
				uids = [];
				console_error(e);
			}
		}
//		if (uids !== undefined && uids.length > 0) {
			var cmds_tmp = [];
			for (var j = 0; j < cmds.length; j++) {
				if (cmds[j].includes("{}")) {
					for (var k = 0; k < uids.length; k++) {
						cmds_tmp.push(cmds[j].replaceAll("{}", uids[k]));
					}
				} else {
					cmds_tmp.push(cmds[j]);
				}
			}
			cmds = cmds_tmp;
//		}
	}
	return cmds;
}
function getIdsJson(ks) {
	return ks.reduce(function(v, k) {
		if (typeof k.aweme_id === "string") {
			v.push(k.aweme_id);
		}
		return v;
	}, []);
}
function getUidsJson(ks) {
	return ks.reduce(function(v, k) {
		if (typeof k.author?.uid === "string") {
			v.push(k.author.uid);
		} else if (typeof k.uid === "string") {
			v.push(k.uid);
		}
		return v;
	}, []);
}
function getUidsLiteral(value) {
	return value.split(/[\r\n]+/).map(line => line.replace(/#.*/, "").trim()).filter(line => line.length > 0);
}
function getIdsSync(value) {
	var i = 0, wr = /\s+/g, ur = /[\/\\]([1-9][0-9]{0,19})/, r = [];
	var m, t;
	while ((m = wr.exec(value)) !== null) {
		if (i < wr.lastIndex - m[0].length) {
			if (uidRegex.test(t = value.substring(i, wr.lastIndex - m[0].length))) {
				r.push(t);
			} else if ((m = t.match(ur)) !== null) {
				r.push(m[1]);
			}
		}
		i = wr.lastIndex;
	}
	if (i < value.length) {
		if (uidRegex.test(t = value.substring(i))) {
			r.push(t);
		} else if ((m = t.match(ur)) !== null) {
			r.push(m[1]);
		}
	}
	return r;
}
function getUidsSync(value) {
	var i = 0, wr = /\s+/g, ur = /[\/\\]@?([1-9][0-9]{0,19})/, r = [];
	var m, t;
	while ((m = wr.exec(value)) !== null) {
		if (i < wr.lastIndex - m[0].length) {
			if (uidRegex.test(t = value.substring(i, wr.lastIndex - m[0].length))) {
				r.push(t.replace(/^@/, ""));
			} else if ((m = t.match(ur)) !== null) {
				r.push(m[1]);
			}
		}
		i = wr.lastIndex;
	}
	if (i < value.length) {
		if (uidRegex.test(t = value.substring(i))) {
			r.push(t.replace(/^@/, ""));
		} else if ((m = t.match(ur)) !== null) {
			r.push(m[1]);
		}
	}
	return r;
}
function splitCmd(value, args) {
	args = args || [];
	for (var i = 0, e, c, t, sr = /[^ ]/g; i < value.length;) {
		switch (value.charCodeAt(i)) {
			case 32:
				sr.lastIndex = i + 1;
				i = (t = sr.exec(value)) !== null ? t.index : value.length;
				break;
			case 34:
				for (i++, e = 0, t = []; i < value.length; i++) {
					if ((c = value.charCodeAt(i)) === 34 && (++i === value.length || value.charCodeAt(i) !== 34)) {
						e = 1;
						break;
					}
					t.push(c);
				}
				if (e === 0) {
					throw new Error("Unescaped quotation mark detected.");
				}
				args.push(String.fromCharCode.apply(null, t));
				break;
			case 39:
				for (i++, e = 0, t = []; i < value.length; i++) {
					if ((c = value.charCodeAt(i)) === 39 && (++i === value.length || value.charCodeAt(i) !== 39)) {
						e = 1;
						break;
					}
					t.push(c);
				}
				if (e === 0) {
					throw new Error("Unescaped apostrophe detected.");
				}
				args.push(String.fromCharCode.apply(null, t));
				break;
			default:
				args.push(value.substring(i, (i = value.indexOf(" ", i + 1)) > -1 ? i : i = value.length));
				break;
		}
	}
	return args;
}
function random_user_agent() {
	return "com.zhiliaoapp.musically/" + Math.random().toString().substr(2,10) + " (Linux; U; Android 7.1.2; en_US; SM-G973N; Build/PPR1.190810.011;tt-ok/3.10.0.2)";
}
function requestGet(uri, headers, callback) {
	try {
		var u = typeof uri === "string" ? new URL(uri) : uri, h, r,
		uri_block = u.host === "www.tikwm.com" || u.host === "tikwm.com" || uri_blocks.has(String(uri)),
		uri_headers = uri_block ? headers : {
			"Cookie": generateCookie(),
			"User-Agent": user_agents_random ? random_user_agent() : user_agent,
			...headers
		};
		if (u.protocol === "http:") {
			h = http;
		} else if (u.protocol === "https:") {
			h = https;
		} else {
			process.nextTick(callback, new Error("Only http and https is supported."));
			return;
		}
		if (debug) console_log("http/get: " + String(uri));
		if (debug) console_log(uri_headers);
		r = h.request({
//			ciphers: ciphers_shuffled,
			method: aweme_post_endpoints.has(u.pathname) ? "POST" : "GET",
			host: u.host,
			port: +u.port || 0,
			path: u.pathname + u.search,//+ u.hash
			timeout: 10000,
//			agent: new h.Agent({
//				keepAlive: true,
//				keepAliveMsecs: 5000
//			}),
			headers: uri_headers
		}, function(response) {
			if (callback === null) {
				return;
			}
			if (debug) console_log("http/"
				+ response.statusCode
				+ (response.headers["content-encoding"] !== undefined ? "=" + response.headers["content-encoding"] : "")
				+ (+response.headers["content-length"] ? " (" + response.headers["content-length"] + " bytes)" : "")
				+ ": " + String(uri)
				+ (response.headers["location"] !== undefined ? " => " + response.headers["location"] : ""));
			if (response.statusCode >= 300 && response.statusCode < 400) {
				var l = response.headers["location"];
				if (l === undefined) {
					callback(new Error("Redirection without location."));
					callback = null;
				} else if (reject_sd && String(uri).includes("tikwm.com/video/media/hdplay/") && l.includes("&btag=80000")) {
					callback(reject_sd_error);
					callback = null;
				} else {
					try {
						var new_uri = new URL(l, String(uri));
						if (uri_block) uri_blocks.add(String(new_uri));
						requestGet(new_uri, headers, callback);
					} catch (e) {
						callback(e);
						callback = null;
					}
				}
				return;
			}
			if (response.statusCode !== 200 && response.statusCode !== 206) {
				callback(new Error(response.statusMessage));
				callback = null;
				return;
			}
			callback(null, response, r, String(uri));
			callback = null;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("timeout", function() {
			r.destroy();
			if (debug) console_log("timed_out: " + String(uri));
		}).end();
	} catch (e) {
		process.nextTick(callback, e);
		return;
	}
}
function content_decoder(encoding) {
	switch(encoding) {
		case "gzip":
			return zlib.createGunzip();
		case "deflate":
			return zlib.createInflate();
		case "br":
			return zlib.BrotliDecompress();
		default:
			return null;
	}
}
function requestGetJson(uri, headers, callback) {
	requestGet(uri, {
		...headers,
		"Accept-Encoding": "gzip, deflate, br"
	}, function(error, response, request) {
		if (error !== null) {
			callback(error);
			return;
		}
		var data_stream, d = "";
		if ((data_stream = content_decoder(response.headers["content-encoding"]))) {
			response.pipe(data_stream);
		} else {
			data_stream = response;
		}
		data_stream.setEncoding("utf8");
		data_stream.on("data", function(data) {
			d += data;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("end", function() {
			if (callback === null) {
				return;
			}
			if (d.length === 0) {
				callback(new Error("Empty response."));
				callback = null;
				return;
			}
//			print_log(d.includes("user_story") + " | " + uri);
			if (debug_data) console_log(d);
			if (log_data) write_log(d);
			try {
				var d2 = d.replace(/([\[:])?(?<![\d.]|\\".)(\d{15,})([,\}\]])/g, "$1\"$2\"$3"); // rancid
				callback(null, JSON.parse(d2));
			} catch (e) {
				try {
					callback(null, JSON.parse(d));
//					console_error(new Error("RegEx for preserving big numbers failed"));
//					fs.writeFileSync("/" + path.basename(__filename) + "_" + output_time + "_pass.json", d);
//					fs.writeFileSync("/" + path.basename(__filename) + "_" + output_time + "_fail.json", d2);
				} catch (e) {
					callback(e);
				}
			}
			callback = null;
		});
	});
}
function getIds(value, callback) {
	var i = 0, wr = /\s+/g, ur = /[\/\\]([1-9][0-9]{0,19})(?:;(v\w{31}\b))?/, r = [], f0 = function() {
		var m, t;
		while ((m = wr.exec(value)) !== null) {
			if (i < wr.lastIndex - m[0].length) {
				if (idRegex.test(t = value.substring(i, wr.lastIndex - m[0].length))) {
					r.push(t);
				} else if ((m = t.match(ur)) !== null) {
					r.push(m[1]);
				} else {
					i = wr.lastIndex;
					f1(t, false);
					return;
				}
			}
			i = wr.lastIndex;
		}
		if (i < value.length) {
			if (idRegex.test(t = value.substring(i))) {
				r.push(t);
			} else if ((m = t.match(ur)) !== null) {
				r.push(m[1]);
			} else {
				f1(t, true);
				return;
			}
		}
		callback(null, r);
	}, f1 = function(uri, last) {
		requestGet(uri, {}, function(error, response, request) {
			var m;
			if (error === null && (m = request.path.match(ur)) !== null) {
				r.push(m[1]);
			}
			if (last) {
				callback(null, r);
			} else {
				f0();
			}
		});
	};
	process.nextTick(f0);
}
function getVideoUrlList(value) {
	var v;
	if (hevc) {
		v = value.video?.play_addr_265?.url_list;
		if (typeof v === "object" && v !== null && v.length > 0) return v;
		v = value.video?.play_addr_bytevc1?.url_list;
		if (typeof v === "object" && v !== null && v.length > 0) return v;
	}
	v = value.video?.play_addr?.url_list;
	return typeof v === "object" && v !== null && v.length > 0 ? v : null;
}
function getVideoWatermarked(value) {
	var v = value.video?.download_addr?.url_list;
	return typeof v === "object" && v !== null && v.length > 0 ? v : null;
}
function getVideoThumbnail(value) {
	var v = value.video?.cover?.url_list;
	return typeof v === "object" && v !== null && v.length > 0 ? v : null;
}
function getVideoThumbnailAnimated(value) {
	var v = value.video?.dynamic_cover?.url_list;
	return typeof v === "object" && v !== null && v.length > 0 ? v : null;
}
function getVideoAudio(value) {
	var v = value.music?.play_url?.url_list;
	return typeof v === "object" && v !== null && v.length > 0 ? v : null;
}
function getVideoNowImages(value) {
	return [
		"front_image",
		"back_image"
	].map(v => value.now_posts[v]?.url_list)
	.filter(v => typeof v === "object" && v !== null && v.length > 0)
	.map(v => v[v.length - 1]);
}
function getVideoImages(value) {
	var v = value.image_post_info?.images;
	return typeof v === "object" && v !== null ? getVideoImageLinks(v) : null;
}
function getVideoImageLinks(value) {
	return value
	.map(v => v.display_image?.url_list)
	.filter(v => typeof v === "object" && v !== null && v.length > 0)
	.map(v => v[v.length - 1]);
}
function downloadAweme(filename, uri, test_file_bytes, callback) {
	var f = function(error, repeat) {
		if (error === reject_sd_error || repeat > 3 || !running) {
			callback(error !== null ? error : new Error("Exited unexpectedly."));
		} else {
			requestGet(uri, test_file_bytes ? {
				"Range": "bytes=" + magic_bytes_start + "-" + magic_bytes_end
			} : {}, function(error, response, request) {
				if (error === null) uri = request.protocol + "//" + request.host + request.path;
				if (error !== null) {
					f(error, repeat + 1);
				} else if (!+response.headers["content-length"]) {
					f(new Error("Response body is empty."), repeat + 1);
				} else if (test_file_bytes) {
					var file_bytes = "";
					response.on("data", function(data) {
						file_bytes += data.toString("hex");
					}).on("end", function() {
						if (debug) console_log("test_file_bytes: " + file_bytes + " | " + (file_bytes === magic_bytes) + " | " + filename);
						if (file_bytes === magic_bytes) {
							test_file_bytes = false;
							f(null, 0);
						} else {
							callback(new Error("Mundane bytes."));
						}
					}).on("error", function(error) {
						callback(error);
					});
				} else if (cached_content_lengths.hasOwnProperty(filename) && cached_content_lengths[filename] === +response.headers["content-length"]) {
					request.destroy();
					callback(new Error("Broken file."));
				} else {
					var progress = 0,
					progress_max,
					progress_idx,
					progress_bar,
					file_size = +response.headers["content-length"],
					file_size_pretty = printSize(file_size);
					print_log("downloading: " + filename);
					if (progress_bars) {
						progress_max = multi_progress.stream.rows;
						progress_idx = multi_progress.cursor;
						progress_bar = multi_progress.newBar(output_line("[:bar] :percent | :progress_pretty / :file_size_pretty", progress_idx+1, "~"), {
							renderThrottle: 60,
							width: 10,
							total: file_size
						});
					}
					var attempt_download = function(response, request, attempts=0) {
						var stream = fs.createWriteStream(filename, {flags: "a", start: progress}),
						stream_running = true,
						stream_finish = function() {
							if (stream_running === true) {
								stream_running = false;
								request.destroy();
								stream.close();
								if (progress_bars && (multi_progress.bars.length-progress_idx) < progress_max) {
									multi_progress.move(progress_idx);
									progress_bar.render(undefined, true);
//									progress_bar.terminate();
								}
							}
						};
						if (attempts !== 0) {
							console_log("resuming: " + filename + " | " + attempts + " / " + max_resumes);
						}
						stream.on("close", function() {
							stream_running = false;
//							console_log("check_size: " + filename);
							fs.stat(filename, function(error, stats) {
								if (error !== null) {
									f(error, repeat + 1);
								} else if (stats.size !== file_size) {
									progress = stats.size;
									console_log("mismatch: " + filename + " | " + printSize(progress) + " / " + file_size_pretty);
									re_attempt_download(new Error("File size doesn't match content-length."), attempts + 1);
								} else if (callback !== null) {
									cached_content_lengths[filename] = file_size;
									callback(null);
								}
							});
						}).on("error", stream_finish);
						response.on("data", function(data) {
							if (progress_bars && (multi_progress.bars.length-progress_idx) < progress_max) {
								progress += Buffer.byteLength(data);
								progress_bar.update(progress/file_size, {
									progress_pretty: printSize(progress),
									file_size_pretty: file_size_pretty
								});
							}
							stream.write(data);
							if (!running) {
//								running = true;
								stream_finish();
							}
						}).on("end", stream_finish).on("error", stream_finish);
						request.removeAllListeners("timeout").on("timeout", function() {
							stream_finish();
							if (debug) console_log("timed_out: " + filename);
						});
//						request.setTimeout(1000);
					},
					re_attempt_download = function(error, attempts) {
						if (attempts > max_resumes || progress > file_size || !running) {
							fs.unlink(filename, function() {
								f(error, repeat + 1);
							});
						} else {
//							setTimeout(function() {
								requestGet(uri, {
									"Range": "bytes=" + progress + "-"
								}, function(error, response, request) {
									if (error !== null) {
										re_attempt_download(error, repeat + 1);
									} else {
										attempt_download(response, request, attempts);
									}
								});
//							}, 1000);
						}
					};
					attempt_download(response, request);
				}
			});
		}
	};
	f(null, 0);
}
function file_bucket(v) {
	return v.length === 19 ? "-".repeat(16) + v.slice(-3) : "~" + v.slice(-1);
}
function file_name(video, file_ext, file_tag, add_description=false, windows_long_path=false, metadata_dir=false) {
	var file_sub_dirs = [];
	if (metadata_dir && metadata_dirs && path.isAbsolute(metadata_dir_name)) file_sub_dirs.push(metadata_dir_name);
	else if (video.is_story && story_dirs && path.isAbsolute(story_dir_name)) file_sub_dirs.push(story_dir_name);
	if (uid_directories) file_sub_dirs.push("@" + video.uid);
	if (metadata_dir && metadata_dirs) {
		if (!path.isAbsolute(metadata_dir_name)) file_sub_dirs.push(metadata_dir_name);
	}
	else if (video.is_story && story_dirs && !path.isAbsolute(story_dir_name)) file_sub_dirs.push(story_dir_name);
	if (item_buckets || (metadata_dir && metadata_buckets)) file_sub_dirs.push(file_bucket(video.id));
	var file_dir = file_sub_dirs.join(path.sep);
	if (file_ext === "mp4_wm") {
		file_ext = "mp4";
		if (tag_wm) file_tag = file_tag_wm + (file_tag_wm.length > 0 && file_tag.length > 0 ? file_tag_delimiter : "") + file_tag;
	} else if (file_ext === "mp4_sd") {
		file_ext = "mp4";
		if (tag_sd) file_tag = file_tag_sd + (file_tag_sd.length > 0 && file_tag.length > 0 ? file_tag_delimiter : "") + file_tag;
	}
	var photo_dir = "", photo_tag = "";
	if (typeof file_ext === "object" && file_ext !== null) {
		if (!flat_photos) photo_dir = video.id;
		[photo_tag, file_ext] = file_ext;
	}
	var base_file_name = function(v) {
		return video.id
		+ (tag_uid && video.uid.length > 0 ? "@" + video.uid : "")
		+ (tag_unique_id && video.unique_id.length > 0 ? "@" + video.unique_id : "")
		+ (d.length > 0 ? " " + d : "")
		+ (v.length > 0 ? " " + v : "")
		+ (tag_mutual && video.is_mutual ? file_tag_delimiter + file_tag_mutual : "")
		+ (tag_stories && video.is_story ? file_tag_delimiter + file_tag_stories : "")
		+ (photo_dir.length > 0 ? path.sep + photo_dir : "")
		+ (photo_tag.length > 0 ? file_tag_delimiter + photo_tag : "")
		+ (file_tag.length > 0 ? file_tag_delimiter + file_tag : "")
		+ "." + file_ext;
	},
	d = date && video.time > 0 ? createTimeToFilename(video.time) : "",
	t = add_description && video.desc.length > 0 ? sanitizeFilename(video.desc) : "",
	n = base_file_name(t);
	if (description_limit > 0 && t.length > 0 && Buffer.byteLength(n) > description_limit) {
		t = t.substring(0, description_limit - base_file_name("").length).trim();
		n = base_file_name(t);
		while (t.length > 0 && Buffer.byteLength(n) > description_limit) {
			t = t.slice(0, -1).trim();
			n = base_file_name(t);
		}
	}
	if (file_dir.length > 0) {
		n = file_dir + path.sep + n;
	}
	if (windows_long_path !== false) {
//		https://docs.microsoft.com/en-us/windows/win32/fileio/maximum-file-path-limitation
		n = "\\\\\?\\" + file_path_absolute(n);
	}
	return n;
}
function ensureAweme(video, file_ext, callback) {
	var add_description = description && video.desc.length > 0 && typeof file_ext !== "object",
	ffprobe_file = require_ffprobe && ffprobe_exts.has(file_ext),
	file_tag = verify_files ? file_tag_verify : file_tag_default,
	file = file_name(video, file_ext, file_tag, add_description),
	file_whole = file,
	file_trimmed = false;
	if (add_description) {
		if (Buffer.byteLength(path.basename(file)) > 255) {
			file = file_name(video, file_ext, file_tag, add_description = false);
		} else if (windows_paths && file_path_absolute(file).length > windows_max_path) {
			file = file_name(video, file_ext, file_tag, add_description = false);
			file_trimmed = true;
		}
	}
	if (file_ext === "mp4" && (video.is_now || video.is_story)) {
		callback(reject_sd_error, file);
		return;
	}
	if (ensureFileDirectorySync(file, callback) !== null) return;
	var uris = video[file_ext],
	download_attempt = 1,
	download_attempts = typeof uris !== "object" ? max_retries : uris.length*2-1,
	test_file_exists = function(test_file, cb_exists) {
		fs.access(test_file, function(error) {
			if (debug) console_log("test_file_exists: " + test_file);
			if (error === null) {
				if (debug) console_log("file_exists: " + test_file);
				file = test_file;
				cb_exists(true);
			} else if (error.code === "ENOENT" || error.code === "ENAMETOOLONG") {
				cb_exists(false);
			} else {
				callback(error, test_file);
			}
		});
	}, test_file_desc = function(test_tag, cb_exists) {
		test_file_exists(file_name(video, file_ext, test_tag, add_description), function(exists) {
			if (!exists && add_description) {
				test_file_exists(file_name(video, file_ext, test_tag, false), function(exists) {
					if (exists) add_description = false;
					cb_exists(exists);
				});
			} else {
				cb_exists(exists);
			}
		});
	}, test_file_default = () => new Promise(resolve => {
		test_file_desc(file_tag_default, function(exists) {
			if (exists) callback(null, file, true);
			resolve(exists);
		});
	}), test_file_hevc = () => new Promise(resolve => {
		test_file_desc(file_tag_hevc, function(exists) {
			if (exists) callback(null, file, true);
			resolve(exists);
		});
	}), test_file_verify = () => new Promise(resolve => {
		test_file_desc(file_tag_verify, function(exists) {
			if (exists) {
				download_attempt--;
				if (ffprobe_file) verify_file();
				else fail_file();
			}
			resolve(exists);
		});
	}), test_file_create = function() {
		fs.open(file, "w", function(error, fd) {
			if (debug) console_log("test_file_create: " + file);
			if (error !== null) {
				if (debug) console_log("fail_file_create: " + file);
				file = file_name(video, file_ext, file_tag, add_description = false);
				download_file();
			} else {
				fs.close(fd, function(error) {
					fs.unlink(file, download_file);
				});
			}
		});
	}, download_file = function() {
		if (file_ext === "mp4" && (video.is_now || video.is_story || video.is_mutual || video.is_private)) {
			callback(reject_sd_error, file);
			return;
		}
		var uri = typeof uris !== "object" ? uris : uris[(download_attempt-1) % uris.length],
		test_file_bytes = file_ext === "mp4" && test_magic_bytes;
		if (test_file_bytes && !(test_file_bytes = uris.length > download_attempt-1)) {
			console_log("retrying (" + (download_attempt-1) + "/" + download_attempts + "): " + file);
		}
		if (download_attempt === 1 && file !== file_whole) {
			if (file_trimmed) {
				print_log("path too long: " + file_whole);
			} else {
				print_log("name too long: " + file_whole);
			}
		}
		downloadAweme(file, uri, test_file_bytes, function(error) {
			if (error !== null) {
				re_download_file(error, file);
			} else if (verify_files) {
				if (ffprobe_file) verify_file();
				else {
					var new_file = file_name(video, file_ext, file_tag_default, add_description);
					fs.rename(file, new_file, function(rename_error) {
						re_download_file(rename_error, new_file);
					});
				}
			} else {
				callback(null, file);
			}
		});
	}, re_download_file = function(error, file) {
		if (error === null) {
			callback(null, file);
		} else if (error === reject_sd_error || download_attempt++ > download_attempts || !running) {
//			print_log("abandoning: " + file);
			callback(error, file);
		} else {
			download_file();
		}
	}, verify_file = function(windows_long_path=false) {
		var probe_file = file_name(video, file_ext, file_tag_verify, add_description, windows_long_path);
		ffprobe(probe_file, {path: ffprobe_path}, function(error, response) {
			if (debug) console_log("verify_file: " + probe_file);
//			error = new Error("fail_verify: " + probe_file);
			if (error !== null) {
				if (windows_long_path === false && process.platform === "win32") {
					verify_file(true);
				} else {
					fail_file(error);
				}
			} else if (typeof response !== "object" || response === null
			|| typeof response.streams !== "object" || response.streams === null
			|| response.streams.length === 0) {
				fail_file(new Error(probe_file));
			} else {
				var is_hevc = ffprobe_file && (rename_hevc || convert_hevc) && response.streams.some(v => v.codec_type === "video" && v.codec_name === "hevc");
				var new_file_tag = is_hevc && rename_hevc ? file_tag_hevc : file_tag_default;
				var new_file = file_name(video, file_ext, new_file_tag, add_description, windows_long_path);
				fs.rename(file, new_file, function(rename_error) {
					re_download_file(rename_error, new_file);
					if (rename_error === null && is_hevc && convert_hevc) {
						convert_file(new_file, file_name(video, file_ext, file_tag_h264, add_description, windows_long_path));
					}
				});
			}
		});
	}, fail_file = function(error) {
		var error_file = file_name(video, file_ext, file_tag_error, add_description);
		fs.rename(file, error_file, function(rename_error) {
			if (rename_error !== null) {
				console_error(rename_error);
			} else {
				print_log("renamed: " + error_file);
			}
			re_download_file(error, file);
		});
	}, convert_file = function(input_file, output_file) {
		if (active_converts >= max_converts) {
			queued_converts.push(arguments);
		} else {
			active_converts++;
			var queue_next = function() {
				active_converts--;
				if (queued_converts.length > 0) {
					convert_file(...queued_converts.shift());
				}
			};
			fs.access(output_file, function(error) {
				if (debug) console_log("test_file_exists: " + output_file);
				if (error !== null) {
					if (error.code !== "ENOENT") {
						console_error(error);
						queue_next();
					} else {
						if (debug) console_log("file_exists: " + output_file);
						print_log("converting: " + input_file);
						var proc = child_process.spawn(ffmpeg_path, [
							"-i", input_file,
							"-map", "0",

							"-c:v", "libx264",
//							"-crf", "18",
							"-crf", "23",
//							"-preset", "veryslow",
							"-preset", "veryfast",

//							"-c:v", "h264_nvenc",
//							"-cq", "21",

							"-pix_fmt", "yuv420p",
							"-b:v", "0",
							"-c:a", "copy",
							"-movflags", "+faststart+use_metadata_tags",
							output_file
						], {stdio: "ignore", detached: true}); // unlink it from the node process, in case that's closed for some reason while ffmpeg is still converting
						proc.on("close", function() {
							print_log("converted: " + output_file);
							queue_next();
						});
					}
				} else {
					queue_next();
				}
			});
		}
	};
	(async () => {
		if (ffprobe_file && rename_hevc && await test_file_hevc()) return;
		if (await test_file_default()) return;
		if (verify_files && await test_file_verify()) return;
		if (add_description) test_file_create();
		else download_file();
	})();
}
function ensureFile(video, file_name_generator, callback) {
	var add_description = description && video.desc.length > 0,
	file = file_name_generator(add_description),
	file_whole = file,
	file_trimmed = false;
	if (add_description) {
		if (Buffer.byteLength(path.basename(file)) > 255) {
			file = file_name_generator(add_description = false);
		} else if (windows_paths && file_path_absolute(file).length > windows_max_path) {
			file = file_name_generator(add_description = false);
			file_trimmed = true;
		}
	}
	if (ensureFileDirectorySync(file, callback) !== null) return;
	var test_file_exists = function(test_file, cb_exists) {
		fs.access(test_file, function(error) {
			if (debug) console_log("test_file_exists: " + test_file);
			if (error === null) {
				if (debug) console_log("file_exists: " + test_file);
				file = test_file;
				cb_exists(true);
			} else if (error.code === "ENOENT" || error.code === "ENAMETOOLONG") {
				cb_exists(false);
			} else {
				callback(error, test_file);
			}
		});
	}, test_file_desc = function(cb_exists) {
		test_file_exists(file_name_generator(add_description), function(exists) {
			if (!exists && add_description) {
				test_file_exists(file_name_generator(false), function(exists) {
					if (exists) add_description = false;
					cb_exists(exists);
				});
			} else {
				cb_exists(exists);
			}
		});
	}, test_file_default = function() {
		test_file_desc(function(exists) {
			if (exists) callback(null, file, true);
			else if (add_description) test_file_create();
			else download_file();
		});
	}, test_file_create = function() {
		fs.open(file, "w", function(error, fd) {
			if (debug) console_log("test_file_create: " + file);
			if (error !== null) {
				if (debug) console_log("fail_file_create: " + file);
				file = file_name_generator(add_description = false);
				download_file();
			} else {
				fs.close(fd, function(error) {
					fs.unlink(file, download_file);
				});
			}
		});
	}, download_file = function() {
		if (file !== file_whole) {
			if (file_trimmed) {
				print_log("path too long: " + file_whole);
			} else {
				print_log("name too long: " + file_whole);
			}
		}
		callback(null, file);
	};
	test_file_default();
}
function encryptParams(v) {
	var cipher = crypto.createCipheriv("aes-128-cbc", "webapp1.0+202106", "webapp1.0+202106");
	var encrypted = cipher.update(v, "utf8", "base64");
	return encrypted + cipher.final("base64");
}
function decryptParams(v) {
	var decipher = crypto.createDecipheriv("aes-128-cbc", "webapp1.0+202106", "webapp1.0+202106");
	var decrypted = decipher.update(v, "base64", "utf8");
	return decrypted + decipher.final("utf8");
}
function requestTiktok(uri, headers, callback) {
	var f = function(error, repeat) {
		if (repeat > 9 || (ignore_errors && repeat > 0) || !running) {
			callback(error !== null ? error : new Error("Exited unexpectedly."));
			return;
		}
		requestGetJson("https://m.tiktok.com" + uri, {
			"Referer": "https://m.tiktok.com/",
			"User-Agent": "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36",
			...headers
		}, function(error, data) {
			if (error !== null) {
				f(error, repeat + 1);
			} else if (typeof data !== "object" || data === null || typeof data.statusCode !== "number" || data.statusCode !== 0) {
				f(new Error("Unexpected response."), repeat + 1);
			} else {
				if (debug_data) console_log(data);
				callback(null, data);
			}
		});
	};
	f(null, 0);
}
function hash_string(v) {
	return crypto.createHash("md5").update(v).digest("hex");
}
function signAwemeCachedFile(uri) {
	var request_aweme_cache_file = request_aweme_cache_dir + path.sep + hash_string(uri) + ".json";
	return file_path_absolute(request_aweme_cache_file, root_directory);
}
function signAwemeCached(uri) {
	try {
		return JSON.parse(fs.readFileSync(signAwemeCachedFile(uri), "utf8"));
	} catch (e) {}
}
function signAwemeCache(uri, uri_full, f0, callback) {
	signAweme(path.basename(uri_full).substring(1), function(error, headers) {
		if (error !== null) {
			callback(error, undefined, uri);
		} else {
			f0(uri_full, headers);
			var request_aweme_cache_file = signAwemeCachedFile(uri);
			writeFileDirectorySync(request_aweme_cache_file, JSON.stringify({
				"uri": uri_full,
				"x-argus": headers["X-Argus"],
				"x-ladon": headers["X-Ladon"]
			}), function() {
				if (debug) console_log("sign_aweme_save: " + uri + " => " + request_aweme_cache_file);
			});
		}
	});
}
function signAweme(params, callback) {
	setTimeout(requestGetJson, 1000, "https://www.tikwm.com/api/service/sign?params=" + encodeURIComponent(params), {}, function(error, data) {
		if (error === null) {
			if (typeof data !== "object" || data === null || typeof data.code !== "number") {
				error = new Error("Unexpected response.");
			} else if (data.code !== 0) { // success
				error = new Error(data.code + (typeof data.msg === "string" && data.msg.length > 0 ? " (" + data.msg + ")" : ""));
			}
		}
		callback(error, data?.data);
	});
}
function requestAweme(host, uri, callback) {
	var f = function(error, repeat) {
		if (repeat > (cycle_hosts ? aweme_hosts.length*3 : 9) || !running) {
			callback(error !== null ? error : new Error("Exited unexpectedly."), undefined, uri);
			return;
		}
		if (cycle_hosts && repeat > 0) host = aweme_hosts[(repeat-1) % aweme_hosts.length];
		var u, f0 = function(uri_full, headers) {
			requestGetJson("https://" + host + uri_full, headers, function(error, data) {
				if (error === null) {
					if (typeof data !== "object" || data === null || typeof data.status_code !== "number") {
						error = new Error("Unexpected response.");
					} else if (![
						0, // success
//						4, // server is currently unavailable
						5, // invalid parameters
						7, // permission denied (user likes)
						8, // login expired (stories)
						2053, // video has been removed (details)
						10011, // bad params (livestream)
						20003, // not logged in (livestream)
						30001, // livestream room doesn't exist
						30003 // livestream ended
					].includes(data.status_code)) {
						error = awemeError(data);
					}
				}
				if (error !== null) {
					aweme_app.device_version = generateBase62(8);
					f(error, repeat + 1);
				} else {
					if (debug_data) console_log(data);
					callback(null, data, uri);
				}
			});
		};
		if ((u = request_aweme_static)
		|| (request_aweme_cache && (u = signAwemeCached(uri)))) {
			if (debug) console_log("sign_aweme_load: " + u.uri);
			f0(u.uri, {
				"X-Argus": u["x-argus"],
				"X-Ladon": u["x-ladon"]
			});
		} else {
			var d = new Date(),
			t = d.getTime() - d.getTimezoneOffset() * 60000,
			ts = Math.floor(t / 1000),
			uri_full = uri
			+ "&address_book_access=1"

			+ "&ac=wifi"
			+ "&ac2=wifi"
			+ "&app_language=en"
			+ "&app_name=musical_ly"
			+ "&app_type=normal"
			+ "&channel=googleplay"
			+ "&cpu_support64=false"
			+ "&device_brand=google"
			+ "&device_platform=android"
			+ "&dpi=441"
			+ "&language=en"
			+ "&locale=en"
			+ "&pass-region=1"
			+ "&pass-route=1"
			+ "&resolution=1080*1920"
			+ "&ssmix=a"
			+ "&timezone_name=Etc%2FGMT"
			+ "&timezone_offset=0"
			+ "&uoo=0"

//			+ "&carrier_region_v2="
//			+ "&cdid="
//			+ "&host_abi="
//			+ "&mcc_mnc="
//			+ "&openudid="

			+ "&carrier_region=" + aweme_app.region
			+ "&current_region=" + aweme_app.region
			+ "&op_region=" + aweme_app.region
			+ "&region=" + aweme_app.region
			+ "&sys_region=" + aweme_app.region

			+ "&manifest_version_code=" + aweme_app.manifest_version_code
			+ "&update_version_code=" + aweme_app.manifest_version_code
			+ "&version_code=" + aweme_app.version_code

			+ "&ab_version=" + aweme_app.version_name
			+ "&build_number=" + aweme_app.version_name
			+ "&version_name=" + aweme_app.version_name

//			+ "&os_api=" + aweme_app.os_api
			+ "&os_version=" + aweme_app.os_version

			+ "&aid=" + aweme_app.aid
//			+ "&iid=" + aweme_app.iid
			+ (request_aweme_iid ? "&iid=" + (aweme_app.iid || generateDeviceId()) : "")
			+ "&device_id=" + aweme_app.device_id
			+ "&device_type=Pixel%20" + aweme_app.device_version

			+ "&_rticket=" + t
			+ "&ts=" + ts;
			if (request_aweme_cache) {
				if (debug) console_log("sign_aweme_queue: " + uri);
				signAwemeCache(uri, uri_full, f0, callback);
			} else if (request_aweme_sign) {
				f0(uri_full, request_aweme_sign_func(path.basename(uri_full).substring(1), ts, generateCookie()));
			} else {
				f0(uri_full, {});
			}
		}
	};
	f(null, 0);
}
function awemeError(data) {
	var status_message = [data.status_msg, data.data?.message].find(v => typeof v === "string" && v.length > 0);
	return new Error(data.status_code + (status_message ? " (" + status_message + ")" : ""));
}
function download_item(video, download) {
	if (metadata_save_each && typeof metadata_each[video.id] === "object" && metadata_each[video.id]) {
		metadata_save_each_to_file(video);
	}
	download_exts
	.filter(file_ext => video[file_ext] && !ignored_file(video.id, file_ext))
	.forEach(file_ext => download(video, file_ext));
	if (download_videos && video["images"] && video["images"].length > 0) {
		if (!zip_photos) {
			download_photos(video, download);
		} else if (!ignored_file(video.id, "zip")) {
			download_zip_photos(video);
		}
	}
}
function download_photos(video, download) {
	var file_ext, pad_len = Math.max(2, (video.images.length+1).toString().length);
	if (video["mp3"]) {
		video[file_ext = [
			"",
			"mp3"
		]] = video["mp3"];
		download(video, file_ext);
	}
	for (var j = 0; j < video.images.length; j++) {
		video[file_ext = [
			(j+1).toString().padStart(pad_len, "0"),
			"jpg"
		]] = video.images[j];
		download(video, file_ext);
	}
}
function download_zip_photos(video) {
	if (active_zips >= max_zips) {
		queued_zips.push(arguments);
	} else {
		active_zips++;
		var queue_next = function(error) {
			if (error !== undefined && error !== null) {
				console_error(error);
			}
			active_zips--;
			if (queued_zips.length > 0) {
				download_zip_photos(...queued_zips.shift());
			}
		};
		ensureFile(video, add_description => file_name(video, "zip", file_tag_default, add_description), function(error, file, exists) {
			if (error !== null) {
				console_error(error);
				queue_next();
			} else if (exists) {
				ignore_file(video.id, "zip");
				queue_next();
			} else {
				print_log("downloading: " + file);
				var items = new Set(),
				item_dirs = new Set(),
				item_count = 0;
				download_photos(video, function(video, file_ext) {
					item_count++;
					ensureAweme(video, file_ext, function(error, item, exists) {
						if (error !== null) {
							if (debug || error !== reject_sd_error) print_log("failed: " + item + " | " + error.message);
							queue_next();
						} else {
							items.add(item);
							item_dirs.add(path.dirname(item));
							if (item_count === items.size) {
								item_dirs.forEach(function(item_dir) {
									fs.readdirSync(item_dir).forEach(function(item_name) {
										var item = item_dir + path.sep + item_name;
										if (items.has(item)) {
											item_count--;
										} else {
											item_count = -1;
											console_error("non_photo_file: " + item);
										}
									});
								});
								if (item_count === 0) {
									var output = fs.createWriteStream(file),
									archive = archiver("zip"),
									archive_finish = function() {
										ignore_file(video.id, "zip");
										print_log("downloaded: " + file);
										queue_next();
										items.forEach(function(item) {
											if (debug) console_log("file_delete: " + item);
											fs.unlink(item, function(error) {
												if (error !== null) {
													console_error(error);
												} else {
													if (debug) console_log("file_deleted: " + item);
													item_count++;
													if (item_count === items.size) {
														item_dirs.forEach(function(item_dir) {
															if (debug) console_log("dir_delete: " + item_dir);
															fs.rmdir(item_dir, function(error) {
																if (error !== null) {
																	console_error(error);
																} else if (debug) {
																	console_log("dir_deleted: " + item_dir);
																}
															});
														});
													}
												}
											});
										});
									};
									output.on("end", archive_finish);
									output.on("close", archive_finish);
									output.on("error", queue_next);
									output.on("warning", queue_next);
									archive.pipe(output);
									item_dirs.forEach(function(item_dir) {
										archive.directory(item_dir, false);
									});
									archive.finalize();
								} else {
									queue_next();
								}
							}
						}
					});
				});
			}
		});
	}
}
function register_error(video, file_ext, download) {
	if (fallback_sd && file_ext === "mp4" && video["mp4_sd"] && !ignored_file(video.id, "mp4_sd")) {
		download(video, "mp4_sd");
	}
}
function register_download(video, file_ext, file) {
	if (fallback_sd && file_ext === "mp4") delete_file(video, "mp4_sd", file_tag_default);
	if (verify_files) delete_file(video, file_ext, file_tag_error);
	if (alert_on_download) {
		try {
			child_process.spawn(alert_proc, [
//				alert_args.replaceAll("{}", file)
				alert_args.replaceAll("{}", file_path_absolute(file))
			], {stdio: "ignore", detached: true}).unref();
		} catch (e) {
			console_error(e);
		}
	}
}
function delete_file(video, file_ext, file_tag) {
	var file = file_name(video, file_ext, file_tag, description);
	fs.unlink(file, function(error) {
		if (debug) console_log("test_file_delete: " + file);
		if (error === null) {
			print_log("deleted: " + file);
		} else if (description && video.desc.length > 0) {
			fs.unlink(file = file_name(video, file_ext, file_tag), function(error) {
				if (debug) console_log("test_file_delete: " + file);
				if (error === null) {
					print_log("deleted: " + file);
				}
			});
		}
	});
}
function downloadVideosMulti(ids, callback=emptyFunction) {
	ids = [...new Set(ids)];
	if (fetched_ids_save || unscraped_ids_save) fetched_ids = ids;
	if (ignore_ids_save && ignore_ids.size > 0) ids = ids.filter(id => !ignored_id(id));
	var a = 0, i = 0, e = 0, y = 0, c = 0, m = ids.length > 0 && !fetch_only, v = [], cursor_printed, cursor_start, cursor_end, f0 = function() {
		if (running) {
			while (download_files && i < v.length && e < max_downloads) {
				download_item(v[i++], f1);
			}
			if (m && e < max_downloads) {
				m = false;
				a++;
				print_cursor();
				requestAweme(aweme_host, "/aweme/v1/multi/aweme/detail/?aweme_ids=[" + ids.slice(c, c + count).join() + "]", f2);//+ "origin_type="//+ "push_params="
			}
		}
		if (a === 0 && e === 0) {
			a--;
			print_cursor();
			save_to_files();
			callback(null);
		}
	}, print_cursor = function() {
		if (cursor_print && cursor_printed !== String([c,y])) {
			cursor_printed = String([c,y]);
			console_log("cursor: " + c + "/" + ids.length);
			console_log("item count: " + y + (limit > 0 ? "/" + limit + (break_limit ? "+" : "") : ""));
			if (cursor_times) {
				cursor_end = Date.now();
				if (c !== cursor) console_log("duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f1 = function(video, file_ext) {
		e++;
		ensureAweme(video, file_ext, function(error, file, exists) {
			if (error !== null) {
				if (debug || error !== reject_sd_error) print_log("failed: " + file + " | " + error.message);
				register_error(video, file_ext, f1);
			} else {
				ignore_file(video.id, file_ext);
				if (!exists) {
					print_log("downloaded: " + file);
					register_download(video, file_ext, file);
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				m = true;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			} else {
				console_error(error);
			}
		} else {
			c = Math.min(c+count, ids.length);
			m = c < ids.length;
			ignore_errors_count = 0;
			if (typeof data === "object" && data !== null
			&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
				for (var j = 0, video; j < data.aweme_details.length; j++) {
					if ((video = video_format(data.aweme_details[j], data.extra.now)) === null) continue;
					if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
					v.push(video);
					if (++y === limit) {
						m = false;
						if (!break_limit) break;
					}
				}
			}
		}
		a--;
		f0();
	};
	if (download_videos_tikwm) {
		print_cursor();
		m = false;
		c = ids.length;
		y = ids.length;
		v = ids.map(id => video_format_tikwm(id));
	}
	f0();
}
function downloadVideos(ids, callback=emptyFunction) {
	ids = [...new Set(ids)];
	if (fetched_ids_save || unscraped_ids_save) fetched_ids = ids;
	if (ignore_ids_save && ignore_ids.size > 0) ids = ids.filter(id => !ignored_id(id));
	var a = 0, i = 0, e = 0, y = 0, c = 0, m = ids.length > 0 && !fetch_only, v = [], error_queue = [], error_queued = {}, cursor_printed, cursor_start, cursor_end, f0 = function() {
		if (running) {
			while (download_files && i < v.length && e < max_downloads) {
				download_item(v[i++], f1);
			}
			while (m && a < max_downloads && error_queue.length > 0) {
				a++;
				requestAweme(aweme_host, error_queue.shift(), f2);
			}
			while (m && a < max_downloads && c < ids.length) {
				a++;
				if (c % max_downloads === 0) print_cursor();
				requestAweme(aweme_host, "/aweme/v1/aweme/detail/?aweme_id=" + ids[c++], f2);
			}
		}
		if (a === 0 && e === 0) {
			a--;
			print_cursor();
			save_to_files();
			callback(null);
		}
	}, print_cursor = function() {
		if (cursor_print && cursor_printed !== String([c,y])) {
			cursor_printed = String([c,y]);
			console_log("cursor: " + c + "/" + ids.length);
			console_log("item count: " + y + (limit > 0 ? "/" + limit + (break_limit ? "+" : "") : ""));
			if (cursor_times) {
				cursor_end = Date.now();
				if (c !== cursor) console_log("duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f1 = function(video, file_ext) {
		e++;
		ensureAweme(video, file_ext, function(error, file, exists) {
			if (error !== null) {
				if (debug || error !== reject_sd_error) print_log("failed: " + file + " | " + error.message);
				register_error(video, file_ext, f1);
			} else {
				ignore_file(video.id, file_ext);
				if (!exists) {
					print_log("downloaded: " + file);
					register_download(video, file_ext, file);
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data, uri) {
		var detail = get_detail(data, "aweme_detail");
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
				error_queue.push(uri);
			} else {
				m = false;
				if (debug) console_error(error);
			}
		} else if (typeof detail !== "object" || detail === null) {
			if (!error_queued.hasOwnProperty(uri)) error_queued[uri] = 0;
			if (3 > ++error_queued[uri]) error_queue.push(uri);
			else if (debug) print_error("missing: " + uri);
		} else if (m || break_limit) {
			ignore_errors_count = 0;
			var video = video_format(detail, data.extra.now);
			if (video !== null) {
				if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
				v.push(video);
				if (++y === limit) m = false;
			}
		}
		a--;
		f0();
	};
	if (download_videos_tikwm) {
		print_cursor();
		m = false;
		c = ids.length;
		y = ids.length;
		v = ids.map(id => video_format_tikwm(id));
	}
	f0();
}
function downloadUserVideosWebPage(id, callback=emptyFunction) {
	requestGet("https://www.tiktok.com/@" + id, {}, function(error, response, request) {
		var d = "";
		response.setEncoding("utf8");
		response.on("data", function(data) {
			d += data;
		}).on("error", function(error) {
			console_error(error);
		}).on("end", function() {
			var m = d.match(/,"list":(\[[\d",]+\])/);
			if (m) {
				var download_videos_func = download_videos_single ? downloadVideos : downloadVideosMulti;
				download_videos_func(JSON.parse(m.pop()));
			}
		});
	});
}
function get_detail(k, v) {
	return typeof k === "object" && k !== null ? typeof v === "string" ? k[v] : k : undefined;
}
function scrapeWeb(o, callback=emptyFunction) {
	var a = 0, i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], ids = [], error_queue = [], error_queued = {}, cursor_printed, cursor_start, cursor_end, delay = 0, depth = 0, f0 = function() {
		if (running) {
			while (download_files && i < v.length && e < max_downloads) {
				download_item(v[i++], f1);
			}
			while (a < max_downloads && error_queue.length > 0) {
				a++;
				requestAweme(aweme_host, error_queue.shift(), f4);
			}
			while (a < max_downloads && ids.length > 0) {
				a++;
				requestAweme(aweme_host, "/aweme/v1/aweme/detail/?aweme_id=" + ids.shift(), f4);
			}
			if (m && e < max_downloads) {
				m = false;
				a++;
				print_cursor();
				setTimeout(requestTiktok, delay, o.path + (o.query_params || c), o.params ? {
					"User-Agent": o.user_agent,
					"x-tt-params": encryptParams(o.params + c)
				} : {}, f2);
			}
		}
		if (a === 0 && e === 0) {
			a--;
			print_cursor();
			save_to_files();
			callback(null);
		}
	}, print_cursor = function() {
		if (cursor_print && cursor_printed !== String([c,y])) {
			cursor_printed = String([c,y]);
			console_log("cursor: " + c
			+ (c !== 0 && o.date_cursor ? " (" + (new Date(+c)).toISOString() + ")" : "")
			+ " [" + (count*depth) + "=" + count + "*" + depth + (max_depth ? "/" + max_depth : "") + "]");
			console_log("item count: " + y + (!date_limit && limit > 0 ? "/" + limit + (break_limit ? "+" : "") : ""));
			if (cursor_times) {
				cursor_end = Date.now();
				if (c !== cursor) console_log("duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f1 = function(video, file_ext) {
		e++;
		ensureAweme(video, file_ext, function(error, file, exists) {
			if (error !== null) {
				last_scrape_save = false;
				if (debug || error !== reject_sd_error) print_log("failed: " + file + " | " + error.message);
				register_error(video, file_ext, f1);
			} else {
				ignore_file(video.id, file_ext);
				if (!exists) {
					print_log("downloaded: " + file);
					register_download(video, file_ext, file);
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		delay = 0;
		var details = get_detail(data, o.details);
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				delay = ignore_errors_delay;
				m = true;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			} else {
				last_scrape_save = false;
				console_error(error);
			}
		} else if (typeof details !== "object" || details === null
		|| (typeof details[o.max_cursor] !== "string" && typeof details[o.max_cursor] !== "number")
		|| (typeof details[o.has_more] !== "boolean" && typeof details[o.has_more] !== "number")) {
			last_scrape_save = false;
			if (debug) console_error(data);
		} else {
			n = details[o.has_more];
			c = details[o.max_cursor];
			ignore_errors_count = 0;
			if (++depth === max_depth) {
				n = false;
			}
			var detail = get_detail(details, o.detail);
			if (typeof detail === "object" && detail !== null) {
				for (var j = 0, r = []; j < detail.length; j++) {
					var aweme_detail = detail[j];
					if (typeof aweme_detail !== "object" || aweme_detail === null) continue;
					if (o.item_detail) {
						aweme_detail = aweme_detail[o.item_detail];
						if (typeof aweme_detail !== "object" || aweme_detail === null) continue;
					}
					var video = video_format_feed(aweme_detail);
					if (last_scrape_save && last_scrape === 0) {
						last_scrape = video.time;
					}
					if (date_limit && video.time <= limit) {
						if (debug) console_log("breaking at: " + video.time + " = " + createTimeToFilename(video.time) + " = " + video.id);
						limit = 0;
						n = false;
						if (!break_limit) break;
					}
					if (!ignored_id(video.id) && !fetch_only) {
						if (download_videos_tikwm) {
							video["mp4_sd"] = getUriApi(video.id);
							if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
							v.push(video);
						}
						else if (download_videos_single) ids.push(video.id);
						else r.push(video.id);
					}
					if (last_scrape_save || fetched_ids_save || unscraped_ids_save) fetched_ids.push(video.id);
					if (++y === limit && !date_limit) {
						n = false;
						if (!break_limit) break;
					}
				}
				if (r.length > 0) {
					requestAweme(aweme_host, "/aweme/v1/multi/aweme/detail/?aweme_ids=[" + r.join(",") + "]", f3);
					return;
				}
			}
			m = n;
		}
		a--;
		f0();
	}, f3 = function(error, data, uri) {
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
				setTimeout(requestAweme, ignore_errors_delay, aweme_host, uri, f3);
				return;
			} else {
				last_scrape_save = false;
				console_error(error);
			}
		} else {
			ignore_errors_count = 0;
			m = n;
			if (typeof data === "object" && data !== null
			&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
				for (var j = 0, video; j < data.aweme_details.length; j++) {
					if ((video = video_format(data.aweme_details[j], data.extra.now)) === null) continue;
					if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
					if (!fetch_only) v.push(video);
				}
			}
			if (last_scrape_save && v.length !== fetched_ids.length) {
				last_scrape_save = false;
			}
		}
		a--;
		f0();
	}, f4 = function(error, data, uri) {
		var detail = get_detail(data, "aweme_detail");
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
				error_queue.push(uri);
			} else {
				last_scrape_save = false;
				if (debug) console_error(error);
			}
		} else if (typeof detail !== "object" || detail === null) {
			if (!error_queued.hasOwnProperty(uri)) error_queued[uri] = 0;
			if (9 > ++error_queued[uri]) error_queue.push(uri);
			else print_error("missing: " + uri);
		} else {
			ignore_errors_count = 0;
			var video = video_format(detail, data.extra.now);
			if (video !== null) {
				if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
				v.push(video);
			}
		}
		a--;
		f0();
	};
	f0();
}
function scrapeWebApi(o, ...a) {
	scrapeWeb({
		path: o.path,
		params: o.params,
		query_params: "?aid=1988"
			+ "&app_language=en"
			+ "&app_name=tiktok_web"
			+ "&browser_language=en-US"
			+ "&browser_name=Mozilla"
			+ "&browser_online=true"
			+ "&browser_platform=Win32"
			+ "&browser_version=5.0%20%28Windows%29"
			+ "&channel=tiktok_web"
			+ "&cookie_enabled=true"
			+ "&device_id=6006859028954454735"
			+ "&device_platform=web_pc"
			+ "&focus_state=true"
			+ "&from_page=user"
			+ "&history_len=1"
			+ "&is_fullscreen=false"
			+ "&is_page_visible=true"
			+ "&os=windows"
			+ "&priority_region=GB"
			+ "&referer="
			+ "&region=GB"
			+ "&screen_height=1080"
			+ "&screen_width=1920"
			+ "&tz_name=Europe%2FLondon"
			+ "&webcast_language=en"
			+ "&msToken=H_ii5xnBqTB-HFLd6IPTuIEBWPXoloX0LLTBXxwmr46-TOfM4cbgBZ07nD5-ypjwwqZtkrrHI6A7dJzLTOMJ6LTV75eT1nvWNzgSxJ7hTUGIjvaGcrlSQsVHl6aTWRYS88EmSxkX0KfAuoqgFg=="
			+ "&X-Bogus=DFSzsIVE/6zANtg/S0Oc21KqaiOC"
			+ "&_signature=_02B4Z6wo000017L7sQwAAIDBDBerl9ohi.Oy-rWAAI.Ze9",
		user_agent: "Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:106.0) Gecko/20100101 Firefox/106.0",
		detail: "itemList",
		max_cursor: "cursor",
		has_more: "hasMore",
		date_cursor: o.date_cursor
	}, ...a);
}
function downloadUserVideosWeb(sec_uid, ...a) {
	scrapeWebApi({
		path: "/api/post/item_list/",
		params: "aid=1988"
			+ "&secUid=" + sec_uid
//			+ "&id=" // ?
//			+ "&userId=" // ?
			+ "&count=" + count
			+ "&cursor=",
		date_cursor: true
	}, ...a);
}
function downloadMusicVideosWeb(id, ...a) {
	scrapeWebApi({
		path: "/api/music/item_list/",
		params: "aid=1988"
			+ "&musicID=" + id
			+ "&count=" + count
			+ "&cursor="
	}, ...a);
}
function downloadHashtagVideosWeb(id, ...a) {
	scrapeWebApi({
		path: "/api/challenge/item_list/",
		params: "aid=1988"
			+ "&challengeID=" + id
			+ "&count=" + count
			+ "&cursor="
	}, ...a);
}
function scrapeFeed(feed_type, id, ...a) {
	scrapeWeb({
		path: "/node/video/feed"
			+ "?secUid="
			+ "&shareUid="
			+ "&lang=en"
			+ "&id=" + id
			+ "&type=" + feed_type
			+ "&count=" + count
			+ "&minCursor=0"
			+ "&maxCursor=",
		details: "body",
		detail: "itemListData",
		item_detail: "itemInfos",
		max_cursor: "maxCursor",
		has_more: "hasMore",
		date_cursor: feed_type === 1
	}, ...a);
}
function scrapeAweme(o, callback=emptyFunction, handle_metadata=true) {
	var cache_cursors = request_aweme_cache_cursors && request_aweme_cache && o.max_cursor;
	if (cache_cursors) {
		var cached_cursor = function(a, b) {
			if (cached_cursors.has(b)) return b;
			if (a <= 0 || b <= 0) return b;
			var c = a, d = a > b;
			cached_cursors.forEach(v => {
				if (v > (d ? b : c)
				&& (v < (d ? c : b))) c = v;
			});
			return c === a ? b : c;
		},
		cached_cursors,
		cached_cursors_initial,
		cached_cursors_file = file_path_absolute(request_aweme_cache_cursors_dir + path.sep + hash_string(o.path) + ".json", root_directory);
		try {
			cached_cursors = new Set(JSON.parse(fs.readFileSync(cached_cursors_file)).cursors);
		} catch (e) {
			cached_cursors = new Set();
		}
		cached_cursors_initial = cached_cursors.size;
	}
	var a = 0, i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], vs = new Set(), cursor_printed, cursor_start, cursor_end, delay = 0, depth = 0, f0 = function() {
		if (running) {
			while (download_files && i < v.length && e < max_downloads) {
				download_item(v[i++], f1);
			}
			if (m && e < max_downloads) {
				m = false;
				a++;
				print_cursor();
				setTimeout(requestAweme, delay, o.host, o.path + (o.max_cursor ? c : ""), f2);
			}
		}
		if (a === 0 && e === 0) {
			a--;
			print_cursor();
			if (handle_metadata) save_to_files();
			if (cache_cursors && cached_cursors_initial !== cached_cursors.size) {
				writeFileDirectorySync(cached_cursors_file, JSON.stringify({
					path: o.path,
					cursors: [...cached_cursors]
				}));
			}
			callback(null);
		}
	}, print_cursor = function() {
		if (o.max_cursor && cursor_print && cursor_printed !== String([c,y])) {
			cursor_printed = String([c,y]);
			console_log((handle_metadata ? "" : "\t") + "cursor: " + c
			+ (c !== 0 && (o.date_cursor || o.date_cursor_alt) ? " (" + (new Date(+c * (o.date_cursor_alt ? 1000 : 1))).toISOString() + ")" : "")
			+ " [" + (count*depth) + "=" + count + "*" + depth + (max_depth ? "/" + max_depth : "") + "]");
			console_log((handle_metadata ? "" : "\t") + "item count: " + y + (!date_limit && limit > 0 ? "/" + limit + (break_limit ? "+" : "") : ""));
			if (cursor_times) {
				cursor_end = Date.now();
				if (c !== cursor) console_log((handle_metadata ? "" : "\t") + "duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f1 = function(video, file_ext) {
		e++;
		ensureAweme(video, file_ext, function(error, file, exists) {
			if (error !== null) {
				last_scrape_save = false;
				if (debug || error !== reject_sd_error) print_log("failed: " + file + " | " + error.message);
				register_error(video, file_ext, f1);
			} else {
				ignore_file(video.id, file_ext);
				if (!exists) {
					if (scraped_ids_save || unscraped_ids_save) scraped_ids.push(video.id);
					print_log("downloaded: " + file);
					register_download(video, file_ext, file);
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		delay = 0;
		var details = get_detail(data, o.details);
		var detail = get_detail(details, o.detail);
		if (error === null && cache_cursors) cached_cursors.add(c);
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				delay = ignore_errors_delay;
				m = true;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			} else {
				last_scrape_save = false;
				console_error(error);
			}
		} else if (data.status_code !== 0) { // success
			console_error(awemeError(data));
		} else if (account_status_save && detail === null) {
			if (account_status <= 0 && account_status > -5) {
				account_status -= 1;
				if (private_cookie) {
					cookie = private_cookie;
					private_cookie = false;
					private_cookie_used = true;
				}
				if (private_cookie_used) m = true;
			}
		} else if (private_cookie_used && data.status_msg === "No more videos") {
			account_status = 1;
		} else if (o.dump_metadata_obj) {
			metadata = detail;
		} else if (typeof details !== "object" || details === null
		|| (typeof details[o.max_cursor] !== "string" && typeof details[o.max_cursor] !== "number")
		|| (typeof details[o.has_more] !== "boolean" && typeof details[o.has_more] !== "number")) {
			last_scrape_save = false;
			if (debug) console_error(data);
		} else {
			if (private_cookie_used) account_status = 1;
			n = details[o.has_more];
			ignore_errors_count = 0;
			if (++depth === max_depth) {
				n = false;
			}
			if (typeof detail === "object" && detail !== null) {
				for (var j = 0, video; j < detail.length; j++) {
					var aweme_detail = detail[j];
					if (typeof aweme_detail !== "object" || aweme_detail === null) continue;
					if (o.item_detail) {
						aweme_detail = aweme_detail[o.item_detail];
						if (typeof aweme_detail !== "object" || aweme_detail === null) continue;
					}
					if (o.dump_metadata) {
						if (o.dump_metadata === true || metadata_verbose) {
							metadata.push(aweme_detail);
						} else {
							metadata.push(obj_filter(aweme_detail, o.dump_metadata));
						}
					} else if ((video = video_format(aweme_detail, data.extra.now)) !== null) {
						if (vs.has(video.id)) continue;
						else vs.add(video.id);
						if (!aweme_detail.is_top) {
							if (cache_cursors && c === 0 && (o.date_cursor || o.date_cursor_alt)) {
								c = video.time * (o.date_cursor ? 1000 : 1);
							}
							if (last_scrape_save && last_scrape === 0) {
								last_scrape = video.time;
							}
							if (date_limit && video.time <= limit) {
								if (debug) console_log("breaking at: " + video.time + " = " + createTimeToFilename(video.time) + " = " + video.id);
								limit = 0;
								n = false;
								if (!break_limit) break;
							}
						}
						if (!ignored_id(video.id) && !fetch_only) v.push(video);
						if (fetched_ids_save || unscraped_ids_save) fetched_ids.push(video.id);
					}
					if (++y === limit && !date_limit) {
						n = false;
						if (!break_limit) break;
					}
				}
			}
			if (cache_cursors && n) c = cached_cursor(c, details[o.max_cursor]);
			else c = details[o.max_cursor];
			m = n;
		}
		a--;
		f0();
	};
	f0();
}
function scrapeStories(callback=emptyFunction) {
	var i = 0, e = 0, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < max_downloads) {
				e++;
				downloadUserStories(v[i++], function() {
					e--;
					f0();
				}, false);
			}
		}
		if (e === 0) {
			save_to_files();
			callback(null);
		}
	}, f1 = function(error, data) {
		if (error !== null) {
			console_error(error);
		} else if (data.status_code !== 0) { // success
			console_error(awemeError(data));
		} else if (typeof data.user_ids === "object" && data.user_ids !== null) {
			v = data.user_ids;
			if (cursor_print) {
				console_log("active story pages: " + v.length);
			}
		}
		f0();
	};
	requestAweme(aweme_host, "/tiktok/v1/story/get_feed?refresh=true", f1);
}
function scrapeCollections(callback=emptyFunction) {
	var a = 0, i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], cursor_printed, cursor_start, cursor_end, delay = 0, o = {
		host: aweme_host,
		path: "/tiktok/collection/item_archive/list/v1"
		+ "?count=" + count
		+ "&cursor=",
		detail: "item_archive_detail_list",
		max_cursor: "cursor",
		has_more: "has_more"
	}, f0 = function() {
		if (running) {
			while (i < v.length && e < max_downloads) {
				e++;
				if (cursor_print) console_log("collection " + v[i].id + ": " + v[i].name + " [" + v[i].statistic.total + "]");
				downloadCollection(v[i++].id, function() {
					e--;
					f0();
				}, false);
			}
			if (m && e < max_downloads) {
				m = false;
				a++;
				print_cursor();
				setTimeout(requestAweme, delay, o.host, o.path + c, f2);
			}
		}
		if (a === 0 && e === 0) {
			a--;
			print_cursor();
			save_to_files();
			callback(null);
		}
	}, print_cursor = function() {
		if (cursor_print && cursor_printed !== String([c,y])) {
			cursor_printed = String([c,y]);
			console_log("cursor: " + c);
			console_log("item count: " + y);
			if (cursor_times) {
				cursor_end = Date.now();
				if (c !== cursor) console_log("duration: " + ((cursor_end-cursor_start)/1000).toFixed(3) + "s");
				cursor_start = cursor_end;
			}
		}
	}, f2 = function(error, data) {
		delay = 0;
		var details = get_detail(data, o.details);
		if (error !== null) {
			if (running && ignore_errors && (ignore_errors_limit === 0 || ignore_errors_count < ignore_errors_limit)) {
				ignore_errors_count++;
				delay = ignore_errors_delay;
				m = true;
				console_error("ignoring: " + error.toString() + " | " + ignore_errors_count + (ignore_errors_limit !== 0 ? " / " + ignore_errors_limit : ""));
			} else {
				last_scrape_save = false;
				console_error(error);
			}
		} else if (data.status_code !== 0) { // success
			console_error(awemeError(data));
		} else if (typeof details !== "object" || details === null
		|| (typeof details[o.max_cursor] !== "string" && typeof details[o.max_cursor] !== "number")
		|| (typeof details[o.has_more] !== "boolean" && typeof details[o.has_more] !== "number")) {
			if (debug) console_error(data);
		} else {
			n = details[o.has_more];
			c = details[o.max_cursor];
			ignore_errors_count = 0;
			var detail = get_detail(details, o.detail);
			if (typeof detail === "object" && detail !== null) {
				for (var j = 0; j < detail.length; j++, y++) {
					if (typeof detail[j] === "object" && detail[j] !== null) {
						v.push(detail[j]);
					}
				}
			}
			m = n;
		}
		a--;
		f0();
	};
	f0();
}
function downloadNow(feed, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: (feed ? "/tiktok/v1/now/feed" : "/tiktok/v1/now/discovery/feed")
		+ "?count=" + count
//		+ "&insert_ids=[]" // takes the aweme_id(s) of a now post -- returns fuzzy photos for mutual only posts
		+ "&cursor=",
		detail: "data",
		max_cursor: "cursor",
		has_more: "has_more",
		date_cursor: true
	}, ...a);
}
function downloadHashtagVideosAweme(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/challenge/aweme/"
		+ "?ch_id=" + id
		+ "&query_type=0"
		+ "&source=challenge_video"
		+ "&type=5"
		+ "&count=" + count
		+ "&cursor=",
		detail: "aweme_list",
		max_cursor: "cursor",
		has_more: "has_more"
	}, ...a);
}
function downloadMusicVideosAweme(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/music/aweme/"
		+ "?music_id=" + id
		+ "&type=0"
		+ "&count=" + count
		+ "&cursor=",
		detail: "aweme_list",
		max_cursor: "cursor",
		has_more: "has_more"
	}, ...a);
}
function downloadUserVideosAweme(uid, sec_uid, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/aweme/post/"
		+ "?" + (sec_uid ? "sec_user_id=" + sec_uid : "user_id=" + uid)
		+ "&source=0"
		+ "&count=" + count
		+ "&max_cursor=",
		detail: "aweme_list",
		max_cursor: "max_cursor",
		has_more: "has_more",
		date_cursor: true
	}, ...a);
}
function downloadUserLikesAweme(uid, sec_uid, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/aweme/favorite/"
		+ "?" + (sec_uid ? "sec_user_id=" + sec_uid : "user_id=" + uid)
		+ "&invalid_item_count=0"
		+ "&is_hiding_invalid_item=0"
		+ "&count=" + count
		+ "&max_cursor=",
		detail: "aweme_list",
		max_cursor: "max_cursor",
		has_more: "has_more",
		date_cursor: true
	}, ...a);
}
function downloadUserStories(uid, ...a) {
//	if (cursor === 0) cursor = 1;
	if (cursor === 0) cursor = Date.now();
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/v1/story/get_user_story"
		+ "?author_id=" + uid
		+ "&count=" + count
		+ "&load_before=1"
		+ "&cursor=",
		details: "user_story",
		detail: "stories",
//		max_cursor: "max_cursor",
//		has_more: "has_more_after",
		max_cursor: "min_cursor",
		has_more: "has_more_before",
		date_cursor: true
	}, ...a);
}
function downloadUserNow(uid, ...a) {
//	if (cursor === 0) cursor = 1;
	if (cursor === 0) cursor = Date.now();
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/v1/now/user/post"
		+ "?author_id=" + uid
		+ "&count=" + count
		+ "&backward=1"
		+ "&cursor=",
		details: "user_now_post",
		detail: "now_posts",
//		max_cursor: "next_cursor",
//		has_more: "has_more_after",
		max_cursor: "pre_cursor",
		has_more: "has_more_before",
		date_cursor: true
	}, ...a);
}
function downloadTrendingAweme(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/feed/"
		+ "?offset=0"
		+ "&type=0"
		+ "&is_cold_start=1"
		+ "&pull_type=1"
		+ "&count=" + count
		+ "&max_cursor=",
		detail: "aweme_list",
		max_cursor: "max_cursor",
		has_more: "has_more"
	}, ...a);
}
function downloadFollowedAweme(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v2/follow/feed/"
		+ "?follow_req_index=1"
		+ "&feed_style=1"
		+ "&pull_type=2"
		+ "&count=" + count
		+ "&cursor=",
		detail: "data",
		item_detail: "aweme",
		max_cursor: "cursor",
		has_more: "has_more"
	}, ...a);
}
function dumpVideoComments(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v2/comment/list/"
		+ "?aweme_id=" + id
		+ "&count=" + count
		+ "&cursor=",
		detail: "comments",
		max_cursor: "cursor",
		has_more: "has_more",
		dump_metadata: commentMetadataFilter()
	}, ...a);
}
function dumpVideoCommentReplies(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/comment/list/reply/"
		+ "?comment_id=" + id
		+ "&count=" + count
		+ "&cursor=",
		detail: "comments",
		max_cursor: "cursor",
		has_more: "has_more",
		dump_metadata: commentMetadataFilter()
	}, ...a);
}
function commentMetadataFilter() {
	return {
		aweme_id: "",
		cid: "",
		reply_id: "",
		reply_to_reply_id: "",
		reply_to_userid: "",
		reply_to_username: "",
		create_time: 0,
		reply_comment_total: 0,
		digg_count: 0,
		is_author_digged: 0,
		author_pin: 0,
		text: "",
		text_extra: true,
		user: {
			uid: "",
			sec_uid: "",
			unique_id: "",
			nickname: ""
		}
	};
}
function dumpCollectionsMetadata(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/collection/item_archive/list/v1"
		+ "?count=" + count
		+ "&cursor=",
		detail: "item_archive_detail_list",
		max_cursor: "cursor",
		has_more: "has_more",
		dump_metadata: {
			id: "",
			name: "",
			status: true,
			statistic: true
		}
	}, ...a);
}
function downloadCollection(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/collection/item_archive/item/list/v1"
		+ "?item_archive_id=" + id
		+ "&count=" + count
		+ "&cursor=",
		detail: "items",
		max_cursor: "max_cursor",
		has_more: "has_more"
	}, ...a);
}
function downloadBookmarkedVideos(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/aweme/listcollection/"
		+ "?count=" + count
		+ "&cursor=",
		detail: "aweme_list",
		max_cursor: "cursor",
		has_more: "has_more",
		date_cursor_alt: true
	}, ...a);
}
function downloadPlaylistVideos(id, sec_uid, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/v1/mix/videos/"
		+ "?mix_id=" + id
		+ "&sec_uid=" + sec_uid
//		+ "&uid=" // doesn't work
		+ "&count=" + count
		+ "&cursor=",
		detail: "videos",
		max_cursor: "max_cursor",
		has_more: "has_more"
	}, ...a);
}
function dumpPlaylists(uid, sec_uid, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/tiktok/v1/mix/list/"
		+ "?" + (sec_uid ? "sec_uid=" + sec_uid : "uid=" + uid)
		+ "&count=" + count
		+ "&cursor=",
		detail: "mix_list",
		max_cursor: "cursor",
		has_more: "has_more",
		dump_metadata: {
			mix_id: "",
			name: ""
		}
	}, ...a);
}
function dumpInfoUser(user, sec_uid, ...a) {
	var query;
//	var name_param = "unique_id"; // ?
//	var name_param = "user_name";
//	var name_param = "username";
//	var name_param = "user";
	if (sec_uid) query = "sec_user_id=" + sec_uid;
//	else if (user.startsWith("@")) query = name_param + "=" + encodeURI(user.substring(1));
//	else if (!isNaN(BoundInt(user))) query = "user_id=" + user;
//	else query = name_param + "=" + encodeURI(user);
	else query = "user_id=" + user;
	scrapeAweme({
		host: aweme_host,
//		path: "/aweme/v1/user/" // requires login
		path: "/aweme/v1/user/profile/other/"
		+ "?" + query,
		detail: "user",
		dump_metadata_obj: true
	}, ...a);
}
function dumpInfoMusic(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/music/detail/"
		+ "?music_id=" + id,
		detail: "music_info",
		dump_metadata_obj: true
	}, ...a);
}
function dumpInfoHashtag(tag, ...a) {
	var query, query_type = "1";
	if (tag.startsWith("#")) query = "hashtag_name=" + encodeURI(tag.substring(1));
	else if (!isNaN(BoundInt(tag))) query = "ch_id=" + tag, query_type = "0";
	else query = "hashtag_name=" + encodeURI(tag);
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/challenge/detail/"
		+ "?" + query
		+ "&query_type=" + query_type,
		detail: "ch_info",
		dump_metadata_obj: true
	}, ...a);
}
function dumpInfoVideo(id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/aweme/detail/"
		+ "?aweme_id=" + id,
		detail: "aweme_detail",
		dump_metadata_obj: true
	}, ...a);
}
function dumpLivesInbox(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/janus/v1/notice/multi/"
		+ "?req_from=tiktok_message",
//		+ "?live_entrance=5"
//		+ "req_from=tiktok_message"
//		+ "is_draw=0"
//		+ "content_type=3"
//		+ "channel_id=81"
//		+ "count=0"
//		+ "webcast_sdk_version=2560"
//		+ "webcast_client_version=26.5.2"
//		+ "webcast_locale=en"
//		+ "webcast_language=en"
//		+ "scenario=2"
//		+ "has_shown_following_popup=false",
		details: "data",
		detail: "live_message",
		dump_metadata_obj: true
	}, ...a);
}
function dumpLivesFollowing(...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/aweme/v1/following/interest/users/"
		+ "?following_list_type=2"
		+ "&last_display_time=0"
		+ "&sky_light_type=2",
		detail: "user_list",
		dump_metadata_obj: true
	}, ...a);
}
function dumpLiveInfo(room_id, ...a) {
	scrapeAweme({
		host: aweme_host,
		path: "/webcast/room/enter/"
		+ "?anchor_id=" // room owner uid, required but not validated
		+ "&room_id=" + room_id,
		detail: "data",
		dump_metadata_obj: true
	}, ...a);
}
function execCmds(commands, repeat, processes, output, use_shell, refresh_commands, callback=emptyFunction) {
	if (output) {
		process.stdout.setMaxListeners(0);
		process.stderr.setMaxListeners(0);
	}
	var i = 0, e = 0, l = commands.length, pad_len = l.toString().length, l_str = l.toString().padStart(pad_len, "0"), f0 = function() {
		timeout = null;
		if (running) {
			while (i < l && e < processes) {
				f1(i);
				i++;
				e++;
			}
			if (e === 0 && i === l && repeat > -1) {
				i = 0;
				var d = Date.now();
				console_log([
					output_timestamp(new Date(d)),
					"sleep",
					output_timestamp(new Date(d+repeat))
				].join(" | "));
				timeout = setTimeout(function() {
					if (refresh_commands) {
						if (commands_file !== undefined) {
							try {
								commands_file_cmds = fs.readFileSync(commands_file, "utf8");
							} catch (error) {
								console_error(error);
							}
						}
						commands = getCmds(commands_file_cmds);
						if (l !== commands.length) {
							l = commands.length;
							pad_len = l.toString().length;
							l_str = l.toString().padStart(pad_len, "0");
						}
					}
					f0();
				}, repeat);
				return;
			}
		}
		if (e === 0 && (!running || i === l)) {
			callback(null);
		}
	}, f1 = function(index) {
		var a, p;
		try {
			a = splitCmd(commands[index], [__filename]);
		} catch (e_) {
			console_log([
				output_timestamp(new Date()),
				(index+1).toString().padStart(pad_len, " ") + " / " + l_str,
				"0".toString().padStart(5, " "),
				commands[index]
			].join(" | "));
			console_error(e_);
			process.nextTick(f2, null, null);
			return;
		}
		p = child_process.spawn("node", a, {stdio: output ? ["ignore", "pipe", "pipe"] : "ignore", shell: use_shell});
		p.on("exit", f2);
		if (output) {
			p.stdout.pipe(process.stdout);
			p.stderr.pipe(process.stderr);
		}
		//p["x-index"] = i;
		console_log([
			output_timestamp(new Date()),
			(index+1).toString().padStart(pad_len, " ") + " / " + l_str,
			p.pid.toString().padStart(5, " "),
			commands[index]
		].join(" | "));
	}, f2 = function(code, signal) {
		//console_log(this["x-index"] + " " + this.pid + " " + commands[this["x-index"]]);
		e--;
		f0();
	};
	f0();
}
function ignore_format(id, file_ext) {
	return id + "." + file_ext;
}
function ignored_file(id, file_ext) {
	if (ignore_ids_save) {
		if (debug) console_log("ignore_file_test: " + ignore_format(id, file_ext) + " | " + ignore_ids.has(ignore_format(id, file_ext)));
		return ignore_ids.has(ignore_format(id, file_ext));
	}
}
function ignored_id(id) {
	if (ignore_ids_save) {
		return ignore_ids.has(id) || !download_exts.some(file_ext => !ignored_file(id, file_ext));
	}
}
function ignore_file(id, file_ext) {
	if (ignore_ids_save && ignore_exts.has(file_ext)) {
		if (debug) console_log("ignore_file: " + ignore_format(id, file_ext));
		ignore_ids.add(ignore_format(id, file_ext));
	}
}
function video_format(v, scrape_time) {

	if (v.is_ads) return null;

	if (skip_min_views && skip_min_views > v.statistics?.play_count) return null;
	if (skip_max_views && skip_max_views < v.statistics?.play_count) return null;

	var is_live = typeof v.author?.room_id === "string" && v.author.room_id.length > 1;
	if (skip_live && is_live) return null;
	if (only_live && !is_live) return null;

	var is_photo = typeof v.image_post_info === "object" && v.image_post_info !== null;
	if (skip_photos && is_photo) return null;
	if (only_photos && !is_photo) return null;

	var is_story = (typeof v.user_story === "object" && v.user_story !== null) || (typeof v.story_metadata === "object" && v.story_metadata !== null);
	if (skip_stories && is_story) return null;
	if (only_stories && !is_story) return null;

	var is_followed = typeof v.author?.follow_status === "number" && v.author.follow_status !== 0;
	if (skip_followed && is_followed) return null;
	if (only_followed && !is_followed) return null;

	var is_now = typeof v.now_posts === "object" && v.now_posts !== null;
//	if (is_now && v.now_posts.now_status === 0) return null; // mutual only

	var is_mutual = v.status?.private_status === 2;
	var is_private = v.author?.secret;
	if (account_status_save) {
		var is_mutuals = v.author?.follow_status === 2;
		if (is_mutuals) account_status = 2;
		else if (is_private) account_status = 1;
		else account_status = 0;
	}

	var uid = v.author?.uid || "";
	if (skip_uids && skip_uids.has(uid)) return null;
	if (only_uids && !only_uids.has(uid)) return null;

	if (metadata_files) {
		var video_metadata = metadata_format(v, scrape_time);
		if (lives_save && is_live) lives[v.author.room_id] = video_metadata;
		if (metadata_save) metadata.push(video_metadata);
		if (metadata_save_obj && (metadata_update_obj || !metadata_obj.hasOwnProperty(v.aweme_id))) metadata_obj[v.aweme_id] = video_metadata;
		if (metadata_save_each && (metadata_update_each || !ignored_file(v.aweme_id, "json"))) metadata_each[v.aweme_id] = video_metadata;
	}

	var u = getVideoUrlList(v);

	return {
		id: v.aweme_id,
		uid: uid,
		unique_id: v.author?.unique_id || "",
		time: +v.create_time || 0,
		desc: v.desc || "",
		mp4_wm: !is_photo ? getVideoWatermarked(v) : null,
		mp4_sd: !is_photo ? u : null,
//		mp4: !is_photo && u !== null ? getQualityUri(u[u.length - 1]) : null,
		mp4: !is_photo ? getQualityUriApi(v.aweme_id) : null,
		jpg: getVideoThumbnail(v),
		webp: getVideoThumbnailAnimated(v),
		mp3: getVideoAudio(v),
		images: is_now ? getVideoNowImages(v) : getVideoImages(v),
		is_now: is_now,
		is_photo: is_photo,
		is_story: is_story,
		is_mutual: is_mutual,
		is_private: is_private
	};
}
function video_format_feed(v) {
	var uri = null;
//	var uri = typeof v.video?.bitrateInfo === "object" && v.video.bitrateInfo !== null ? v.video.bitrateInfo[0].PlayAddr.Uri : null;
//	console_log([v.id,uri,Boolean(uri)]);
	return {
		id: v.id,
		uid: v.authorId || "",
		unique_id: v.author?.uniqueId || "",
		time: +v.createTime || 0,
		desc: v.desc || "",
		mp4_wm: v.video?.playAddr || null,
		mp4_sd: uri ? getUri(uri, aweme_host) : null,
//		mp4: uri ? getQualityUris(uri, aweme_host) : null,
		mp4: getQualityUriApi(v.id),
		jpg: v.video?.cover || null,
		webp: v.video?.dynamicCover || null,
		mp3: null,
		images: null,
		is_mutual: v.forFriend,
		is_private: v.author?.secret
	};
}
function video_format_tikwm(id) {
	return {
		id: id,
		uid: "",
		unique_id: "",
		time: 0,
		desc: "",
		mp4_wm: getWatermarkedUriApi(id),
		mp4_sd: getUriApi(id),
		mp4: getQualityUriApi(id),
		jpg: null,
		webp: null,
		mp3: null,
		images: null
	};
}
function metadata_format(aweme_detail, scrape_time) {
	var ks;
	if (metadata_verbose) {
		ks = aweme_detail;
	} else {
		ks = {};
		["aweme_id", "create_time", "desc"]
		.forEach(v => ks[v] = aweme_detail[v]);
		ks.uri = aweme_detail.video?.play_addr?.uri;
		if (typeof aweme_detail.text_extra === "object" && aweme_detail.text_extra !== null && aweme_detail.text_extra.length > 0) {
			ks.text_extra = aweme_detail.text_extra.map(v => {
				v.text = aweme_detail.desc.substring(v.start, v.end);
				delete v.start;
				delete v.end;
				return Object.fromEntries(
					Object.keys(v)
					.filter(k => typeof v[k] !== "string" || v[k].length > 0)
					.map(k => [k, v[k]])
				);
			});
		}
		if (typeof aweme_detail.interaction_stickers === "object" && aweme_detail.interaction_stickers !== null) {
			ks.interaction_stickers = aweme_detail.interaction_stickers;
		}
		if (typeof aweme_detail.interaction_tag_info === "object" && aweme_detail.interaction_tag_info !== null
		&& typeof aweme_detail.interaction_tag_info.tagged_users === "object" && aweme_detail.interaction_tag_info.tagged_users !== null
		&& aweme_detail.interaction_tag_info.tagged_users.length > 0) {
			ks.interaction_tag_info = {};
			ks.interaction_tag_info.tagged_users = aweme_detail.interaction_tag_info.tagged_users.map(v => ({
				nickname: v.nickname,
				uid: v.uid,
				unique_id: v.unique_id
			}));
		}
		if (typeof aweme_detail.playlist_info === "object" && aweme_detail.playlist_info !== null) {
			ks.playlist_info = aweme_detail.playlist_info;
		}
		if (typeof aweme_detail.statistics === "object" && aweme_detail.statistics !== null) {
			ks.statistics = aweme_detail.statistics;
			delete ks.statistics.aweme_id;
		}
		if (typeof aweme_detail.author === "object" && aweme_detail.author !== null) {
			ks.author = {};
			["uid", "sec_uid", "unique_id", "nickname", "signature", "region", "language"]
			.forEach(v => ks.author[v] = aweme_detail.author[v]);
			["ins_id", "twitter_id", "youtube_channel_id"]
			.filter(v => aweme_detail.author[v] !== "" && aweme_detail.author[v] !== 0)
			.forEach(v => ks.author[v] = aweme_detail.author[v]);
			if (lives_include && typeof aweme_detail.author.room_id === "string") ks.author.room_id = aweme_detail.author.room_id;
		}
		if (typeof aweme_detail.video === "object" && aweme_detail.video !== null) {
			ks.video = {};
			["duration", "width", "height"]
			.forEach(v => ks.video[v] = aweme_detail.video[v]);
		}
		if (typeof aweme_detail.music === "object" && aweme_detail.music !== null) {
			ks.music = {};
			["duration", "id_str", "owner_id", "title", "author", "owner_handle", "owner_nickname"]
			.forEach(v => ks.music[v] = aweme_detail.music[v]);
			if (typeof aweme_detail.music.matched_song === "object" && aweme_detail.music.matched_song !== null) {
				ks.music.matched_song = {};
				["id", "title", "author"]
				.forEach(v => ks.music.matched_song[v] = aweme_detail.music.matched_song[v]);
			}
		}
	}
	ks.scrape_time = Math.floor(scrape_time / 1000);
	if (metadata_print) console_log(JSON.stringify(ks));
	return ks;
}
function output_file_name(a, tag="", params=true) {
	var obj_out = [];
//	obj_out.push(path.basename(__filename, path.extname(__filename)));
	obj_out.push(path.basename(__filename));
	obj_out.push(createTimeToFilename(output_time/1000));
	if (params) {
		output_tags.split("").forEach(function(value) {
			if (value === "i" && a["si"]) value = "si";
			if (a[value] !== undefined) {
				if (a[value] === "") {
					obj_out.push(value);
				} else {
					obj_out.push([value,sanitizeFilename(a[value])].join("="));
				}
			}
		});
	}
	if (tag.length > 0) obj_out.push(tag);
	return obj_out.join("_") + ".json";
}
function save_to_files() {
	if (lives_save) {
		lives_save_to_file();
	}
	if (metadata_save) {
		metadata_save_to_file();
	}
	if (metadata_save_obj) {
		metadata_save_obj_to_file();
	}
	if (fetched_ids_save) {
		ids_save_to_file(fetched_ids, fetched_ids_file);
	}
	if (scraped_ids_save) {
		ids_save_to_file(scraped_ids, scraped_ids_file);
	}
	if (unscraped_ids_save) {
		unscraped_ids = new Set(fetched_ids);
		for (var j = 0; j < scraped_ids.length; j++) {
			unscraped_ids.delete(scraped_ids[j]);
		}
		ids_save_to_file([...unscraped_ids], unscraped_ids_file);
	}
	if (ignore_ids_save && ignore_ids_save_queue === 0) {
		ignore_ids_save_to_file();
	} else {
		ignore_ids_save_queued = ignore_ids_save;
	}
	if (last_scrape_save && last_scrape !== 0 && last_scrape !== previous_scrape) {
		writeFileDirectorySync(last_scrape_file, last_scrape.toString(), function() {
			console_log("last scrape: " + last_scrape + " = " + createTimeToFilename(last_scrape) + " > " + last_scrape_file);
		});
	}
	if (account_status_save
	&& previous_account_status !== account_status
	&& previous_account_status !== 2
	&& [-5,0,1].includes(account_status)) {
		writeFileDirectorySync(account_status_file, account_status.toString(), function() {
			console_log("account status: " + account_status + " > " + account_status_file);
		});
	}
}
function writeFileDirectorySync(file, str, callback=emptyFunction) {
	if (ensureFileDirectorySync(file) !== null) return;
	fs.writeFile(file, str, function(error) {
		if (error !== null) {
			console_error(error);
		} else {
			callback();
		}
	});
}
function ignore_ids_save_to_file() {
	if (ignore_ids.size !== ignore_ids_initial) {
		ids_save_to_file([...ignore_ids], ignore_ids_file);
	}
}
function lives_save_to_file() {
	var len = Object.keys(lives).length;
	if (save_empty || len > 0) {
		writeFileDirectorySync(lives_file, JSON.stringify(lives), function() {
			console_log("output file: " + file_path_absolute(lives_file));
			console_log("item count: " + len);
		});
	}
}
function metadata_save_to_file() {
	var is_array = Array.isArray(metadata);
	if (save_empty || !is_array || metadata.length > 0) {
		writeFileDirectorySync(metadata_file, is_array && metadata_split ? metadata.map(ks => JSON.stringify(ks)).join("\n") : JSON.stringify(metadata), function() {
			console_log("output file: " + file_path_absolute(metadata_file));
			if (is_array) console_log("item count: " + metadata.length);
		});
	}
}
function metadata_save_obj_to_file() {
	var len = Object.keys(metadata_obj).length;
	if (save_empty || len > 0) {
		var v = JSON.stringify(metadata_obj);
		if (metadata_obj_initial === hash_string(v)) return;
		writeFileDirectorySync(metadata_obj_file, v, function() {
			console_log("output file: " + file_path_absolute(metadata_obj_file));
			console_log("item count: " + len);
		});
	}
}
function ids_save_to_file(ids, ids_file) {
	if (save_empty || ids.length > 0) {
//		writeFileDirectorySync(ids_file, JSON.stringify(ids.sort((a, b) => a - b)), function() {
		writeFileDirectorySync(ids_file, JSON.stringify(ids), function() {
			console_log("output file: " + file_path_absolute(ids_file));
			console_log("item count: " + ids.length);
		});
	}
}
function metadata_save_each_to_file(video) {
	ignore_ids_save_queue++;
	ensureFile(video, add_description => file_name(video, "json", file_tag_default, add_description, false, true), function(error, file, exists) {
		var video_metadata = metadata_each[video.id];
		metadata_each[video.id] = null;
		if (error !== null) {
			console_error(error);
			if (--ignore_ids_save_queue === 0 && ignore_ids_save_queued) ignore_ids_save_to_file();
		} else if (!exists || metadata_update_each) {
			fs.writeFile(file, JSON.stringify(video_metadata), function(error) {
				if (error !== null) {
					console_error(error);
				} else {
					print_log((!exists ? "saved" : "updated") + " metadata: " + file);
					ignore_file(video.id, "json");
				}
				if (--ignore_ids_save_queue === 0 && ignore_ids_save_queued) ignore_ids_save_to_file();
			});
		} else {
			ignore_file(video.id, "json");
			if (--ignore_ids_save_queue === 0 && ignore_ids_save_queued) ignore_ids_save_to_file();
		}
	});
}
function multi_progress_push_dummy() {
	try {
		multi_progress.bars.push("");
		multi_progress.move(multi_progress.bars.length - 1);
		multi_progress.stream.cursorTo(0);
		multi_progress.cursor += 1;
//		multi_progress.terminates += 1;
	} catch (e) {
		progress_bars = false;
		console_error(e);
	}
}
function output_timestamp(d) {
	return ("00" + d.getHours()).substr(-2)
	+ ":" + ("00" + d.getMinutes()).substr(-2)
	+ ":" + ("00" + d.getSeconds()).substr(-2)
	+ "." + ("000" + d.getMilliseconds()).substr(-3);
}
function output_line(v, n, k) {
	if (v && typeof v === "object" && v.constructor === Object) {
		try {
			v = JSON.stringify(v);
		} catch (e) {
			v = e;
		}
	}
	return (progress_bars_debug
		? output_timestamp(new Date()) + " "
		+ ("0000" + n).substr(-4) + " "
		+ k + " "
		: ""
	) + v;
}
function console_log(v) {
	print_log(v, false);
}
function console_error(v) {
	print_error(v);
}
function print_log(v, log=true) {
	if (progress_bars && multi_progress && process.stdout.isTTY) {
		multi_progress_push_dummy();
		console.log(output_line(v, multi_progress.cursor, "#"));
	} else {
		console.log(v);
	}
	if (log_save && (log || log_verbose)) {
		write_log(v);
	}
}
function print_error(v) {
	if (progress_bars && multi_progress && process.stderr.isTTY) {
		multi_progress_push_dummy();
		console.error(output_line(v, multi_progress.cursor, "!"));
	} else {
		console.error(v);
	}
	if (log_save && log_errors) {
		write_log(v);
	}
}
function write_log(v) {
	open_log(function(error) {
		if (error !== null) {
			log_save = false;
			console_error(error);
		} else if (v !== null) {
			if (typeof v === "object") {
				try {
					v = JSON.stringify(v);
				} catch (e) {
					v = e;
				}
			}
			try {
				fs.writeSync(logger, (new Date()).toISOString() + " " + sanitizeLog(v.toString()) + os.EOL);
			} catch (e) {
				console_error(e);
			}
		}
	});
}
function open_log(callback) {
	if (!logger) {
		try {
			if (ensureFileDirectorySync(log_file, callback, false) !== null) return;
			logger = fs.openSync(log_file, "a");
		} catch (e) {
			callback(e);
			return;
		}
	}
	callback(null);
}
function printSize(bytes) {
	var units = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
	for (var steps = 0; bytes > 1024; steps++) {
		bytes /= 1024;
	}
	return parseFloat(bytes).toFixed(2) + " " + units[steps];
}
function obj_filter(obj_in, obj_match) {
	var obj_out = {};
	for (var [key, value] of Object.entries(obj_in)) {
		if (obj_match.hasOwnProperty(key)) {
			if (obj_match[key] === true || typeof value !== "object") {
				obj_out[key] = value;
			} else {
				obj_out[key] = obj_filter(value, obj_match[key]);
			}
		}
	}
	return obj_out;
}
function file_path_absolute(file, dir=directory) {
	return (path.isAbsolute(file) ? "" : dir + path.sep) + file;
}
process.on("exit", function() {
	if (log_save && logger) {
		try {
			fs.closeSync(logger);
		} catch (e) {}
	}
});
process.on("SIGINT", function() {
	running = false;
	console_log("SIGINT");
	if (timeout !== null) {
		clearTimeout(timeout);
		timeout = null;
	}
});
(function() {
	var i, f, t, a = parseArgv(process.argv);
	if (a.e !== undefined) {
		f = function(error, data) {
			if (error !== null) {
				console_error(error);
				return;
			}
			commands_file_cmds = data;
			commands_file_uids = a.i;
			if (a.text !== undefined) {
				commands_file_func = getUidsLiteral;
			} else if (commands_file_uids !== undefined && commands_file_uids.length > 0 && path.extname(commands_file_uids) === ".json") {
				commands_file_func = a.ids !== undefined ? getIdsJson : getUidsJson;
			} else {
				commands_file_func = a.ids !== undefined ? getIdsSync : getUidsSync;
			}
			var cmds = getCmds(commands_file_cmds);
			if (a.d !== undefined) {
				try {
					ids_save_to_file(cmds, root_directory + path.sep + output_file_name(a, "cmds", false));
				} catch (e) {
					console_error(e);
				}
				return;
			}
			execCmds(cmds,
			a.r !== undefined && !isNaN(i = parseInt(a.r, 10)) && i > -1 ? i * 1000 : -1,
			a.p !== undefined && !isNaN(i = parseInt(a.p, 10)) && i > 1 ? i : 1,
			a.o !== undefined,
			a.s !== undefined,
			a.u !== undefined);
		};
		if (a.e.length === 0) {
			readStdIn(f);
		} else if (a.f !== undefined) {
			f(null, a.e);
		} else {
			commands_file = file_path_absolute(a.e, root_directory);
			fs.readFile(commands_file, "utf8", f);
		}
		return;
	} else if (a.t === undefined) {
		console_log(help);
		return;
	}
	if (a.f !== undefined) directory = file_path_absolute(a.f, root_directory);
//	try {
//		process.chdir(directory);
//	} catch (e) {}
	t = ({
		"ui": 0,
		"mi": 1,
		"hi": 2,
		"vi": 3,
		"uv": 4,
		"mv": 5,
		"hv": 6,
		"v": 7,
		"us": 8,
		"s": 9,
		"c": 10,
		"cv": 11,
		"ul": 12,
		"fyp": 13,
		"vc": 14,
		"cm": 15,
		"vcr": 16,
		"followed": 17,
		"uvw": 18,
		"uvwp": 19,
		"bv": 20,
		"pv": 21,
		"up": 22,
		"li": 23,
		"lives_inbox": 24,
		"lives_following": 25,
		"n": 26,
		"nd": 27,
		"un": 28,
		"mvw": 29,
		"hvw": 30
	})[a.t.toLowerCase()];
	switch (t) {
		default: break;
		case 0:
		case 4:
		case 12:
		case 19:
		case 22:
			if (a.si) break;
		case 1:
		case 3:
		case 5:
		case 6:
		case 8:
		case 11:
		case 23:
		case 28:
		case 29:
		case 30:
			if (a.i && idRegex.test(a.i)) break;
		console_error(new Error("ID is not valid."));
		return;
	}
	if ([18,21].includes(t) && !a.si) {
		console_log(help);
		return;
	}
	if ([21].includes(t) && (!a.i || !idRegex.test(a.i))) {
		console_log(help);
		return;
	}
	if (a.cookie !== undefined) cookie = cookie_format(a.cookie);
	if (a.j !== undefined) cookie = a.j;
	if (a.u !== undefined) user_agent = a.u;
	if (a.ur !== undefined) user_agents_random = true;
	if (!isNaN(i = BoundInt(a.o))) cursor = i;
	if (a.l !== undefined) {
		if ([4,18].includes(t) && a.l === "last_scrape") {
			last_scrape_save = true;
		} else if ([4,18].includes(t) && a.l.length === 10 && !isNaN(i = Math.floor((new Date(a.l + "T00:00:00.000Z")).getTime() / 1000))) {
			limit = i;
			date_limit = true;
		} else if (!isNaN(i = BoundInt(a.l))) {
			limit = i;
			date_limit = false;
		}
	}
	if (a.q !== undefined) {
		tag_wm = true;
		tag_sd = false;
		download_wm = false;
		download_sd = true;
		download_hd = false;
		fallback_sd = false; // defaults
		quality = true; // deprecated for videos, still used in some other places
		tag_sd = true;
		if (!isNaN(i = BoundInt(a.q, -1))) {
			if (i === -1) {
				tag_wm = false;
				download_wm = true;
				download_sd = false;
			} else if (i === 0) {
				quality = false;
			} else if (i === 1) {
				download_hd = true;
			} else if (i === 2 || i === -2) {
				verify_files = true;
				download_sd = false;
				download_hd = true;
				fallback_sd = true;
				tag_sd = i === 2;
			} else if (i === 3) {
				download_wm = true;
				download_sd = false;
			} else if (i === 4) {
				download_wm = true;
				download_hd = true;
			}
		} else {
			download_sd = false;
			download_hd = true;
		}
	}
	Object.keys(aweme_app)
	.filter(v => a[v] !== undefined && a[v].length > 0)
	.forEach(v => aweme_app[v] = a[v]);
	if (!isNaN(i = BoundInt(a.d))) description_limit = i;
	if (!isNaN(i = BoundInt(a.w, 1, 100))) count = i;
	if (!isNaN(i = BoundInt(a.n))) ignore_errors_limit = i;
	if (!isNaN(i = BoundInt(a.error_delay))) ignore_errors_delay = i;
	if (!isNaN(i = BoundInt(a.max_depth))) max_depth = i;
	if (!isNaN(i = BoundInt(a.max_resumes, 1, 100))) max_resumes = i;
	if (!isNaN(i = BoundInt(a.max_retries, 1, 100))) max_retries = i;
	if (!isNaN(i = BoundInt(a.max_converts, 1, 100))) max_converts = i;
	if (!isNaN(i = BoundInt(a.max_downloads, 1, 100))) max_downloads = i;
	if (!isNaN(i = BoundInt(a.max_zips, 1, 100))) max_zips = i;
	if (!isNaN(i = BoundInt(a.min_views))) skip_min_views = i;
	if (!isNaN(i = BoundInt(a.max_views))) skip_max_views = i;
	if (a.aweme_host !== undefined && a.aweme_host.length > 0) {
		aweme_host = a.aweme_host;
		var api_pos = aweme_hosts.indexOf(aweme_host);
		if (api_pos > 0) aweme_hosts.splice(api_pos, 1);
		if (api_pos !== 0) aweme_hosts.unshift(aweme_host);
	} else if ([0,4,13,17].includes(t)) {
		aweme_host = aweme_host_core;
	} else if (t === 23) {
		aweme_host = aweme_host_stream;
		cycle_hosts = false;
	} else {
		aweme_host = aweme_host_normal;
	}
	if (a.c !== undefined) date = true;
	if (a.d !== undefined) description = true;
	if (a.h !== undefined) hevc = true;

	if (a.last_scrape !== undefined) last_scrape_save = true;
	if (a.backup_cookie !== undefined) backup_cookie = cookie_format(a.backup_cookie);
	if (a.private_cookie !== undefined) private_cookie = true;
	if (a.account_status !== undefined || private_cookie) account_status_save = true;
	if (![4,18].includes(t)) {
		last_scrape_save = false;
		account_status_save = false;
		private_cookie = false;
	}

	if (a.log_errors !== undefined) log_errors = true;
	if (a.log_verbose !== undefined) log_verbose = true;
	if (a.log_data !== undefined) log_data = true;
	if (log_errors || log_verbose || log_data || a.g !== undefined) log_save = true;
	if (a.x !== undefined) cursor_print = true;
	if (a.x !== undefined && a.x.length > 0) cursor_times = true;
	if (a.y !== undefined) break_limit = true;
	if (a.n !== undefined) ignore_errors = true;
	if (a.z !== undefined) uid_directories = true;
	if (a.cycle_hosts !== undefined) cycle_hosts = true;
	if (a.debug !== undefined) debug = true;
	if (a.debug_data !== undefined) debug_data = true;
	if (a.alert_proc !== undefined) alert_on_download = true;
	if (a.ui !== undefined) tag_uid = true;
	if (a.un !== undefined) tag_unique_id = true;
	if (a.tag_mutual !== undefined) tag_mutual = true;
	if (a.tag_stories !== undefined) tag_stories = true;
	if (a.strip_spaces !== undefined) strip_spaces = true;
	if (a.windows_paths !== undefined) windows_paths = true;

	if (a.progress_bars !== undefined) progress_bars = true;
	if (a.progress_bars !== undefined && a.progress_bars.length > 0) progress_bars_debug = true;
	if (!progress_bars_stream.isTTY) progress_bars = false;

	if (a.tikwm !== undefined) download_videos_tikwm = true;
	if (a.aweme_details_single !== undefined) download_videos_single = true;

	if (a.zip_photos !== undefined) zip_photos = true;
	if (a.flat_photos !== undefined) flat_photos = true;
	if (flat_photos) zip_photos = false;

	if (a.item_buckets !== undefined) item_buckets = true;
	if (a.metadata_buckets !== undefined) metadata_buckets = true;

	if (a.p !== undefined) download_videos = false;
	if (a.a !== undefined) download_thumbs = true;
	if (a.b !== undefined) download_thumbs_anim = true;
	if (a.mp3 !== undefined) download_audios = true;

	if (a.lives !== undefined) lives_save = true;
	if (a.lives_include !== undefined) lives_include = true;

	if (a.v !== undefined) metadata_verbose = true;
	if (a.s !== undefined) metadata_split = true;
	if (a.k !== undefined) metadata_print = true;

	if (a.m !== undefined) metadata_save = true;
	if ([0,1,2,3,14,15,16,22,23,24,25].includes(t)) metadata_save = true;

	if (a.mo !== undefined) metadata_save_obj = true;
	if (a.mu !== undefined) metadata_update_obj = true;

	if (a.metadata_each !== undefined) metadata_save_each = true;
	if (a.metadata_each !== undefined && a.metadata_each.length > 0) metadata_update_each = true;

	if (a.metadata_dirs !== undefined) metadata_dirs = true;
	if (a.metadata_dirs !== undefined && a.metadata_dirs.length > 0) metadata_dir_name = a.metadata_dirs;

	if (a.story_dirs !== undefined) story_dirs = true;
	if (a.story_dirs !== undefined && a.story_dirs.length > 0) story_dir_name = a.story_dirs;

	if (a.fetched_ids !== undefined) fetched_ids_save = true;
	if (a.scraped_ids !== undefined) scraped_ids_save = true;
	if (a.unscraped_ids !== undefined) unscraped_ids_save = true;
	if (a.ignore_ids !== undefined) ignore_ids_save = true;

	if (a.fetch_only !== undefined) fetch_only = true;
	if (fetch_only) {
		download_videos = false;
		download_audios = false;
		download_thumbs = false;
		download_thumbs_anim = false;

		metadata_save = false;
		metadata_save_obj = false;
		metadata_update_obj = false;
		metadata_save_each = false;

		scraped_ids_save = false;
		unscraped_ids_save = false;
		ignore_ids_save = false;

		download_files = false;
	} else if ((download_files = download_videos || download_audios || download_thumbs || download_thumbs_anim || metadata_save_each)) {
		if (metadata_save_each) download_exts.push("json");
		if (download_videos && download_wm) download_exts.push("mp4_wm");
		if (download_videos && download_sd) download_exts.push("mp4_sd");
		if (download_videos && download_hd) download_exts.push("mp4");
		if (download_audios) download_exts.push("mp3");
		if (download_thumbs) download_exts.push("jpg");
		if (download_thumbs_anim) download_exts.push("webp");
	}
	metadata_files = lives_save || metadata_print || metadata_save || metadata_save_obj || metadata_save_each;

	if (a.save_empty !== undefined) save_empty = true;
	if (a.skip_empty !== undefined) save_empty = false;

	if (a.skip_live !== undefined) skip_live = true;
	if (a.only_live !== undefined) only_live = true;

	if (a.skip_photos !== undefined) skip_photos = true;
	if (a.only_photos !== undefined) only_photos = true;

	if (a.skip_stories !== undefined) skip_stories = true;
	if (a.only_stories !== undefined) only_stories = true;
	if ([8,9].includes(t)) skip_stories = false;

	if (a.skip_followed !== undefined) skip_followed = true;
	if (a.only_followed !== undefined) only_followed = true;

	if (a.verify_files !== undefined) verify_files = true;
	if (a.rename_hevc !== undefined) rename_hevc = true;
	if (a.convert_hevc !== undefined) convert_hevc = true;
	require_ffprobe = (verify_files || rename_hevc || convert_hevc) && download_exts.some(v => ffprobe_exts.has(v));
	verify_files = verify_files || require_ffprobe;

	if (![0,1,2,4,5,6,23].includes(t)) request_aweme_cache = false;
	if (a.skip_aweme_cache !== undefined) request_aweme_cache = false;
	if (a.cache !== undefined || a.request_aweme_cache !== undefined) request_aweme_cache = true;
	if (a.cache_cursors !== undefined || a.request_aweme_cache_cursors !== undefined) request_aweme_cache_cursors = true;

	if (a.static_uri !== undefined) request_aweme_static = true;
	if (progress_bars) {
		multi_progress = new (require("multi-progress"))(progress_bars_stream);
		(require("cli-cursor")).hide();
	}
	if (zip_photos) {
		archiver = require("archiver");
	}

	if (a.iid !== undefined || a.request_aweme_iid !== undefined) request_aweme_iid = true;
	if ([5].includes(t)) request_aweme_iid = true;

	if (a.sign !== undefined || a.request_aweme_sign !== undefined) request_aweme_sign = true;
//	if ([0,1,2,4,5,6,23].includes(t)) request_aweme_sign = true;

//	debug = true;
//	request_aweme_sign = true;
	if (request_aweme_sign) {
		request_aweme_cache = false;
		request_aweme_static = false;
		request_aweme_sign_func = (require("./aweme")).gorgonSign;

//		cycle_hosts = false;
//		if ([0,4,13,17].includes(t)) {
//			aweme_host = "api16-core-useast5.us.tiktokv.com";
//		} else {
//			aweme_host = "api16-normal-useast5.us.tiktokv.com";
//		}

		aweme_app.version_name = "19.3.3";
		aweme_app.version_code = "190303";
		aweme_app.manifest_version_code = "2021903030";

	}

	if (request_aweme_static) {
		var request_aweme_static_file = request_aweme_static_dir + path.sep + (a.si || a.i) + ".json";
		try {
			request_aweme_static = JSON.parse(fs.readFileSync(file_path_absolute(request_aweme_static_file, root_directory), "utf8"));
			max_depth = 1;
		} catch (e) {
			request_aweme_static = false;
			console_error(e);
			return;
		}
	}
	if (alert_on_download) {
		if (a.alert_proc !== undefined) alert_proc = a.alert_proc;
		if (a.alert_args !== undefined) alert_args = a.alert_args;
		alert_on_download = alert_proc.length > 0;
	}
	if (log_save && a.g !== undefined && a.g.length > 0) log_file = a.g;
	if (lives_save) lives_file = a.lives !== undefined && a.lives.length > 0 ? a.lives : output_file_name(a, "lives");
	if (metadata_save) metadata_file = a.m !== undefined && a.m.length > 0 ? a.m : output_file_name(a);
	if (fetched_ids_save) fetched_ids_file = a.fetched_ids !== undefined && a.fetched_ids.length > 0 ? a.fetched_ids : output_file_name(a, "fetched");
	if (scraped_ids_save) scraped_ids_file = a.scraped_ids !== undefined && a.scraped_ids.length > 0 ? a.scraped_ids : output_file_name(a, "scraped");
	if (unscraped_ids_save) unscraped_ids_file = a.unscraped_ids !== undefined && a.unscraped_ids.length > 0 ? a.unscraped_ids : output_file_name(a, "unscraped");
	if (ignore_ids_save) {
		if (a.ignore_ids !== undefined && a.ignore_ids.length > 0) {
			ignore_ids_file = a.ignore_ids;
		} else if ([4,5,6,8,18].includes(t)) {
			ignore_ids_file = ignore_ids_dir + path.sep + {4:"@",5:"~",6:"#",8:"$",18:"@"}[t] + (a.si || a.i) + ".json";
		} else {
			ignore_ids_save = typeof ignore_ids_file === "string" && ignore_ids_file.length > 0;
		}
		if (ignore_ids_save) {
			try {
				ignore_ids = new Set(JSON.parse(fs.readFileSync(file_path_absolute(ignore_ids_file), "utf8")));
			} catch (e) {
				ignore_ids = new Set();
			}
			ignore_ids_initial = ignore_ids.size;
			ignore_exts = new Set(download_exts);
			if (zip_photos) ignore_exts.add("zip");
			if (fallback_sd) ignore_exts.add("mp4_sd");
			if (metadata_save_each) ignore_exts.add("json");
		}
	}
	if (metadata_save_obj) {
		if (a.mo !== undefined && a.mo.length > 0) {
			metadata_obj_file = a.mo;
		} else if ([4,5,6,8,18].includes(t)) {
			metadata_obj_file = {4:"@",5:"~",6:"#",8:"$",18:"@"}[t] + (a.si || a.i) + ".json";
		} else {
			metadata_save_obj = typeof metadata_obj_file === "string" && metadata_obj_file.length > 0;
		}
		if (metadata_save_obj) {
			try {
				var metadata_str = fs.readFileSync(file_path_absolute(metadata_obj_file), "utf8");
				metadata_obj = JSON.parse(metadata_str);
				metadata_obj_initial = hash_string(metadata_str);
			} catch (e) {
				metadata_obj = {};
			}
		}
	}
	if (skip_uids || a.skip_uids !== undefined) {
		if (a.skip_uids !== undefined && a.skip_uids.length > 0) skip_uids_file = a.skip_uids;
		try {
			skip_uids = new Set(getUidsSync(fs.readFileSync(file_path_absolute(skip_uids_file, root_directory), "utf8")));
		} catch (e) {
			skip_uids = false;
			console_error(e);
		}
	}
	if (only_uids || a.only_uids !== undefined) {
		if (a.only_uids !== undefined && a.only_uids.length > 0) only_uids_file = a.only_uids;
		try {
			only_uids = new Set(getUidsSync(fs.readFileSync(file_path_absolute(only_uids_file, root_directory), "utf8")));
		} catch (e) {
			only_uids = false;
			console_error(e);
		}
	}
	if (last_scrape_save) {
		last_scrape_file = a.last_scrape !== undefined && a.last_scrape.length > 0 ? a.last_scrape : last_scrapes_dir + path.sep + "@" + (a.si || a.i) + ".txt";
		if (a.l === "last_scrape") {
			try {
				if (isNaN(previous_scrape = +fs.readFileSync(file_path_absolute(last_scrape_file), "utf8"))) throw "Invalid file contents";
				limit = previous_scrape;
				date_limit = true;
			} catch (e) {
				previous_scrape = 0;
				limit = 1;
				date_limit = false;
				break_limit = true;
			}
		}
	}
	if (account_status_save) {
		account_status_file = file_path_absolute(account_status_dir + path.sep + (a.si || a.i) + ".txt", root_directory);
		try {
			account_status = +fs.readFileSync(account_status_file, "utf8");
		} catch (e) {
			account_status = 0;
		}
		if (account_status > 0) {
			private_cookie = false;
			private_cookie_used = true;
		} else {
			private_cookie = private_cookie ? cookie : "";
			cookie = backup_cookie ? backup_cookie : "";
			private_cookie_used = false;
		}
		previous_account_status = account_status;
	}
	if (require_ffprobe) {
		ffprobe = require("ffprobe");
		if (ffprobe_path === undefined || (convert_hevc && ffmpeg_path === undefined)) {
			ffmpeg = require("ffmpeg-ffprobe-static");
			if (ffprobe_path === undefined) ffprobe_path = ffmpeg.ffprobePath;
			if (ffmpeg_path === undefined) ffmpeg_path = ffmpeg.ffmpegPath;
		}
	}

	count = Math.min(count, (() => {
		switch (t) {
			case 4: return 33; // user profile
			case 5: return 18; // audio
			case 6: return 20; // tag

			case 8:
			case 9: return 5; // stories

			case 10:
			case 11: return 20; // collections

			case 12:
			case 14:
			case 16: return 50; // user likes, video comments

			case 17: return 4; // following page

			case 18:
			case 29:
			case 30: return 35; // web api

			case 20: return 30; // bookmarked videos

			default: return 100;
		}
	})());

	switch (t) {
		case 0:
			dumpInfoUser(a.i, a.si);
			return;
		case 1:
			dumpInfoMusic(a.i);
			return;
		case 2:
			dumpInfoHashtag(a.i);
			return;
		case 3:
			dumpInfoVideo(a.i);
			return;
		case 4:
//			scrapeFeed(1, a.i);
			downloadUserVideosAweme(a.i, a.si);
			return;
		case 5:
//			scrapeFeed(4, a.i);
			downloadMusicVideosAweme(a.i);
			return;
		case 6:
//			scrapeFeed(3, a.i);
			downloadHashtagVideosAweme(a.i);
			return;
		case 7:
			var download_videos_func = download_videos_single ? downloadVideos : downloadVideosMulti;
			if (idRegex.test(a.i)) {
				download_videos_func([a.i]);
				return;
			}
			f = function(error, data) {
				if (error !== null) {
					console_error(error);
					return;
				}
				getIds(data, function(error, ids) {
					if (error !== null) {
						console_error(error);
					} else if (ids.length > 0) {
						download_videos_func(ids);
					}
				});
			};
			if (a.i.length === 0) {
				readStdIn(f);
			} else if (a.i === "clipboard") {
				try {
					f(null, (require("clipboardy")).readSync());
				} catch (e) {
					console_error(e);
					return;
				}
			} else {
				fs.readFile(file_path_absolute(a.i, root_directory), "utf8", f);
			}
			return;
		case 8:
			downloadUserStories(a.i);
			return;
		case 9:
			scrapeStories();
			return;
		case 10:
			scrapeCollections();
			return;
		case 11:
			downloadCollection(a.i);
			return;
		case 12:
//			scrapeFeed(2, a.i);
			downloadUserLikesAweme(a.i, a.si);
			return;
		case 13:
//			scrapeFeed(5, "");
			downloadTrendingAweme();
			return;
		case 14:
			i = get_cid(a.i);
			if (i === null) console_error(new Error("ID is not valid."));
			else dumpVideoComments(i);
			return;
		case 15:
			dumpCollectionsMetadata();
			return;
		case 16:
			i = get_cid(a.i);
			if (i === null) console_error(new Error("ID is not valid."));
			else dumpVideoCommentReplies(i);
			return;
		case 17:
			downloadFollowedAweme();
			return;
		case 18:
			downloadUserVideosWeb(a.si);
			return;
		case 19:
			downloadUserVideosWebPage(a.si || a.i);
			return;
		case 20:
			downloadBookmarkedVideos();
			return;
		case 21:
			downloadPlaylistVideos(a.i, a.si);
			return;
		case 22:
			dumpPlaylists(a.i, a.si);
			return;
		case 23:
			dumpLiveInfo(a.i);
			return;
		case 24:
			dumpLivesInbox();
			return;
		case 25:
			dumpLivesFollowing();
			return;
		case 26:
		case 27:
			downloadNow(t === 26);
			return;
		case 28:
			downloadUserNow(a.i);
			return;
		case 29:
			downloadMusicVideosWeb(a.i);
			return;
		case 30:
			downloadHashtagVideosWeb(a.i);
			return;
	}
	console_log(help);
})();
function BoundInt(n, min=0, max=undefined) {
	var i = parseInt(n, 10);
	if (!isNaN(i) && typeof min === "number" && i < min) return min;
	if (!isNaN(i) && typeof max === "number" && i > max) return max;
	return i;
}
function get_cid(cid) {
	if (cid.length === 0) return null;
	if (idRegex.test(cid)) return cid;
	if (cid.includes("?cid=")) {
		try {
			cid = (new URL(cid, "https://www.tiktok.com")).searchParams.get("cid");
		} catch (e) {}
	}
	try {
		cid = Buffer.from(cid, "base64").toString();
	} catch (e) {}
	if (idRegex.test(cid)) return cid;
	return null;
}
function cookie_format(cookie) {
	return ["sid_tt", "sessionid", "sessionid_ss"].map(v => v + "=" + cookie).join("; ");
}